/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of Phidget22.jar
 *
 * Copyright (c) 2017-2022 Phidgets Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

package com.phidget22;
import java.util.*;

public class BLDCMotorBase extends Phidget {

	BLDCMotorBase(long handle) {
		super(handle);
	}

	public BLDCMotorBase() throws PhidgetException {
		super(create());
	}

	private native static long create() throws PhidgetException;

	private final void setDeviceEvents(boolean enable) {
		enableBrakingStrengthChangeEvents(enable && brakingStrengthChangeListeners.size() > 0);
		enablePositionChangeEvents(enable && positionChangeListeners.size() > 0);
		enableVelocityUpdateEvents(enable && velocityUpdateListeners.size() > 0);
	}

	public final void addBrakingStrengthChangeListener(BLDCMotorBrakingStrengthChangeListener l) {
		synchronized(brakingStrengthChangeListeners) {
			brakingStrengthChangeListeners.add(l);
			enableBrakingStrengthChangeEvents(true);
		}
	}
	private List<BLDCMotorBrakingStrengthChangeListener> brakingStrengthChangeListeners = new ArrayList<BLDCMotorBrakingStrengthChangeListener>();
	private long nativeBrakingStrengthChangeHandler = 0;
	public final void removeBrakingStrengthChangeListener(BLDCMotorBrakingStrengthChangeListener l) {
		synchronized(brakingStrengthChangeListeners) {
			brakingStrengthChangeListeners.remove(l);
			enableBrakingStrengthChangeEvents(brakingStrengthChangeListeners.size() > 0);
		}
	}
	private void fireBrakingStrengthChange(BLDCMotorBrakingStrengthChangeEvent e) {
		synchronized(brakingStrengthChangeListeners) {
			for (Iterator it = brakingStrengthChangeListeners.iterator (); it.hasNext();)
			((BLDCMotorBrakingStrengthChangeListener) it.next ()).onBrakingStrengthChange (e);
		}
	}
	private native void enableBrakingStrengthChangeEvents(boolean b);

	public final void addPositionChangeListener(BLDCMotorPositionChangeListener l) {
		synchronized(positionChangeListeners) {
			positionChangeListeners.add(l);
			enablePositionChangeEvents(true);
		}
	}
	private List<BLDCMotorPositionChangeListener> positionChangeListeners = new ArrayList<BLDCMotorPositionChangeListener>();
	private long nativePositionChangeHandler = 0;
	public final void removePositionChangeListener(BLDCMotorPositionChangeListener l) {
		synchronized(positionChangeListeners) {
			positionChangeListeners.remove(l);
			enablePositionChangeEvents(positionChangeListeners.size() > 0);
		}
	}
	private void firePositionChange(BLDCMotorPositionChangeEvent e) {
		synchronized(positionChangeListeners) {
			for (Iterator it = positionChangeListeners.iterator (); it.hasNext();)
			((BLDCMotorPositionChangeListener) it.next ()).onPositionChange (e);
		}
	}
	private native void enablePositionChangeEvents(boolean b);

	public final void addVelocityUpdateListener(BLDCMotorVelocityUpdateListener l) {
		synchronized(velocityUpdateListeners) {
			velocityUpdateListeners.add(l);
			enableVelocityUpdateEvents(true);
		}
	}
	private List<BLDCMotorVelocityUpdateListener> velocityUpdateListeners = new ArrayList<BLDCMotorVelocityUpdateListener>();
	private long nativeVelocityUpdateHandler = 0;
	public final void removeVelocityUpdateListener(BLDCMotorVelocityUpdateListener l) {
		synchronized(velocityUpdateListeners) {
			velocityUpdateListeners.remove(l);
			enableVelocityUpdateEvents(velocityUpdateListeners.size() > 0);
		}
	}
	private void fireVelocityUpdate(BLDCMotorVelocityUpdateEvent e) {
		synchronized(velocityUpdateListeners) {
			for (Iterator it = velocityUpdateListeners.iterator (); it.hasNext();)
			((BLDCMotorVelocityUpdateListener) it.next ()).onVelocityUpdate (e);
		}
	}
	private native void enableVelocityUpdateEvents(boolean b);


	public native double getAcceleration() throws PhidgetException;
	public native void setAcceleration(double Acceleration) throws PhidgetException;
	public native double getMinAcceleration() throws PhidgetException;
	public native double getMaxAcceleration() throws PhidgetException;
	public native double getBrakingStrength() throws PhidgetException;
	public native double getMinBrakingStrength() throws PhidgetException;
	public native double getMaxBrakingStrength() throws PhidgetException;
	public native double getCurrentLimit() throws PhidgetException;
	public native void setCurrentLimit(double CurrentLimit) throws PhidgetException;
	public native double getMinCurrentLimit() throws PhidgetException;
	public native double getMaxCurrentLimit() throws PhidgetException;
	public native int getDataInterval() throws PhidgetException;
	public native void setDataInterval(int DataInterval) throws PhidgetException;
	public native int getMinDataInterval() throws PhidgetException;
	public native int getMaxDataInterval() throws PhidgetException;
	public native double getDataRate() throws PhidgetException;
	public native void setDataRate(double DataRate) throws PhidgetException;
	public native double getMinDataRate() throws PhidgetException;
	public native double getMaxDataRate() throws PhidgetException;
	public native void enableFailsafe(int failsafeTime) throws PhidgetException;
	public native int getMinFailsafeTime() throws PhidgetException;
	public native int getMaxFailsafeTime() throws PhidgetException;
	public native double getPosition() throws PhidgetException;
	public native double getMinPosition() throws PhidgetException;
	public native double getMaxPosition() throws PhidgetException;
	public native void addPositionOffset(double positionOffset) throws PhidgetException;
	public native double getRescaleFactor() throws PhidgetException;
	public native void setRescaleFactor(double RescaleFactor) throws PhidgetException;
	public native void resetFailsafe() throws PhidgetException;
	public native double getStallVelocity() throws PhidgetException;
	public native void setStallVelocity(double StallVelocity) throws PhidgetException;
	public native double getMinStallVelocity() throws PhidgetException;
	public native double getMaxStallVelocity() throws PhidgetException;
	public native double getTargetBrakingStrength() throws PhidgetException;
	public native void setTargetBrakingStrength(double TargetBrakingStrength) throws PhidgetException;
	public native double getTargetVelocity() throws PhidgetException;
	public native void setTargetVelocity(double TargetVelocity, AsyncListener asyncHandler);
	public native void setTargetVelocity(double TargetVelocity) throws PhidgetException;
	public native double getVelocity() throws PhidgetException;
	public native double getMinVelocity() throws PhidgetException;
	public native double getMaxVelocity() throws PhidgetException;
}
