/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of Phidget22.jar
 *
 * Copyright (c) 2017-2022 Phidgets Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

package com.phidget22;
import java.util.*;

public class CapacitiveTouchBase extends Phidget {

	CapacitiveTouchBase(long handle) {
		super(handle);
	}

	public CapacitiveTouchBase() throws PhidgetException {
		super(create());
	}

	private native static long create() throws PhidgetException;

	private final void setDeviceEvents(boolean enable) {
		enableTouchEvents(enable && touchListeners.size() > 0);
		enableTouchEndEvents(enable && touchEndListeners.size() > 0);
	}

	public final void addTouchListener(CapacitiveTouchTouchListener l) {
		synchronized(touchListeners) {
			touchListeners.add(l);
			enableTouchEvents(true);
		}
	}
	private List<CapacitiveTouchTouchListener> touchListeners = new ArrayList<CapacitiveTouchTouchListener>();
	private long nativeTouchHandler = 0;
	public final void removeTouchListener(CapacitiveTouchTouchListener l) {
		synchronized(touchListeners) {
			touchListeners.remove(l);
			enableTouchEvents(touchListeners.size() > 0);
		}
	}
	private void fireTouch(CapacitiveTouchTouchEvent e) {
		synchronized(touchListeners) {
			for (Iterator it = touchListeners.iterator (); it.hasNext();)
			((CapacitiveTouchTouchListener) it.next ()).onTouch (e);
		}
	}
	private native void enableTouchEvents(boolean b);

	public final void addTouchEndListener(CapacitiveTouchTouchEndListener l) {
		synchronized(touchEndListeners) {
			touchEndListeners.add(l);
			enableTouchEndEvents(true);
		}
	}
	private List<CapacitiveTouchTouchEndListener> touchEndListeners = new ArrayList<CapacitiveTouchTouchEndListener>();
	private long nativeTouchEndHandler = 0;
	public final void removeTouchEndListener(CapacitiveTouchTouchEndListener l) {
		synchronized(touchEndListeners) {
			touchEndListeners.remove(l);
			enableTouchEndEvents(touchEndListeners.size() > 0);
		}
	}
	private void fireTouchEnd(CapacitiveTouchTouchEndEvent e) {
		synchronized(touchEndListeners) {
			for (Iterator it = touchEndListeners.iterator (); it.hasNext();)
			((CapacitiveTouchTouchEndListener) it.next ()).onTouchEnd (e);
		}
	}
	private native void enableTouchEndEvents(boolean b);


	public native int getDataInterval() throws PhidgetException;
	public native void setDataInterval(int DataInterval) throws PhidgetException;
	public native int getMinDataInterval() throws PhidgetException;
	public native int getMaxDataInterval() throws PhidgetException;
	public native double getDataRate() throws PhidgetException;
	public native void setDataRate(double DataRate) throws PhidgetException;
	public native double getMinDataRate() throws PhidgetException;
	public native double getMaxDataRate() throws PhidgetException;
	public native boolean getIsTouched() throws PhidgetException;
	public native double getSensitivity() throws PhidgetException;
	public native void setSensitivity(double Sensitivity) throws PhidgetException;
	public native double getMinSensitivity() throws PhidgetException;
	public native double getMaxSensitivity() throws PhidgetException;
	public native double getTouchValue() throws PhidgetException;
	public native double getMinTouchValue() throws PhidgetException;
	public native double getMaxTouchValue() throws PhidgetException;
	public native double getTouchValueChangeTrigger() throws PhidgetException;
	public native void setTouchValueChangeTrigger(double TouchValueChangeTrigger) throws PhidgetException;
	public native double getMinTouchValueChangeTrigger() throws PhidgetException;
	public native double getMaxTouchValueChangeTrigger() throws PhidgetException;
}
