/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of Phidget22.jar
 *
 * Copyright (c) 2017-2022 Phidgets Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

package com.phidget22;
import java.util.*;

public class DictionaryBase extends Phidget {

	DictionaryBase(long handle) {
		super(handle);
	}

	public DictionaryBase() throws PhidgetException {
		super(create());
	}

	private native static long create() throws PhidgetException;

	private final void setDeviceEvents(boolean enable) {
		enableAddEvents(enable && addListeners.size() > 0);
		enableRemoveEvents(enable && removeListeners.size() > 0);
		enableUpdateEvents(enable && updateListeners.size() > 0);
	}

	public final void addAddListener(DictionaryAddListener l) {
		synchronized(addListeners) {
			addListeners.add(l);
			enableAddEvents(true);
		}
	}
	private List<DictionaryAddListener> addListeners = new ArrayList<DictionaryAddListener>();
	private long nativeAddHandler = 0;
	public final void removeAddListener(DictionaryAddListener l) {
		synchronized(addListeners) {
			addListeners.remove(l);
			enableAddEvents(addListeners.size() > 0);
		}
	}
	private void fireAdd(DictionaryAddEvent e) {
		synchronized(addListeners) {
			for (Iterator it = addListeners.iterator (); it.hasNext();)
			((DictionaryAddListener) it.next ()).onAdd (e);
		}
	}
	private native void enableAddEvents(boolean b);

	public final void addRemoveListener(DictionaryRemoveListener l) {
		synchronized(removeListeners) {
			removeListeners.add(l);
			enableRemoveEvents(true);
		}
	}
	private List<DictionaryRemoveListener> removeListeners = new ArrayList<DictionaryRemoveListener>();
	private long nativeRemoveHandler = 0;
	public final void removeRemoveListener(DictionaryRemoveListener l) {
		synchronized(removeListeners) {
			removeListeners.remove(l);
			enableRemoveEvents(removeListeners.size() > 0);
		}
	}
	private void fireRemove(DictionaryRemoveEvent e) {
		synchronized(removeListeners) {
			for (Iterator it = removeListeners.iterator (); it.hasNext();)
			((DictionaryRemoveListener) it.next ()).onRemove (e);
		}
	}
	private native void enableRemoveEvents(boolean b);

	public final void addUpdateListener(DictionaryUpdateListener l) {
		synchronized(updateListeners) {
			updateListeners.add(l);
			enableUpdateEvents(true);
		}
	}
	private List<DictionaryUpdateListener> updateListeners = new ArrayList<DictionaryUpdateListener>();
	private long nativeUpdateHandler = 0;
	public final void removeUpdateListener(DictionaryUpdateListener l) {
		synchronized(updateListeners) {
			updateListeners.remove(l);
			enableUpdateEvents(updateListeners.size() > 0);
		}
	}
	private void fireUpdate(DictionaryUpdateEvent e) {
		synchronized(updateListeners) {
			for (Iterator it = updateListeners.iterator (); it.hasNext();)
			((DictionaryUpdateListener) it.next ()).onUpdate (e);
		}
	}
	private native void enableUpdateEvents(boolean b);


	public native void add(java.lang.String key, java.lang.String value) throws PhidgetException;
	public native void removeAll() throws PhidgetException;
	public native java.lang.String get(java.lang.String key) throws PhidgetException;
	public native void remove(java.lang.String key) throws PhidgetException;
	public native void set(java.lang.String key, java.lang.String value) throws PhidgetException;
	public native java.lang.String sscan(java.lang.String start) throws PhidgetException;
	public native void update(java.lang.String key, java.lang.String value) throws PhidgetException;
}
