/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of Phidget22.jar
 *
 * Copyright (c) 2017-2022 Phidgets Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

package com.phidget22;
import java.util.*;

public class DigitalInputBase extends Phidget {

	DigitalInputBase(long handle) {
		super(handle);
	}

	public DigitalInputBase() throws PhidgetException {
		super(create());
	}

	private native static long create() throws PhidgetException;

	private final void setDeviceEvents(boolean enable) {
		enableStateChangeEvents(enable && stateChangeListeners.size() > 0);
	}

	public final void addStateChangeListener(DigitalInputStateChangeListener l) {
		synchronized(stateChangeListeners) {
			stateChangeListeners.add(l);
			enableStateChangeEvents(true);
		}
	}
	private List<DigitalInputStateChangeListener> stateChangeListeners = new ArrayList<DigitalInputStateChangeListener>();
	private long nativeStateChangeHandler = 0;
	public final void removeStateChangeListener(DigitalInputStateChangeListener l) {
		synchronized(stateChangeListeners) {
			stateChangeListeners.remove(l);
			enableStateChangeEvents(stateChangeListeners.size() > 0);
		}
	}
	private void fireStateChange(DigitalInputStateChangeEvent e) {
		synchronized(stateChangeListeners) {
			for (Iterator it = stateChangeListeners.iterator (); it.hasNext();)
			((DigitalInputStateChangeListener) it.next ()).onStateChange (e);
		}
	}
	private native void enableStateChangeEvents(boolean b);


	public native InputMode getInputMode() throws PhidgetException;
	public native void setInputMode(InputMode InputMode) throws PhidgetException;
	public native PowerSupply getPowerSupply() throws PhidgetException;
	public native void setPowerSupply(PowerSupply PowerSupply) throws PhidgetException;
	public native boolean getState() throws PhidgetException;
}
