/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of Phidget22.jar
 *
 * Copyright (c) 2017-2022 Phidgets Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

package com.phidget22;
import java.util.*;

public class DistanceSensorBase extends Phidget {

	DistanceSensorBase(long handle) {
		super(handle);
	}

	public DistanceSensorBase() throws PhidgetException {
		super(create());
	}

	private native static long create() throws PhidgetException;

	private final void setDeviceEvents(boolean enable) {
		enableDistanceChangeEvents(enable && distanceChangeListeners.size() > 0);
		enableSonarReflectionsUpdateEvents(enable && sonarReflectionsUpdateListeners.size() > 0);
	}

	public final void addDistanceChangeListener(DistanceSensorDistanceChangeListener l) {
		synchronized(distanceChangeListeners) {
			distanceChangeListeners.add(l);
			enableDistanceChangeEvents(true);
		}
	}
	private List<DistanceSensorDistanceChangeListener> distanceChangeListeners = new ArrayList<DistanceSensorDistanceChangeListener>();
	private long nativeDistanceChangeHandler = 0;
	public final void removeDistanceChangeListener(DistanceSensorDistanceChangeListener l) {
		synchronized(distanceChangeListeners) {
			distanceChangeListeners.remove(l);
			enableDistanceChangeEvents(distanceChangeListeners.size() > 0);
		}
	}
	private void fireDistanceChange(DistanceSensorDistanceChangeEvent e) {
		synchronized(distanceChangeListeners) {
			for (Iterator it = distanceChangeListeners.iterator (); it.hasNext();)
			((DistanceSensorDistanceChangeListener) it.next ()).onDistanceChange (e);
		}
	}
	private native void enableDistanceChangeEvents(boolean b);

	public final void addSonarReflectionsUpdateListener(DistanceSensorSonarReflectionsUpdateListener l) {
		synchronized(sonarReflectionsUpdateListeners) {
			sonarReflectionsUpdateListeners.add(l);
			enableSonarReflectionsUpdateEvents(true);
		}
	}
	private List<DistanceSensorSonarReflectionsUpdateListener> sonarReflectionsUpdateListeners = new ArrayList<DistanceSensorSonarReflectionsUpdateListener>();
	private long nativeSonarReflectionsUpdateHandler = 0;
	public final void removeSonarReflectionsUpdateListener(DistanceSensorSonarReflectionsUpdateListener l) {
		synchronized(sonarReflectionsUpdateListeners) {
			sonarReflectionsUpdateListeners.remove(l);
			enableSonarReflectionsUpdateEvents(sonarReflectionsUpdateListeners.size() > 0);
		}
	}
	private void fireSonarReflectionsUpdate(DistanceSensorSonarReflectionsUpdateEvent e) {
		synchronized(sonarReflectionsUpdateListeners) {
			for (Iterator it = sonarReflectionsUpdateListeners.iterator (); it.hasNext();)
			((DistanceSensorSonarReflectionsUpdateListener) it.next ()).onSonarReflectionsUpdate (e);
		}
	}
	private native void enableSonarReflectionsUpdateEvents(boolean b);


	public native int getDataInterval() throws PhidgetException;
	public native void setDataInterval(int DataInterval) throws PhidgetException;
	public native int getMinDataInterval() throws PhidgetException;
	public native int getMaxDataInterval() throws PhidgetException;
	public native double getDataRate() throws PhidgetException;
	public native void setDataRate(double DataRate) throws PhidgetException;
	public native double getMinDataRate() throws PhidgetException;
	public native double getMaxDataRate() throws PhidgetException;
	public native int getDistance() throws PhidgetException;
	public native int getMinDistance() throws PhidgetException;
	public native int getMaxDistance() throws PhidgetException;
	public native int getDistanceChangeTrigger() throws PhidgetException;
	public native void setDistanceChangeTrigger(int DistanceChangeTrigger) throws PhidgetException;
	public native int getMinDistanceChangeTrigger() throws PhidgetException;
	public native int getMaxDistanceChangeTrigger() throws PhidgetException;
	public native boolean getSonarQuietMode() throws PhidgetException;
	public native void setSonarQuietMode(boolean SonarQuietMode) throws PhidgetException;
	public native DistanceSensorSonarReflections getSonarReflections() throws PhidgetException;
}
