/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of Phidget22.jar
 *
 * Copyright (c) 2017-2022 Phidgets Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

package com.phidget22;

public enum ErrorEventCode {
	BAD_VERSION(1) {
		public String getMessage() {
			return ("Version Mismatch");
		}
	},
	ESTOP(4117) {
		public String getMessage() {
			return ("Emergency Stop Condition");
		}
	},
	NETWORK(3) {
		public String getMessage() {
			return ("Network Error");
		}
	},
	DISPATCH(4) {
		public String getMessage() {
			return ("Dispatch Error");
		}
	},
	FAILURE(5) {
		public String getMessage() {
			return ("General Failure");
		}
	},
	SUCCESS(4096) {
		public String getMessage() {
			return ("Error Cleared");
		}
	},
	OVERRUN(4098) {
		public String getMessage() {
			return ("Sample Overrun");
		}
	},
	PACKET_LOST(4099) {
		public String getMessage() {
			return ("Packet Lost");
		}
	},
	WRAP_AROUND(4100) {
		public String getMessage() {
			return ("Wrap-Around");
		}
	},
	OVER_TEMPERATURE(4101) {
		public String getMessage() {
			return ("Over-Temperature");
		}
	},
	OVER_CURRENT(4102) {
		public String getMessage() {
			return ("Over-Current");
		}
	},
	OUT_OF_RANGE(4103) {
		public String getMessage() {
			return ("Out of Range");
		}
	},
	BUSY(2) {
		public String getMessage() {
			return ("Phidget in Use");
		}
	},
	SATURATION(4105) {
		public String getMessage() {
			return ("Saturation");
		}
	},
	OVER_VOLTAGE(4107) {
		public String getMessage() {
			return ("Over-Voltage");
		}
	},
	FAILSAFE_CONDITION(4108) {
		public String getMessage() {
			return ("Failsafe");
		}
	},
	VOLTAGE_ERROR(4109) {
		public String getMessage() {
			return ("Voltage Error");
		}
	},
	ENERGY_DUMP_CONDITION(4110) {
		public String getMessage() {
			return ("Energy Dump");
		}
	},
	MOTOR_STALL_CONDITION(4111) {
		public String getMessage() {
			return ("Motor Stall");
		}
	},
	INVALID_STATE_CONDITION(4112) {
		public String getMessage() {
			return ("Invalid State");
		}
	},
	BAD_CONNECTION_CONDITION(4113) {
		public String getMessage() {
			return ("Bad Connection");
		}
	},
	OUT_OF_RANGE_HIGH_CONDITION(4114) {
		public String getMessage() {
			return ("Out of Range High");
		}
	},
	OUT_OF_RANGE_LOW_CONDITION(4115) {
		public String getMessage() {
			return ("Out of Range Low");
		}
	},
	FAULT(4116) {
		public String getMessage() {
			return ("Fault Condition");
		}
	},
	BAD_POWER(4104) {
		public String getMessage() {
			return ("Bad Power");
		}
	};

	public static ErrorEventCode getEnum(int code) {
		switch(code) {
		case 1:
			return BAD_VERSION;
		case 4117:
			return ESTOP;
		case 3:
			return NETWORK;
		case 4:
			return DISPATCH;
		case 5:
			return FAILURE;
		case 4096:
			return SUCCESS;
		case 4098:
			return OVERRUN;
		case 4099:
			return PACKET_LOST;
		case 4100:
			return WRAP_AROUND;
		case 4101:
			return OVER_TEMPERATURE;
		case 4102:
			return OVER_CURRENT;
		case 4103:
			return OUT_OF_RANGE;
		case 2:
			return BUSY;
		case 4105:
			return SATURATION;
		case 4107:
			return OVER_VOLTAGE;
		case 4108:
			return FAILSAFE_CONDITION;
		case 4109:
			return VOLTAGE_ERROR;
		case 4110:
			return ENERGY_DUMP_CONDITION;
		case 4111:
			return MOTOR_STALL_CONDITION;
		case 4112:
			return INVALID_STATE_CONDITION;
		case 4113:
			return BAD_CONNECTION_CONDITION;
		case 4114:
			return OUT_OF_RANGE_HIGH_CONDITION;
		case 4115:
			return OUT_OF_RANGE_LOW_CONDITION;
		case 4116:
			return FAULT;
		case 4104:
			return BAD_POWER;
		}
		return null;
	}

	private final int code;
	private ErrorEventCode(int code) {
		this.code = code;
	}

	public int getCode() {
		return (code);
	}

	public abstract String getMessage();
}
