/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of Phidget22.jar
 *
 * Copyright (c) 2017-2022 Phidgets Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

package com.phidget22;
import java.util.*;

public class FrequencyCounterBase extends Phidget {

	FrequencyCounterBase(long handle) {
		super(handle);
	}

	public FrequencyCounterBase() throws PhidgetException {
		super(create());
	}

	private native static long create() throws PhidgetException;

	private final void setDeviceEvents(boolean enable) {
		enableCountChangeEvents(enable && countChangeListeners.size() > 0);
		enableFrequencyChangeEvents(enable && frequencyChangeListeners.size() > 0);
	}

	public final void addCountChangeListener(FrequencyCounterCountChangeListener l) {
		synchronized(countChangeListeners) {
			countChangeListeners.add(l);
			enableCountChangeEvents(true);
		}
	}
	private List<FrequencyCounterCountChangeListener> countChangeListeners = new ArrayList<FrequencyCounterCountChangeListener>();
	private long nativeCountChangeHandler = 0;
	public final void removeCountChangeListener(FrequencyCounterCountChangeListener l) {
		synchronized(countChangeListeners) {
			countChangeListeners.remove(l);
			enableCountChangeEvents(countChangeListeners.size() > 0);
		}
	}
	private void fireCountChange(FrequencyCounterCountChangeEvent e) {
		synchronized(countChangeListeners) {
			for (Iterator it = countChangeListeners.iterator (); it.hasNext();)
			((FrequencyCounterCountChangeListener) it.next ()).onCountChange (e);
		}
	}
	private native void enableCountChangeEvents(boolean b);

	public final void addFrequencyChangeListener(FrequencyCounterFrequencyChangeListener l) {
		synchronized(frequencyChangeListeners) {
			frequencyChangeListeners.add(l);
			enableFrequencyChangeEvents(true);
		}
	}
	private List<FrequencyCounterFrequencyChangeListener> frequencyChangeListeners = new ArrayList<FrequencyCounterFrequencyChangeListener>();
	private long nativeFrequencyChangeHandler = 0;
	public final void removeFrequencyChangeListener(FrequencyCounterFrequencyChangeListener l) {
		synchronized(frequencyChangeListeners) {
			frequencyChangeListeners.remove(l);
			enableFrequencyChangeEvents(frequencyChangeListeners.size() > 0);
		}
	}
	private void fireFrequencyChange(FrequencyCounterFrequencyChangeEvent e) {
		synchronized(frequencyChangeListeners) {
			for (Iterator it = frequencyChangeListeners.iterator (); it.hasNext();)
			((FrequencyCounterFrequencyChangeListener) it.next ()).onFrequencyChange (e);
		}
	}
	private native void enableFrequencyChangeEvents(boolean b);


	public native long getCount() throws PhidgetException;
	public native boolean getEnabled() throws PhidgetException;
	public native void setEnabled(boolean Enabled) throws PhidgetException;
	public native int getDataInterval() throws PhidgetException;
	public native void setDataInterval(int DataInterval) throws PhidgetException;
	public native int getMinDataInterval() throws PhidgetException;
	public native int getMaxDataInterval() throws PhidgetException;
	public native double getDataRate() throws PhidgetException;
	public native void setDataRate(double DataRate) throws PhidgetException;
	public native double getMinDataRate() throws PhidgetException;
	public native double getMaxDataRate() throws PhidgetException;
	public native FrequencyFilterType getFilterType() throws PhidgetException;
	public native void setFilterType(FrequencyFilterType FilterType) throws PhidgetException;
	public native double getFrequency() throws PhidgetException;
	public native double getMaxFrequency() throws PhidgetException;
	public native double getFrequencyCutoff() throws PhidgetException;
	public native void setFrequencyCutoff(double FrequencyCutoff) throws PhidgetException;
	public native double getMinFrequencyCutoff() throws PhidgetException;
	public native double getMaxFrequencyCutoff() throws PhidgetException;
	public native InputMode getInputMode() throws PhidgetException;
	public native void setInputMode(InputMode InputMode) throws PhidgetException;
	public native PowerSupply getPowerSupply() throws PhidgetException;
	public native void setPowerSupply(PowerSupply PowerSupply) throws PhidgetException;
	public native void reset() throws PhidgetException;
	public native double getTimeElapsed() throws PhidgetException;
}
