/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of Phidget22.jar
 *
 * Copyright (c) 2017-2022 Phidgets Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

package com.phidget22;
import java.util.*;

public class GPSBase extends Phidget {

	GPSBase(long handle) {
		super(handle);
	}

	public GPSBase() throws PhidgetException {
		super(create());
	}

	private native static long create() throws PhidgetException;

	private final void setDeviceEvents(boolean enable) {
		enableHeadingChangeEvents(enable && headingChangeListeners.size() > 0);
		enablePositionChangeEvents(enable && positionChangeListeners.size() > 0);
		enablePositionFixStateChangeEvents(enable && positionFixStateChangeListeners.size() > 0);
	}

	public final void addHeadingChangeListener(GPSHeadingChangeListener l) {
		synchronized(headingChangeListeners) {
			headingChangeListeners.add(l);
			enableHeadingChangeEvents(true);
		}
	}
	private List<GPSHeadingChangeListener> headingChangeListeners = new ArrayList<GPSHeadingChangeListener>();
	private long nativeHeadingChangeHandler = 0;
	public final void removeHeadingChangeListener(GPSHeadingChangeListener l) {
		synchronized(headingChangeListeners) {
			headingChangeListeners.remove(l);
			enableHeadingChangeEvents(headingChangeListeners.size() > 0);
		}
	}
	private void fireHeadingChange(GPSHeadingChangeEvent e) {
		synchronized(headingChangeListeners) {
			for (Iterator it = headingChangeListeners.iterator (); it.hasNext();)
			((GPSHeadingChangeListener) it.next ()).onHeadingChange (e);
		}
	}
	private native void enableHeadingChangeEvents(boolean b);

	public final void addPositionChangeListener(GPSPositionChangeListener l) {
		synchronized(positionChangeListeners) {
			positionChangeListeners.add(l);
			enablePositionChangeEvents(true);
		}
	}
	private List<GPSPositionChangeListener> positionChangeListeners = new ArrayList<GPSPositionChangeListener>();
	private long nativePositionChangeHandler = 0;
	public final void removePositionChangeListener(GPSPositionChangeListener l) {
		synchronized(positionChangeListeners) {
			positionChangeListeners.remove(l);
			enablePositionChangeEvents(positionChangeListeners.size() > 0);
		}
	}
	private void firePositionChange(GPSPositionChangeEvent e) {
		synchronized(positionChangeListeners) {
			for (Iterator it = positionChangeListeners.iterator (); it.hasNext();)
			((GPSPositionChangeListener) it.next ()).onPositionChange (e);
		}
	}
	private native void enablePositionChangeEvents(boolean b);

	public final void addPositionFixStateChangeListener(GPSPositionFixStateChangeListener l) {
		synchronized(positionFixStateChangeListeners) {
			positionFixStateChangeListeners.add(l);
			enablePositionFixStateChangeEvents(true);
		}
	}
	private List<GPSPositionFixStateChangeListener> positionFixStateChangeListeners = new ArrayList<GPSPositionFixStateChangeListener>();
	private long nativePositionFixStateChangeHandler = 0;
	public final void removePositionFixStateChangeListener(GPSPositionFixStateChangeListener l) {
		synchronized(positionFixStateChangeListeners) {
			positionFixStateChangeListeners.remove(l);
			enablePositionFixStateChangeEvents(positionFixStateChangeListeners.size() > 0);
		}
	}
	private void firePositionFixStateChange(GPSPositionFixStateChangeEvent e) {
		synchronized(positionFixStateChangeListeners) {
			for (Iterator it = positionFixStateChangeListeners.iterator (); it.hasNext();)
			((GPSPositionFixStateChangeListener) it.next ()).onPositionFixStateChange (e);
		}
	}
	private native void enablePositionFixStateChangeEvents(boolean b);


	public native double getAltitude() throws PhidgetException;
	public native GPSDate getDate() throws PhidgetException;
	public native java.util.Calendar getDateAndTime() throws PhidgetException;
	public native double getHeading() throws PhidgetException;
	public native double getLatitude() throws PhidgetException;
	public native double getLongitude() throws PhidgetException;
	public native NMEAData getNMEAData() throws PhidgetException;
	public native boolean getPositionFixState() throws PhidgetException;
	public native GPSTime getTime() throws PhidgetException;
	public native double getVelocity() throws PhidgetException;
}
