/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of Phidget22.jar
 *
 * Copyright (c) 2017-2022 Phidgets Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

package com.phidget22;
import java.util.*;

public class IRBase extends Phidget {

	IRBase(long handle) {
		super(handle);
	}

	public IRBase() throws PhidgetException {
		super(create());
	}

	private native static long create() throws PhidgetException;

	private final void setDeviceEvents(boolean enable) {
		enableCodeEvents(enable && codeListeners.size() > 0);
		enableLearnEvents(enable && learnListeners.size() > 0);
		enableRawDataEvents(enable && rawDataListeners.size() > 0);
	}

	public final void addCodeListener(IRCodeListener l) {
		synchronized(codeListeners) {
			codeListeners.add(l);
			enableCodeEvents(true);
		}
	}
	private List<IRCodeListener> codeListeners = new ArrayList<IRCodeListener>();
	private long nativeCodeHandler = 0;
	public final void removeCodeListener(IRCodeListener l) {
		synchronized(codeListeners) {
			codeListeners.remove(l);
			enableCodeEvents(codeListeners.size() > 0);
		}
	}
	private void fireCode(IRCodeEvent e) {
		synchronized(codeListeners) {
			for (Iterator it = codeListeners.iterator (); it.hasNext();)
			((IRCodeListener) it.next ()).onCode (e);
		}
	}
	private native void enableCodeEvents(boolean b);

	public final void addLearnListener(IRLearnListener l) {
		synchronized(learnListeners) {
			learnListeners.add(l);
			enableLearnEvents(true);
		}
	}
	private List<IRLearnListener> learnListeners = new ArrayList<IRLearnListener>();
	private long nativeLearnHandler = 0;
	public final void removeLearnListener(IRLearnListener l) {
		synchronized(learnListeners) {
			learnListeners.remove(l);
			enableLearnEvents(learnListeners.size() > 0);
		}
	}
	private void fireLearn(IRLearnEvent e) {
		synchronized(learnListeners) {
			for (Iterator it = learnListeners.iterator (); it.hasNext();)
			((IRLearnListener) it.next ()).onLearn (e);
		}
	}
	private native void enableLearnEvents(boolean b);

	public final void addRawDataListener(IRRawDataListener l) {
		synchronized(rawDataListeners) {
			rawDataListeners.add(l);
			enableRawDataEvents(true);
		}
	}
	private List<IRRawDataListener> rawDataListeners = new ArrayList<IRRawDataListener>();
	private long nativeRawDataHandler = 0;
	public final void removeRawDataListener(IRRawDataListener l) {
		synchronized(rawDataListeners) {
			rawDataListeners.remove(l);
			enableRawDataEvents(rawDataListeners.size() > 0);
		}
	}
	private void fireRawData(IRRawDataEvent e) {
		synchronized(rawDataListeners) {
			for (Iterator it = rawDataListeners.iterator (); it.hasNext();)
			((IRRawDataListener) it.next ()).onRawData (e);
		}
	}
	private native void enableRawDataEvents(boolean b);


	public native IRCode getLastCode() throws PhidgetException;
	public native IRLearnedCode getLastLearnedCode() throws PhidgetException;
	public native void transmit(java.lang.String code, IRCodeInfo codeInfo) throws PhidgetException;
	public native void transmitRaw(int[] data, int carrierFrequency, double dutyCycle, int gap) throws PhidgetException;
	public native void transmitRepeat() throws PhidgetException;

	public static final int RAW_DATA_LONG_SPACE = -1;

	public static final int MAX_CODE_BIT_COUNT = 128;

	public static final int MAX_CODE_STRING_LENGTH = 33;
}
