/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of Phidget22.jar
 *
 * Copyright (c) 2017-2022 Phidgets Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

package com.phidget22;
import java.util.*;

public class LogBase {
	static {
		try {
			System.loadLibrary("phidget22");
		} catch (UnsatisfiedLinkError ex) { }
		try {
			System.loadLibrary("phidget22java");
		} catch (UnsatisfiedLinkError ex) {
			String os = System.getProperty("os.name");
			if (os.startsWith("Linux")) {
				throw new ExceptionInInitializerError(ex.getMessage()
				+ "\nError loading the Phidget C libraries (libphidget22.so and libphidget22java.so)."
				+ "\nMake sure they are available, and add their path to LD_LIBRARY_PATH, or specify with java.library.path.");
			}
			else if (os.startsWith("Windows")) {
				throw new ExceptionInInitializerError(ex.getMessage()
				+ "\nError loading the Phidget C libraries."
				+ "\nInstall the Windows Phidget22 MSI, or specify with java.library.path.");
			}
			else if (os.startsWith("Mac")) {
				throw new ExceptionInInitializerError(ex.getMessage()
				+ "\nError loading the Phidget C libraries."
				+ "\nThe Mac Phidget22 DMG must be installed.");
			}
			else {
				throw new ExceptionInInitializerError(ex.getMessage()
				+ "\nError loading the Phidget C libraries.");
			}
		}
	}

	public LogBase() throws PhidgetException { }


	private final void setEvents(boolean enable) {
	}


	public static native void disable() throws PhidgetException;
	public static native void enable(LogLevel level, java.lang.String destination) throws PhidgetException;
	public static native LogLevel getLevel() throws PhidgetException;
	public static native void setLevel(LogLevel level) throws PhidgetException;
	public static native void log(LogLevel level, java.lang.String source, java.lang.String message) throws PhidgetException;
	public static native void log(LogLevel level, java.lang.String message) throws PhidgetException;
	public static native void rotate() throws PhidgetException;
	public static native boolean isRotating() throws PhidgetException;
	public static native LogRotating getRotating() throws PhidgetException;
	public static native void setRotating(long size, int keepCount) throws PhidgetException;
	public static native void enableRotating() throws PhidgetException;
	public static native void disableRotating() throws PhidgetException;
	public static native void addSource(java.lang.String source, LogLevel level) throws PhidgetException;
	public static native LogLevel getSourceLevel(java.lang.String source) throws PhidgetException;
	public static native void setSourceLevel(java.lang.String source, LogLevel level) throws PhidgetException;
}
