/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of Phidget22.jar
 *
 * Copyright (c) 2017-2022 Phidgets Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

package com.phidget22;
import java.util.*;

public class MagnetometerBase extends Phidget {

	MagnetometerBase(long handle) {
		super(handle);
	}

	public MagnetometerBase() throws PhidgetException {
		super(create());
	}

	private native static long create() throws PhidgetException;

	private final void setDeviceEvents(boolean enable) {
		enableMagneticFieldChangeEvents(enable && magneticFieldChangeListeners.size() > 0);
	}

	public final void addMagneticFieldChangeListener(MagnetometerMagneticFieldChangeListener l) {
		synchronized(magneticFieldChangeListeners) {
			magneticFieldChangeListeners.add(l);
			enableMagneticFieldChangeEvents(true);
		}
	}
	private List<MagnetometerMagneticFieldChangeListener> magneticFieldChangeListeners = new ArrayList<MagnetometerMagneticFieldChangeListener>();
	private long nativeMagneticFieldChangeHandler = 0;
	public final void removeMagneticFieldChangeListener(MagnetometerMagneticFieldChangeListener l) {
		synchronized(magneticFieldChangeListeners) {
			magneticFieldChangeListeners.remove(l);
			enableMagneticFieldChangeEvents(magneticFieldChangeListeners.size() > 0);
		}
	}
	private void fireMagneticFieldChange(MagnetometerMagneticFieldChangeEvent e) {
		synchronized(magneticFieldChangeListeners) {
			for (Iterator it = magneticFieldChangeListeners.iterator (); it.hasNext();)
			((MagnetometerMagneticFieldChangeListener) it.next ()).onMagneticFieldChange (e);
		}
	}
	private native void enableMagneticFieldChangeEvents(boolean b);


	public native int getAxisCount() throws PhidgetException;
	public native void setCorrectionParameters(double magneticField, double offset0, double offset1, double offset2, double gain0, double gain1, double gain2, double T0, double T1, double T2, double T3, double T4, double T5) throws PhidgetException;
	public native int getDataInterval() throws PhidgetException;
	public native void setDataInterval(int DataInterval) throws PhidgetException;
	public native int getMinDataInterval() throws PhidgetException;
	public native int getMaxDataInterval() throws PhidgetException;
	public native double getDataRate() throws PhidgetException;
	public native void setDataRate(double DataRate) throws PhidgetException;
	public native double getMinDataRate() throws PhidgetException;
	public native double getMaxDataRate() throws PhidgetException;
	public native boolean getHeatingEnabled() throws PhidgetException;
	public native void setHeatingEnabled(boolean HeatingEnabled) throws PhidgetException;
	public native double[] getMagneticField() throws PhidgetException;
	public native double[] getMinMagneticField() throws PhidgetException;
	public native double[] getMaxMagneticField() throws PhidgetException;
	public native double getMagneticFieldChangeTrigger() throws PhidgetException;
	public native void setMagneticFieldChangeTrigger(double MagneticFieldChangeTrigger) throws PhidgetException;
	public native double getMinMagneticFieldChangeTrigger() throws PhidgetException;
	public native double getMaxMagneticFieldChangeTrigger() throws PhidgetException;
	public native void resetCorrectionParameters() throws PhidgetException;
	public native void saveCorrectionParameters() throws PhidgetException;
	public native double getTimestamp() throws PhidgetException;
}
