/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of Phidget22.jar
 *
 * Copyright (c) 2017-2022 Phidgets Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

package com.phidget22;
import java.util.*;

public class ManagerBase {
	static {
		try {
			System.loadLibrary("phidget22");
		} catch (UnsatisfiedLinkError ex) { }
		try {
			System.loadLibrary("phidget22java");
		} catch (UnsatisfiedLinkError ex) {
			String os = System.getProperty("os.name");
			if (os.startsWith("Linux")) {
				throw new ExceptionInInitializerError(ex.getMessage()
				+ "\nError loading the Phidget C libraries (libphidget22.so and libphidget22java.so)."
				+ "\nMake sure they are available, and add their path to LD_LIBRARY_PATH, or specify with java.library.path.");
			}
			else if (os.startsWith("Windows")) {
				throw new ExceptionInInitializerError(ex.getMessage()
				+ "\nError loading the Phidget C libraries."
				+ "\nInstall the Windows Phidget22 MSI, or specify with java.library.path.");
			}
			else if (os.startsWith("Mac")) {
				throw new ExceptionInInitializerError(ex.getMessage()
				+ "\nError loading the Phidget C libraries."
				+ "\nThe Mac Phidget22 DMG must be installed.");
			}
			else {
				throw new ExceptionInInitializerError(ex.getMessage()
				+ "\nError loading the Phidget C libraries.");
			}
		}
	}

	long handle = 0;


	public ManagerBase() throws PhidgetException {
		this.handle = create();
	}

	private native static long create() throws PhidgetException;

	private final void setEvents(boolean enable) {
		enableAttachEvents(enable && attachListeners.size() > 0);
		enableDetachEvents(enable && detachListeners.size() > 0);
	}

	public final void addAttachListener(ManagerAttachListener l) {
		synchronized(attachListeners) {
			attachListeners.add(l);
			enableAttachEvents(true);
		}
	}
	private List<ManagerAttachListener> attachListeners = new ArrayList<ManagerAttachListener>();
	private long nativeAttachHandler = 0;
	public final void removeAttachListener(ManagerAttachListener l) {
		synchronized(attachListeners) {
			attachListeners.remove(l);
			enableAttachEvents(attachListeners.size() > 0);
		}
	}
	private void fireAttach(ManagerAttachEvent e) {
		synchronized(attachListeners) {
			for (Iterator it = attachListeners.iterator (); it.hasNext();)
			((ManagerAttachListener) it.next ()).onAttach (e);
		}
	}
	private native void enableAttachEvents(boolean b);

	public final void addDetachListener(ManagerDetachListener l) {
		synchronized(detachListeners) {
			detachListeners.add(l);
			enableDetachEvents(true);
		}
	}
	private List<ManagerDetachListener> detachListeners = new ArrayList<ManagerDetachListener>();
	private long nativeDetachHandler = 0;
	public final void removeDetachListener(ManagerDetachListener l) {
		synchronized(detachListeners) {
			detachListeners.remove(l);
			enableDetachEvents(detachListeners.size() > 0);
		}
	}
	private void fireDetach(ManagerDetachEvent e) {
		synchronized(detachListeners) {
			for (Iterator it = detachListeners.iterator (); it.hasNext();)
			((ManagerDetachListener) it.next ()).onDetach (e);
		}
	}
	private native void enableDetachEvents(boolean b);


	public native void close() throws PhidgetException;
	public native void open() throws PhidgetException;
}
