/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of Phidget22.jar
 *
 * Copyright (c) 2017-2022 Phidgets Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

package com.phidget22;
import java.util.*;

public class NetBase {
	static {
		try {
			System.loadLibrary("phidget22");
		} catch (UnsatisfiedLinkError ex) { }
		try {
			System.loadLibrary("phidget22java");
		} catch (UnsatisfiedLinkError ex) {
			String os = System.getProperty("os.name");
			if (os.startsWith("Linux")) {
				throw new ExceptionInInitializerError(ex.getMessage()
				+ "\nError loading the Phidget C libraries (libphidget22.so and libphidget22java.so)."
				+ "\nMake sure they are available, and add their path to LD_LIBRARY_PATH, or specify with java.library.path.");
			}
			else if (os.startsWith("Windows")) {
				throw new ExceptionInInitializerError(ex.getMessage()
				+ "\nError loading the Phidget C libraries."
				+ "\nInstall the Windows Phidget22 MSI, or specify with java.library.path.");
			}
			else if (os.startsWith("Mac")) {
				throw new ExceptionInInitializerError(ex.getMessage()
				+ "\nError loading the Phidget C libraries."
				+ "\nThe Mac Phidget22 DMG must be installed.");
			}
			else {
				throw new ExceptionInInitializerError(ex.getMessage()
				+ "\nError loading the Phidget C libraries.");
			}
		}
	}

	public NetBase() throws PhidgetException { }


	private final void setEvents(boolean enable) {
		enableServerAddedEvents(enable && serverAddedListeners.size() > 0);
		enableServerRemovedEvents(enable && serverRemovedListeners.size() > 0);
	}

	public final void addServerAddedListener(NetServerAddedListener l) {
		synchronized(serverAddedListeners) {
			serverAddedListeners.add(l);
			enableServerAddedEvents(true);
		}
	}
	private List<NetServerAddedListener> serverAddedListeners = new ArrayList<NetServerAddedListener>();
	private long nativeServerAddedHandler = 0;
	public final void removeServerAddedListener(NetServerAddedListener l) {
		synchronized(serverAddedListeners) {
			serverAddedListeners.remove(l);
			enableServerAddedEvents(serverAddedListeners.size() > 0);
		}
	}
	private void fireServerAdded(NetServerAddedEvent e) {
		synchronized(serverAddedListeners) {
			for (Iterator it = serverAddedListeners.iterator (); it.hasNext();)
			((NetServerAddedListener) it.next ()).onServerAdded (e);
		}
	}
	private native void enableServerAddedEvents(boolean b);

	public final void addServerRemovedListener(NetServerRemovedListener l) {
		synchronized(serverRemovedListeners) {
			serverRemovedListeners.add(l);
			enableServerRemovedEvents(true);
		}
	}
	private List<NetServerRemovedListener> serverRemovedListeners = new ArrayList<NetServerRemovedListener>();
	private long nativeServerRemovedHandler = 0;
	public final void removeServerRemovedListener(NetServerRemovedListener l) {
		synchronized(serverRemovedListeners) {
			serverRemovedListeners.remove(l);
			enableServerRemovedEvents(serverRemovedListeners.size() > 0);
		}
	}
	private void fireServerRemoved(NetServerRemovedEvent e) {
		synchronized(serverRemovedListeners) {
			for (Iterator it = serverRemovedListeners.iterator (); it.hasNext();)
			((NetServerRemovedListener) it.next ()).onServerRemoved (e);
		}
	}
	private native void enableServerRemovedEvents(boolean b);


	public static native void addServer(java.lang.String serverName, java.lang.String address, int port, java.lang.String password, int flags) throws PhidgetException;
	public static native void removeServer(java.lang.String serverName) throws PhidgetException;
	public static native void enableServer(java.lang.String serverName) throws PhidgetException;
	public static native void disableServer(java.lang.String serverName, int flags) throws PhidgetException;
	public static native void enableServerDiscovery(ServerType serverType) throws PhidgetException;
	public static native void disableServerDiscovery(ServerType serverType) throws PhidgetException;
	public static native void setServerPassword(java.lang.String serverName, java.lang.String password) throws PhidgetException;

	public static final int AUTHREQUIRED = 1;
}
