/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of Phidget22.jar
 *
 * Copyright (c) 2017-2022 Phidgets Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

package com.phidget22;
import java.util.*;

public class PHSensorBase extends Phidget {

	PHSensorBase(long handle) {
		super(handle);
	}

	public PHSensorBase() throws PhidgetException {
		super(create());
	}

	private native static long create() throws PhidgetException;

	private final void setDeviceEvents(boolean enable) {
		enablePHChangeEvents(enable && PHChangeListeners.size() > 0);
	}

	public final void addPHChangeListener(PHSensorPHChangeListener l) {
		synchronized(PHChangeListeners) {
			PHChangeListeners.add(l);
			enablePHChangeEvents(true);
		}
	}
	private List<PHSensorPHChangeListener> PHChangeListeners = new ArrayList<PHSensorPHChangeListener>();
	private long nativePHChangeHandler = 0;
	public final void removePHChangeListener(PHSensorPHChangeListener l) {
		synchronized(PHChangeListeners) {
			PHChangeListeners.remove(l);
			enablePHChangeEvents(PHChangeListeners.size() > 0);
		}
	}
	private void firePHChange(PHSensorPHChangeEvent e) {
		synchronized(PHChangeListeners) {
			for (Iterator it = PHChangeListeners.iterator (); it.hasNext();)
			((PHSensorPHChangeListener) it.next ()).onPHChange (e);
		}
	}
	private native void enablePHChangeEvents(boolean b);


	public native double getCorrectionTemperature() throws PhidgetException;
	public native void setCorrectionTemperature(double CorrectionTemperature) throws PhidgetException;
	public native double getMinCorrectionTemperature() throws PhidgetException;
	public native double getMaxCorrectionTemperature() throws PhidgetException;
	public native int getDataInterval() throws PhidgetException;
	public native void setDataInterval(int DataInterval) throws PhidgetException;
	public native int getMinDataInterval() throws PhidgetException;
	public native int getMaxDataInterval() throws PhidgetException;
	public native double getDataRate() throws PhidgetException;
	public native void setDataRate(double DataRate) throws PhidgetException;
	public native double getMinDataRate() throws PhidgetException;
	public native double getMaxDataRate() throws PhidgetException;
	public native double getPH() throws PhidgetException;
	public native double getMinPH() throws PhidgetException;
	public native double getMaxPH() throws PhidgetException;
	public native double getPHChangeTrigger() throws PhidgetException;
	public native void setPHChangeTrigger(double PHChangeTrigger) throws PhidgetException;
	public native double getMinPHChangeTrigger() throws PhidgetException;
	public native double getMaxPHChangeTrigger() throws PhidgetException;
}
