/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of Phidget22.jar
 *
 * Copyright (c) 2017-2022 Phidgets Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

package com.phidget22;
import java.util.*;

public class PressureSensorBase extends Phidget {

	PressureSensorBase(long handle) {
		super(handle);
	}

	public PressureSensorBase() throws PhidgetException {
		super(create());
	}

	private native static long create() throws PhidgetException;

	private final void setDeviceEvents(boolean enable) {
		enablePressureChangeEvents(enable && pressureChangeListeners.size() > 0);
	}

	public final void addPressureChangeListener(PressureSensorPressureChangeListener l) {
		synchronized(pressureChangeListeners) {
			pressureChangeListeners.add(l);
			enablePressureChangeEvents(true);
		}
	}
	private List<PressureSensorPressureChangeListener> pressureChangeListeners = new ArrayList<PressureSensorPressureChangeListener>();
	private long nativePressureChangeHandler = 0;
	public final void removePressureChangeListener(PressureSensorPressureChangeListener l) {
		synchronized(pressureChangeListeners) {
			pressureChangeListeners.remove(l);
			enablePressureChangeEvents(pressureChangeListeners.size() > 0);
		}
	}
	private void firePressureChange(PressureSensorPressureChangeEvent e) {
		synchronized(pressureChangeListeners) {
			for (Iterator it = pressureChangeListeners.iterator (); it.hasNext();)
			((PressureSensorPressureChangeListener) it.next ()).onPressureChange (e);
		}
	}
	private native void enablePressureChangeEvents(boolean b);


	public native int getDataInterval() throws PhidgetException;
	public native void setDataInterval(int DataInterval) throws PhidgetException;
	public native int getMinDataInterval() throws PhidgetException;
	public native int getMaxDataInterval() throws PhidgetException;
	public native double getDataRate() throws PhidgetException;
	public native void setDataRate(double DataRate) throws PhidgetException;
	public native double getMinDataRate() throws PhidgetException;
	public native double getMaxDataRate() throws PhidgetException;
	public native double getPressure() throws PhidgetException;
	public native double getMinPressure() throws PhidgetException;
	public native double getMaxPressure() throws PhidgetException;
	public native double getPressureChangeTrigger() throws PhidgetException;
	public native void setPressureChangeTrigger(double PressureChangeTrigger) throws PhidgetException;
	public native double getMinPressureChangeTrigger() throws PhidgetException;
	public native double getMaxPressureChangeTrigger() throws PhidgetException;
}
