/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of Phidget22.jar
 *
 * Copyright (c) 2017-2022 Phidgets Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

package com.phidget22;
import java.util.*;

public class RFIDBase extends Phidget {

	RFIDBase(long handle) {
		super(handle);
	}

	public RFIDBase() throws PhidgetException {
		super(create());
	}

	private native static long create() throws PhidgetException;

	private final void setDeviceEvents(boolean enable) {
		enableTagEvents(enable && tagListeners.size() > 0);
		enableTagLostEvents(enable && tagLostListeners.size() > 0);
	}

	public final void addTagListener(RFIDTagListener l) {
		synchronized(tagListeners) {
			tagListeners.add(l);
			enableTagEvents(true);
		}
	}
	private List<RFIDTagListener> tagListeners = new ArrayList<RFIDTagListener>();
	private long nativeTagHandler = 0;
	public final void removeTagListener(RFIDTagListener l) {
		synchronized(tagListeners) {
			tagListeners.remove(l);
			enableTagEvents(tagListeners.size() > 0);
		}
	}
	private void fireTag(RFIDTagEvent e) {
		synchronized(tagListeners) {
			for (Iterator it = tagListeners.iterator (); it.hasNext();)
			((RFIDTagListener) it.next ()).onTag (e);
		}
	}
	private native void enableTagEvents(boolean b);

	public final void addTagLostListener(RFIDTagLostListener l) {
		synchronized(tagLostListeners) {
			tagLostListeners.add(l);
			enableTagLostEvents(true);
		}
	}
	private List<RFIDTagLostListener> tagLostListeners = new ArrayList<RFIDTagLostListener>();
	private long nativeTagLostHandler = 0;
	public final void removeTagLostListener(RFIDTagLostListener l) {
		synchronized(tagLostListeners) {
			tagLostListeners.remove(l);
			enableTagLostEvents(tagLostListeners.size() > 0);
		}
	}
	private void fireTagLost(RFIDTagLostEvent e) {
		synchronized(tagLostListeners) {
			for (Iterator it = tagLostListeners.iterator (); it.hasNext();)
			((RFIDTagLostListener) it.next ()).onTagLost (e);
		}
	}
	private native void enableTagLostEvents(boolean b);


	public native boolean getAntennaEnabled() throws PhidgetException;
	public native void setAntennaEnabled(boolean AntennaEnabled) throws PhidgetException;
	public native RFIDTag getLastTag() throws PhidgetException;
	public native boolean getTagPresent() throws PhidgetException;
	public native void write(java.lang.String tagString, RFIDProtocol protocol, boolean lockTag) throws PhidgetException;
}
