/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of Phidget22.jar
 *
 * Copyright (c) 2017-2022 Phidgets Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

package com.phidget22;
import java.util.*;

public class SpatialBase extends Phidget {

	SpatialBase(long handle) {
		super(handle);
	}

	public SpatialBase() throws PhidgetException {
		super(create());
	}

	private native static long create() throws PhidgetException;

	private final void setDeviceEvents(boolean enable) {
		enableAlgorithmDataEvents(enable && algorithmDataListeners.size() > 0);
		enableSpatialDataEvents(enable && spatialDataListeners.size() > 0);
	}

	public final void addAlgorithmDataListener(SpatialAlgorithmDataListener l) {
		synchronized(algorithmDataListeners) {
			algorithmDataListeners.add(l);
			enableAlgorithmDataEvents(true);
		}
	}
	private List<SpatialAlgorithmDataListener> algorithmDataListeners = new ArrayList<SpatialAlgorithmDataListener>();
	private long nativeAlgorithmDataHandler = 0;
	public final void removeAlgorithmDataListener(SpatialAlgorithmDataListener l) {
		synchronized(algorithmDataListeners) {
			algorithmDataListeners.remove(l);
			enableAlgorithmDataEvents(algorithmDataListeners.size() > 0);
		}
	}
	private void fireAlgorithmData(SpatialAlgorithmDataEvent e) {
		synchronized(algorithmDataListeners) {
			for (Iterator it = algorithmDataListeners.iterator (); it.hasNext();)
			((SpatialAlgorithmDataListener) it.next ()).onAlgorithmData (e);
		}
	}
	private native void enableAlgorithmDataEvents(boolean b);

	public final void addSpatialDataListener(SpatialSpatialDataListener l) {
		synchronized(spatialDataListeners) {
			spatialDataListeners.add(l);
			enableSpatialDataEvents(true);
		}
	}
	private List<SpatialSpatialDataListener> spatialDataListeners = new ArrayList<SpatialSpatialDataListener>();
	private long nativeSpatialDataHandler = 0;
	public final void removeSpatialDataListener(SpatialSpatialDataListener l) {
		synchronized(spatialDataListeners) {
			spatialDataListeners.remove(l);
			enableSpatialDataEvents(spatialDataListeners.size() > 0);
		}
	}
	private void fireSpatialData(SpatialSpatialDataEvent e) {
		synchronized(spatialDataListeners) {
			for (Iterator it = spatialDataListeners.iterator (); it.hasNext();)
			((SpatialSpatialDataListener) it.next ()).onSpatialData (e);
		}
	}
	private native void enableSpatialDataEvents(boolean b);


	public native double[] getMinAcceleration() throws PhidgetException;
	public native double[] getMaxAcceleration() throws PhidgetException;
	public native void setAHRSParameters(double angularVelocityThreshold, double angularVelocityDeltaThreshold, double accelerationThreshold, double magTime, double accelTime, double biasTime) throws PhidgetException;
	public native SpatialAlgorithm getAlgorithm() throws PhidgetException;
	public native void setAlgorithm(SpatialAlgorithm Algorithm) throws PhidgetException;
	public native double getAlgorithmMagnetometerGain() throws PhidgetException;
	public native void setAlgorithmMagnetometerGain(double AlgorithmMagnetometerGain) throws PhidgetException;
	public native double[] getMinAngularRate() throws PhidgetException;
	public native double[] getMaxAngularRate() throws PhidgetException;
	public native int getDataInterval() throws PhidgetException;
	public native void setDataInterval(int DataInterval) throws PhidgetException;
	public native int getMinDataInterval() throws PhidgetException;
	public native int getMaxDataInterval() throws PhidgetException;
	public native double getDataRate() throws PhidgetException;
	public native void setDataRate(double DataRate) throws PhidgetException;
	public native double getMinDataRate() throws PhidgetException;
	public native double getMaxDataRate() throws PhidgetException;
	public native SpatialEulerAngles getEulerAngles() throws PhidgetException;
	public native boolean getHeatingEnabled() throws PhidgetException;
	public native void setHeatingEnabled(boolean HeatingEnabled) throws PhidgetException;
	public native double[] getMinMagneticField() throws PhidgetException;
	public native double[] getMaxMagneticField() throws PhidgetException;
	public native void setMagnetometerCorrectionParameters(double magneticField, double offset0, double offset1, double offset2, double gain0, double gain1, double gain2, double T0, double T1, double T2, double T3, double T4, double T5) throws PhidgetException;
	public native SpatialQuaternion getQuaternion() throws PhidgetException;
	public native void resetMagnetometerCorrectionParameters() throws PhidgetException;
	public native void saveMagnetometerCorrectionParameters() throws PhidgetException;
	public native void zeroAlgorithm() throws PhidgetException;
	public native void zeroGyro() throws PhidgetException;
}
