/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of Phidget22.jar
 *
 * Copyright (c) 2017-2022 Phidgets Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

package com.phidget22;
import java.util.*;

public class TemperatureSensorBase extends Phidget {

	TemperatureSensorBase(long handle) {
		super(handle);
	}

	public TemperatureSensorBase() throws PhidgetException {
		super(create());
	}

	private native static long create() throws PhidgetException;

	private final void setDeviceEvents(boolean enable) {
		enableTemperatureChangeEvents(enable && temperatureChangeListeners.size() > 0);
	}

	public final void addTemperatureChangeListener(TemperatureSensorTemperatureChangeListener l) {
		synchronized(temperatureChangeListeners) {
			temperatureChangeListeners.add(l);
			enableTemperatureChangeEvents(true);
		}
	}
	private List<TemperatureSensorTemperatureChangeListener> temperatureChangeListeners = new ArrayList<TemperatureSensorTemperatureChangeListener>();
	private long nativeTemperatureChangeHandler = 0;
	public final void removeTemperatureChangeListener(TemperatureSensorTemperatureChangeListener l) {
		synchronized(temperatureChangeListeners) {
			temperatureChangeListeners.remove(l);
			enableTemperatureChangeEvents(temperatureChangeListeners.size() > 0);
		}
	}
	private void fireTemperatureChange(TemperatureSensorTemperatureChangeEvent e) {
		synchronized(temperatureChangeListeners) {
			for (Iterator it = temperatureChangeListeners.iterator (); it.hasNext();)
			((TemperatureSensorTemperatureChangeListener) it.next ()).onTemperatureChange (e);
		}
	}
	private native void enableTemperatureChangeEvents(boolean b);


	public native int getDataInterval() throws PhidgetException;
	public native void setDataInterval(int DataInterval) throws PhidgetException;
	public native int getMinDataInterval() throws PhidgetException;
	public native int getMaxDataInterval() throws PhidgetException;
	public native double getDataRate() throws PhidgetException;
	public native void setDataRate(double DataRate) throws PhidgetException;
	public native double getMinDataRate() throws PhidgetException;
	public native double getMaxDataRate() throws PhidgetException;
	public native RTDType getRTDType() throws PhidgetException;
	public native void setRTDType(RTDType RTDType) throws PhidgetException;
	public native RTDWireSetup getRTDWireSetup() throws PhidgetException;
	public native void setRTDWireSetup(RTDWireSetup RTDWireSetup) throws PhidgetException;
	public native double getTemperature() throws PhidgetException;
	public native double getMinTemperature() throws PhidgetException;
	public native double getMaxTemperature() throws PhidgetException;
	public native double getTemperatureChangeTrigger() throws PhidgetException;
	public native void setTemperatureChangeTrigger(double TemperatureChangeTrigger) throws PhidgetException;
	public native double getMinTemperatureChangeTrigger() throws PhidgetException;
	public native double getMaxTemperatureChangeTrigger() throws PhidgetException;
	public native ThermocoupleType getThermocoupleType() throws PhidgetException;
	public native void setThermocoupleType(ThermocoupleType ThermocoupleType) throws PhidgetException;
}
