/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of Phidget22.jar
 *
 * Copyright (c) 2017-2022 Phidgets Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

package com.phidget22;
import java.util.*;

public class VoltageInputBase extends Phidget {

	VoltageInputBase(long handle) {
		super(handle);
	}

	public VoltageInputBase() throws PhidgetException {
		super(create());
	}

	private native static long create() throws PhidgetException;

	private final void setDeviceEvents(boolean enable) {
		enableSensorChangeEvents(enable && sensorChangeListeners.size() > 0);
		enableVoltageChangeEvents(enable && voltageChangeListeners.size() > 0);
	}

	public final void addSensorChangeListener(VoltageInputSensorChangeListener l) {
		synchronized(sensorChangeListeners) {
			sensorChangeListeners.add(l);
			enableSensorChangeEvents(true);
		}
	}
	private List<VoltageInputSensorChangeListener> sensorChangeListeners = new ArrayList<VoltageInputSensorChangeListener>();
	private long nativeSensorChangeHandler = 0;
	public final void removeSensorChangeListener(VoltageInputSensorChangeListener l) {
		synchronized(sensorChangeListeners) {
			sensorChangeListeners.remove(l);
			enableSensorChangeEvents(sensorChangeListeners.size() > 0);
		}
	}
	private void fireSensorChange(VoltageInputSensorChangeEvent e) {
		synchronized(sensorChangeListeners) {
			for (Iterator it = sensorChangeListeners.iterator (); it.hasNext();)
			((VoltageInputSensorChangeListener) it.next ()).onSensorChange (e);
		}
	}
	private native void enableSensorChangeEvents(boolean b);

	public final void addVoltageChangeListener(VoltageInputVoltageChangeListener l) {
		synchronized(voltageChangeListeners) {
			voltageChangeListeners.add(l);
			enableVoltageChangeEvents(true);
		}
	}
	private List<VoltageInputVoltageChangeListener> voltageChangeListeners = new ArrayList<VoltageInputVoltageChangeListener>();
	private long nativeVoltageChangeHandler = 0;
	public final void removeVoltageChangeListener(VoltageInputVoltageChangeListener l) {
		synchronized(voltageChangeListeners) {
			voltageChangeListeners.remove(l);
			enableVoltageChangeEvents(voltageChangeListeners.size() > 0);
		}
	}
	private void fireVoltageChange(VoltageInputVoltageChangeEvent e) {
		synchronized(voltageChangeListeners) {
			for (Iterator it = voltageChangeListeners.iterator (); it.hasNext();)
			((VoltageInputVoltageChangeListener) it.next ()).onVoltageChange (e);
		}
	}
	private native void enableVoltageChangeEvents(boolean b);


	public native int getDataInterval() throws PhidgetException;
	public native void setDataInterval(int DataInterval) throws PhidgetException;
	public native int getMinDataInterval() throws PhidgetException;
	public native int getMaxDataInterval() throws PhidgetException;
	public native double getDataRate() throws PhidgetException;
	public native void setDataRate(double DataRate) throws PhidgetException;
	public native double getMinDataRate() throws PhidgetException;
	public native double getMaxDataRate() throws PhidgetException;
	public native PowerSupply getPowerSupply() throws PhidgetException;
	public native void setPowerSupply(PowerSupply PowerSupply) throws PhidgetException;
	public native VoltageSensorType getSensorType() throws PhidgetException;
	public native void setSensorType(VoltageSensorType SensorType) throws PhidgetException;
	public native UnitInfo getSensorUnit() throws PhidgetException;
	public native double getSensorValue() throws PhidgetException;
	public native double getSensorValueChangeTrigger() throws PhidgetException;
	public native void setSensorValueChangeTrigger(double SensorValueChangeTrigger) throws PhidgetException;
	public native double getVoltage() throws PhidgetException;
	public native double getMinVoltage() throws PhidgetException;
	public native double getMaxVoltage() throws PhidgetException;
	public native double getVoltageChangeTrigger() throws PhidgetException;
	public native void setVoltageChangeTrigger(double VoltageChangeTrigger) throws PhidgetException;
	public native double getMinVoltageChangeTrigger() throws PhidgetException;
	public native double getMaxVoltageChangeTrigger() throws PhidgetException;
	public native VoltageRange getVoltageRange() throws PhidgetException;
	public native void setVoltageRange(VoltageRange VoltageRange) throws PhidgetException;
}
