/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of Phidget22.jar
 *
 * Copyright (c) 2017-2022 Phidgets Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

package com.phidget22;
import java.util.*;

public class VoltageRatioInputBase extends Phidget {

	VoltageRatioInputBase(long handle) {
		super(handle);
	}

	public VoltageRatioInputBase() throws PhidgetException {
		super(create());
	}

	private native static long create() throws PhidgetException;

	private final void setDeviceEvents(boolean enable) {
		enableSensorChangeEvents(enable && sensorChangeListeners.size() > 0);
		enableVoltageRatioChangeEvents(enable && voltageRatioChangeListeners.size() > 0);
	}

	public final void addSensorChangeListener(VoltageRatioInputSensorChangeListener l) {
		synchronized(sensorChangeListeners) {
			sensorChangeListeners.add(l);
			enableSensorChangeEvents(true);
		}
	}
	private List<VoltageRatioInputSensorChangeListener> sensorChangeListeners = new ArrayList<VoltageRatioInputSensorChangeListener>();
	private long nativeSensorChangeHandler = 0;
	public final void removeSensorChangeListener(VoltageRatioInputSensorChangeListener l) {
		synchronized(sensorChangeListeners) {
			sensorChangeListeners.remove(l);
			enableSensorChangeEvents(sensorChangeListeners.size() > 0);
		}
	}
	private void fireSensorChange(VoltageRatioInputSensorChangeEvent e) {
		synchronized(sensorChangeListeners) {
			for (Iterator it = sensorChangeListeners.iterator (); it.hasNext();)
			((VoltageRatioInputSensorChangeListener) it.next ()).onSensorChange (e);
		}
	}
	private native void enableSensorChangeEvents(boolean b);

	public final void addVoltageRatioChangeListener(VoltageRatioInputVoltageRatioChangeListener l) {
		synchronized(voltageRatioChangeListeners) {
			voltageRatioChangeListeners.add(l);
			enableVoltageRatioChangeEvents(true);
		}
	}
	private List<VoltageRatioInputVoltageRatioChangeListener> voltageRatioChangeListeners = new ArrayList<VoltageRatioInputVoltageRatioChangeListener>();
	private long nativeVoltageRatioChangeHandler = 0;
	public final void removeVoltageRatioChangeListener(VoltageRatioInputVoltageRatioChangeListener l) {
		synchronized(voltageRatioChangeListeners) {
			voltageRatioChangeListeners.remove(l);
			enableVoltageRatioChangeEvents(voltageRatioChangeListeners.size() > 0);
		}
	}
	private void fireVoltageRatioChange(VoltageRatioInputVoltageRatioChangeEvent e) {
		synchronized(voltageRatioChangeListeners) {
			for (Iterator it = voltageRatioChangeListeners.iterator (); it.hasNext();)
			((VoltageRatioInputVoltageRatioChangeListener) it.next ()).onVoltageRatioChange (e);
		}
	}
	private native void enableVoltageRatioChangeEvents(boolean b);


	public native boolean getBridgeEnabled() throws PhidgetException;
	public native void setBridgeEnabled(boolean BridgeEnabled) throws PhidgetException;
	public native BridgeGain getBridgeGain() throws PhidgetException;
	public native void setBridgeGain(BridgeGain BridgeGain) throws PhidgetException;
	public native int getDataInterval() throws PhidgetException;
	public native void setDataInterval(int DataInterval) throws PhidgetException;
	public native int getMinDataInterval() throws PhidgetException;
	public native int getMaxDataInterval() throws PhidgetException;
	public native double getDataRate() throws PhidgetException;
	public native void setDataRate(double DataRate) throws PhidgetException;
	public native double getMinDataRate() throws PhidgetException;
	public native double getMaxDataRate() throws PhidgetException;
	public native VoltageRatioSensorType getSensorType() throws PhidgetException;
	public native void setSensorType(VoltageRatioSensorType SensorType) throws PhidgetException;
	public native UnitInfo getSensorUnit() throws PhidgetException;
	public native double getSensorValue() throws PhidgetException;
	public native double getSensorValueChangeTrigger() throws PhidgetException;
	public native void setSensorValueChangeTrigger(double SensorValueChangeTrigger) throws PhidgetException;
	public native double getVoltageRatio() throws PhidgetException;
	public native double getMinVoltageRatio() throws PhidgetException;
	public native double getMaxVoltageRatio() throws PhidgetException;
	public native double getVoltageRatioChangeTrigger() throws PhidgetException;
	public native void setVoltageRatioChangeTrigger(double VoltageRatioChangeTrigger) throws PhidgetException;
	public native double getMinVoltageRatioChangeTrigger() throws PhidgetException;
	public native double getMaxVoltageRatioChangeTrigger() throws PhidgetException;
}
