/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of libphidget22java
 *
 * Copyright (c) 2017-2022 Phidgets Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

#include "phidget_jni.h"
#include "com_phidget22_CurrentInputBase.h"

static jclass currentInputbase_class;
jclass currentInput_class;
jmethodID currentInput_cons;

static jclass currentChangeEvent_class;
static jmethodID fireCurrentChange_mid	;
static jmethodID currentChangeEvent_cons;
static jfieldID nativeCurrentChangeHandler_fid;

void com_phidget22_CurrentInputBase_OnLoad(JNIEnv *env) {
	if (!(currentInput_class = (*env)->FindClass(env, "com/phidget22/CurrentInput"))) {
		(*env)->ExceptionClear(env);
		return;
	}
	if (!(currentInput_class = (jclass)(*env)->NewGlobalRef(env, currentInput_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef currentInput_class");
	if (!(currentInput_cons = (*env)->GetMethodID(env, currentInput_class, "<init>", "(J)V")))
		JNI_ABORT_STDERR("Couldn't get Method ID <init> from currentInput_class");

	if (!(currentInputbase_class = (*env)->FindClass(env, "com/phidget22/CurrentInputBase")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/CurrentInputBase");
	if (!(currentInputbase_class = (jclass)(*env)->NewGlobalRef(env, currentInputbase_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef currentInputbase_class");

	if ((currentChangeEvent_class = (*env)->FindClass(env, "com/phidget22/CurrentInputCurrentChangeEvent"))) {
		if (!(currentChangeEvent_class = (jclass)(*env)->NewGlobalRef(env, currentChangeEvent_class)))
			JNI_ABORT_STDERR("Couldn't create global ref CurrentChangeEvent_class");
		if (!(fireCurrentChange_mid = (*env)->GetMethodID(env, currentInputbase_class, "fireCurrentChange", "(Lcom/phidget22/CurrentInputCurrentChangeEvent;)V")))
			JNI_ABORT_STDERR("Couldn't get method ID fireCurrentChange");
		if (!(currentChangeEvent_cons = (*env)->GetMethodID(env, currentChangeEvent_class, "<init>", "(Lcom/phidget22/CurrentInput;D)V")))
			JNI_ABORT_STDERR("Couldn't get method ID <init> from CurrentChangeEvent_class");
		if (!(nativeCurrentChangeHandler_fid = (*env)->GetFieldID(env, currentInputbase_class, "nativeCurrentChangeHandler", "J")))
			JNI_ABORT_STDERR("Couldn't get Field ID nativeCurrentChangeHandler from currentInputbase_class");
	} else {
		(*env)->ExceptionClear(env);
	}
}
JNIEXPORT jlong JNICALL Java_com_phidget22_CurrentInputBase_create(JNIEnv * env, jclass obj) {
	PhidgetCurrentInputHandle phid;
	int error; 
	if ((error = PhidgetCurrentInput_create(&phid)) != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(error);
		return 0;
	}
	return (jlong)(uintptr_t)phid;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_CurrentInputBase_getCurrent(JNIEnv * env, jobject obj) {
	PhidgetCurrentInputHandle h = (PhidgetCurrentInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double current;
	ret = PhidgetCurrentInput_getCurrent(h, &current);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return current;
	}
	return current;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_CurrentInputBase_getMinCurrent(JNIEnv * env, jobject obj) {
	PhidgetCurrentInputHandle h = (PhidgetCurrentInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minCurrent;
	ret = PhidgetCurrentInput_getMinCurrent(h, &minCurrent);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minCurrent;
	}
	return minCurrent;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_CurrentInputBase_getMaxCurrent(JNIEnv * env, jobject obj) {
	PhidgetCurrentInputHandle h = (PhidgetCurrentInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxCurrent;
	ret = PhidgetCurrentInput_getMaxCurrent(h, &maxCurrent);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxCurrent;
	}
	return maxCurrent;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_CurrentInputBase_getCurrentChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetCurrentInputHandle h = (PhidgetCurrentInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double currentChangeTrigger;
	ret = PhidgetCurrentInput_getCurrentChangeTrigger(h, &currentChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return currentChangeTrigger;
	}
	return currentChangeTrigger;
}

JNIEXPORT void JNICALL Java_com_phidget22_CurrentInputBase_setCurrentChangeTrigger(JNIEnv * env, jobject obj, jdouble currentChangeTrigger) {
	PhidgetCurrentInputHandle h = (PhidgetCurrentInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetCurrentInput_setCurrentChangeTrigger(h, (double)currentChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_CurrentInputBase_getMinCurrentChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetCurrentInputHandle h = (PhidgetCurrentInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minCurrentChangeTrigger;
	ret = PhidgetCurrentInput_getMinCurrentChangeTrigger(h, &minCurrentChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minCurrentChangeTrigger;
	}
	return minCurrentChangeTrigger;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_CurrentInputBase_getMaxCurrentChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetCurrentInputHandle h = (PhidgetCurrentInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxCurrentChangeTrigger;
	ret = PhidgetCurrentInput_getMaxCurrentChangeTrigger(h, &maxCurrentChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxCurrentChangeTrigger;
	}
	return maxCurrentChangeTrigger;
}

JNIEXPORT jint JNICALL Java_com_phidget22_CurrentInputBase_getDataInterval(JNIEnv * env, jobject obj) {
	PhidgetCurrentInputHandle h = (PhidgetCurrentInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t dataInterval;
	ret = PhidgetCurrentInput_getDataInterval(h, &dataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return dataInterval;
	}
	return dataInterval;
}

JNIEXPORT void JNICALL Java_com_phidget22_CurrentInputBase_setDataInterval(JNIEnv * env, jobject obj, jint dataInterval) {
	PhidgetCurrentInputHandle h = (PhidgetCurrentInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetCurrentInput_setDataInterval(h, (uint32_t)dataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jint JNICALL Java_com_phidget22_CurrentInputBase_getMinDataInterval(JNIEnv * env, jobject obj) {
	PhidgetCurrentInputHandle h = (PhidgetCurrentInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t minDataInterval;
	ret = PhidgetCurrentInput_getMinDataInterval(h, &minDataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minDataInterval;
	}
	return minDataInterval;
}

JNIEXPORT jint JNICALL Java_com_phidget22_CurrentInputBase_getMaxDataInterval(JNIEnv * env, jobject obj) {
	PhidgetCurrentInputHandle h = (PhidgetCurrentInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t maxDataInterval;
	ret = PhidgetCurrentInput_getMaxDataInterval(h, &maxDataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxDataInterval;
	}
	return maxDataInterval;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_CurrentInputBase_getDataRate(JNIEnv * env, jobject obj) {
	PhidgetCurrentInputHandle h = (PhidgetCurrentInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double dataRate;
	ret = PhidgetCurrentInput_getDataRate(h, &dataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return dataRate;
	}
	return dataRate;
}

JNIEXPORT void JNICALL Java_com_phidget22_CurrentInputBase_setDataRate(JNIEnv * env, jobject obj, jdouble dataRate) {
	PhidgetCurrentInputHandle h = (PhidgetCurrentInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetCurrentInput_setDataRate(h, (double)dataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_CurrentInputBase_getMinDataRate(JNIEnv * env, jobject obj) {
	PhidgetCurrentInputHandle h = (PhidgetCurrentInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minDataRate;
	ret = PhidgetCurrentInput_getMinDataRate(h, &minDataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minDataRate;
	}
	return minDataRate;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_CurrentInputBase_getMaxDataRate(JNIEnv * env, jobject obj) {
	PhidgetCurrentInputHandle h = (PhidgetCurrentInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxDataRate;
	ret = PhidgetCurrentInput_getMaxDataRate(h, &maxDataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxDataRate;
	}
	return maxDataRate;
}

JNIEXPORT jobject JNICALL Java_com_phidget22_CurrentInputBase_getPowerSupply(JNIEnv * env, jobject obj) {
	PhidgetCurrentInputHandle h = (PhidgetCurrentInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	Phidget_PowerSupply powerSupply;
	if (PowerSupply_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/PowerSupply");
	ret = PhidgetCurrentInput_getPowerSupply(h, &powerSupply);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return NULL;
	}
	return (*env)->CallStaticObjectMethod(env, PowerSupply_class, PowerSupply_getEnum_mid, powerSupply);
}

JNIEXPORT void JNICALL Java_com_phidget22_CurrentInputBase_setPowerSupply(JNIEnv * env, jobject obj, jobject powerSupply) {
	PhidgetCurrentInputHandle h = (PhidgetCurrentInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	if (PowerSupply_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/PowerSupply");
	ret = PhidgetCurrentInput_setPowerSupply(h, (Phidget_PowerSupply)(*env)->CallIntMethod(env, powerSupply, PowerSupply_getCode_mid));
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

static void CCONV currentChange_handler(PhidgetCurrentInputHandle h, void *arg, double current) {
	jobject currentChangeEv;
	JNIEnv *env;
	jobject obj;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;

	if ((currentChangeEv = (*env)->NewObject(env, currentChangeEvent_class, currentChangeEvent_cons, obj, current)) != 0) {
		(*env)->CallVoidMethod(env, obj, fireCurrentChange_mid, currentChangeEv);
		(*env)->DeleteLocalRef(env, currentChangeEv);
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_CurrentInputBase_enableCurrentChangeEvents(JNIEnv * env, jobject obj, jboolean b) {
	if (currentChangeEvent_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/CurrentInputCurrentChangeEvent");
	jlong gr = updateGlobalRef(env, obj, nativeCurrentChangeHandler_fid, b);
	PhidgetCurrentInputHandle h = (PhidgetCurrentInputHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetCurrentInput_setOnCurrentChangeHandler(h, b ? currentChange_handler : NULL, (void *)(uintptr_t) gr);
}
