/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of libphidget22java
 *
 * Copyright (c) 2017-2022 Phidgets Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

#include "phidget_jni.h"
#include "com_phidget22_DictionaryBase.h"

static jclass dictionarybase_class;
jclass dictionary_class;
jmethodID dictionary_cons;

static jclass addEvent_class;
static jmethodID fireAdd_mid	;
static jmethodID addEvent_cons;
static jfieldID nativeAddHandler_fid;

static jclass updateEvent_class;
static jmethodID fireUpdate_mid	;
static jmethodID updateEvent_cons;
static jfieldID nativeUpdateHandler_fid;

static jclass removeEvent_class;
static jmethodID fireRemove_mid	;
static jmethodID removeEvent_cons;
static jfieldID nativeRemoveHandler_fid;

void com_phidget22_DictionaryBase_OnLoad(JNIEnv *env) {
	if (!(dictionary_class = (*env)->FindClass(env, "com/phidget22/Dictionary"))) {
		(*env)->ExceptionClear(env);
		return;
	}
	if (!(dictionary_class = (jclass)(*env)->NewGlobalRef(env, dictionary_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef dictionary_class");
	if (!(dictionary_cons = (*env)->GetMethodID(env, dictionary_class, "<init>", "(J)V")))
		JNI_ABORT_STDERR("Couldn't get Method ID <init> from dictionary_class");

	if (!(dictionarybase_class = (*env)->FindClass(env, "com/phidget22/DictionaryBase")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/DictionaryBase");
	if (!(dictionarybase_class = (jclass)(*env)->NewGlobalRef(env, dictionarybase_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef dictionarybase_class");

	if ((addEvent_class = (*env)->FindClass(env, "com/phidget22/DictionaryAddEvent"))) {
		if (!(addEvent_class = (jclass)(*env)->NewGlobalRef(env, addEvent_class)))
			JNI_ABORT_STDERR("Couldn't create global ref AddEvent_class");
		if (!(fireAdd_mid = (*env)->GetMethodID(env, dictionarybase_class, "fireAdd", "(Lcom/phidget22/DictionaryAddEvent;)V")))
			JNI_ABORT_STDERR("Couldn't get method ID fireAdd");
		if (!(addEvent_cons = (*env)->GetMethodID(env, addEvent_class, "<init>", "(Lcom/phidget22/Dictionary;Ljava/lang/String;Ljava/lang/String;)V")))
			JNI_ABORT_STDERR("Couldn't get method ID <init> from AddEvent_class");
		if (!(nativeAddHandler_fid = (*env)->GetFieldID(env, dictionarybase_class, "nativeAddHandler", "J")))
			JNI_ABORT_STDERR("Couldn't get Field ID nativeAddHandler from dictionarybase_class");
	} else {
		(*env)->ExceptionClear(env);
	}

	if ((updateEvent_class = (*env)->FindClass(env, "com/phidget22/DictionaryUpdateEvent"))) {
		if (!(updateEvent_class = (jclass)(*env)->NewGlobalRef(env, updateEvent_class)))
			JNI_ABORT_STDERR("Couldn't create global ref UpdateEvent_class");
		if (!(fireUpdate_mid = (*env)->GetMethodID(env, dictionarybase_class, "fireUpdate", "(Lcom/phidget22/DictionaryUpdateEvent;)V")))
			JNI_ABORT_STDERR("Couldn't get method ID fireUpdate");
		if (!(updateEvent_cons = (*env)->GetMethodID(env, updateEvent_class, "<init>", "(Lcom/phidget22/Dictionary;Ljava/lang/String;Ljava/lang/String;)V")))
			JNI_ABORT_STDERR("Couldn't get method ID <init> from UpdateEvent_class");
		if (!(nativeUpdateHandler_fid = (*env)->GetFieldID(env, dictionarybase_class, "nativeUpdateHandler", "J")))
			JNI_ABORT_STDERR("Couldn't get Field ID nativeUpdateHandler from dictionarybase_class");
	} else {
		(*env)->ExceptionClear(env);
	}

	if ((removeEvent_class = (*env)->FindClass(env, "com/phidget22/DictionaryRemoveEvent"))) {
		if (!(removeEvent_class = (jclass)(*env)->NewGlobalRef(env, removeEvent_class)))
			JNI_ABORT_STDERR("Couldn't create global ref RemoveEvent_class");
		if (!(fireRemove_mid = (*env)->GetMethodID(env, dictionarybase_class, "fireRemove", "(Lcom/phidget22/DictionaryRemoveEvent;)V")))
			JNI_ABORT_STDERR("Couldn't get method ID fireRemove");
		if (!(removeEvent_cons = (*env)->GetMethodID(env, removeEvent_class, "<init>", "(Lcom/phidget22/Dictionary;Ljava/lang/String;)V")))
			JNI_ABORT_STDERR("Couldn't get method ID <init> from RemoveEvent_class");
		if (!(nativeRemoveHandler_fid = (*env)->GetFieldID(env, dictionarybase_class, "nativeRemoveHandler", "J")))
			JNI_ABORT_STDERR("Couldn't get Field ID nativeRemoveHandler from dictionarybase_class");
	} else {
		(*env)->ExceptionClear(env);
	}
}
JNIEXPORT jlong JNICALL Java_com_phidget22_DictionaryBase_create(JNIEnv * env, jclass obj) {
	PhidgetDictionaryHandle phid;
	int error; 
	if ((error = PhidgetDictionary_create(&phid)) != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(error);
		return 0;
	}
	return (jlong)(uintptr_t)phid;
}

JNIEXPORT void JNICALL Java_com_phidget22_DictionaryBase_add(JNIEnv * env, jobject obj, jstring key, jstring value) {
	PhidgetDictionaryHandle h = (PhidgetDictionaryHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	const char *keyUTFChars = (key == NULL ? NULL : (*env)->GetStringUTFChars(env, key, NULL));
	const char *valueUTFChars = (value == NULL ? NULL : (*env)->GetStringUTFChars(env, value, NULL));
	ret = PhidgetDictionary_add(h, (const char *)keyUTFChars, (const char *)valueUTFChars);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		if (keyUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, key, keyUTFChars);
		if (valueUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, value, valueUTFChars);
		return;
	}
	if (keyUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, key, keyUTFChars);
	if (valueUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, value, valueUTFChars);
}

JNIEXPORT void JNICALL Java_com_phidget22_DictionaryBase_removeAll(JNIEnv * env, jobject obj) {
	PhidgetDictionaryHandle h = (PhidgetDictionaryHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetDictionary_removeAll(h);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_DictionaryBase_remove(JNIEnv * env, jobject obj, jstring key) {
	PhidgetDictionaryHandle h = (PhidgetDictionaryHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	const char *keyUTFChars = (key == NULL ? NULL : (*env)->GetStringUTFChars(env, key, NULL));
	ret = PhidgetDictionary_remove(h, (const char *)keyUTFChars);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		if (keyUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, key, keyUTFChars);
		return;
	}
	if (keyUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, key, keyUTFChars);
}

JNIEXPORT void JNICALL Java_com_phidget22_DictionaryBase_set(JNIEnv * env, jobject obj, jstring key, jstring value) {
	PhidgetDictionaryHandle h = (PhidgetDictionaryHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	const char *keyUTFChars = (key == NULL ? NULL : (*env)->GetStringUTFChars(env, key, NULL));
	const char *valueUTFChars = (value == NULL ? NULL : (*env)->GetStringUTFChars(env, value, NULL));
	ret = PhidgetDictionary_set(h, (const char *)keyUTFChars, (const char *)valueUTFChars);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		if (keyUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, key, keyUTFChars);
		if (valueUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, value, valueUTFChars);
		return;
	}
	if (keyUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, key, keyUTFChars);
	if (valueUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, value, valueUTFChars);
}

JNIEXPORT jstring JNICALL Java_com_phidget22_DictionaryBase_sscan(JNIEnv * env, jobject obj, jstring start) {
	PhidgetDictionaryHandle h = (PhidgetDictionaryHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	const char *startUTFChars = (start == NULL ? NULL : (*env)->GetStringUTFChars(env, start, NULL));
	char keyList[65536];
	size_t keyListLen = 65536;
	ret = PhidgetDictionary_scan(h, (const char *)startUTFChars, keyList, (size_t)keyListLen);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		if (startUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, start, startUTFChars);
		return NULL;
	}
	if (startUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, start, startUTFChars);
	return (*env)->NewStringUTF(env, keyList);
}

JNIEXPORT void JNICALL Java_com_phidget22_DictionaryBase_update(JNIEnv * env, jobject obj, jstring key, jstring value) {
	PhidgetDictionaryHandle h = (PhidgetDictionaryHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	const char *keyUTFChars = (key == NULL ? NULL : (*env)->GetStringUTFChars(env, key, NULL));
	const char *valueUTFChars = (value == NULL ? NULL : (*env)->GetStringUTFChars(env, value, NULL));
	ret = PhidgetDictionary_update(h, (const char *)keyUTFChars, (const char *)valueUTFChars);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		if (keyUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, key, keyUTFChars);
		if (valueUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, value, valueUTFChars);
		return;
	}
	if (keyUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, key, keyUTFChars);
	if (valueUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, value, valueUTFChars);
}

static void CCONV add_handler(PhidgetDictionaryHandle h, void *arg, const char * key, const char * value) {
	jobject addEv;
	JNIEnv *env;
	jobject obj;
	jstring keyStr;
	jstring valueStr;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;
	keyStr = (*env)->NewStringUTF(env, key);
	valueStr = (*env)->NewStringUTF(env, value);

	if ((addEv = (*env)->NewObject(env, addEvent_class, addEvent_cons, obj, keyStr, valueStr)) != 0) {
		(*env)->CallVoidMethod(env, obj, fireAdd_mid, addEv);
		(*env)->DeleteLocalRef(env, addEv);
	}
	(*env)->DeleteLocalRef(env, keyStr);
	(*env)->DeleteLocalRef(env, valueStr);
}

JNIEXPORT void JNICALL Java_com_phidget22_DictionaryBase_enableAddEvents(JNIEnv * env, jobject obj, jboolean b) {
	if (addEvent_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/DictionaryAddEvent");
	jlong gr = updateGlobalRef(env, obj, nativeAddHandler_fid, b);
	PhidgetDictionaryHandle h = (PhidgetDictionaryHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetDictionary_setOnAddHandler(h, b ? add_handler : NULL, (void *)(uintptr_t) gr);
}

static void CCONV remove_handler(PhidgetDictionaryHandle h, void *arg, const char * key) {
	jobject removeEv;
	JNIEnv *env;
	jobject obj;
	jstring keyStr;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;
	keyStr = (*env)->NewStringUTF(env, key);

	if ((removeEv = (*env)->NewObject(env, removeEvent_class, removeEvent_cons, obj, keyStr)) != 0) {
		(*env)->CallVoidMethod(env, obj, fireRemove_mid, removeEv);
		(*env)->DeleteLocalRef(env, removeEv);
	}
	(*env)->DeleteLocalRef(env, keyStr);
}

JNIEXPORT void JNICALL Java_com_phidget22_DictionaryBase_enableRemoveEvents(JNIEnv * env, jobject obj, jboolean b) {
	if (removeEvent_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/DictionaryRemoveEvent");
	jlong gr = updateGlobalRef(env, obj, nativeRemoveHandler_fid, b);
	PhidgetDictionaryHandle h = (PhidgetDictionaryHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetDictionary_setOnRemoveHandler(h, b ? remove_handler : NULL, (void *)(uintptr_t) gr);
}

static void CCONV update_handler(PhidgetDictionaryHandle h, void *arg, const char * key, const char * value) {
	jobject updateEv;
	JNIEnv *env;
	jobject obj;
	jstring keyStr;
	jstring valueStr;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;
	keyStr = (*env)->NewStringUTF(env, key);
	valueStr = (*env)->NewStringUTF(env, value);

	if ((updateEv = (*env)->NewObject(env, updateEvent_class, updateEvent_cons, obj, keyStr, valueStr)) != 0) {
		(*env)->CallVoidMethod(env, obj, fireUpdate_mid, updateEv);
		(*env)->DeleteLocalRef(env, updateEv);
	}
	(*env)->DeleteLocalRef(env, keyStr);
	(*env)->DeleteLocalRef(env, valueStr);
}

JNIEXPORT void JNICALL Java_com_phidget22_DictionaryBase_enableUpdateEvents(JNIEnv * env, jobject obj, jboolean b) {
	if (updateEvent_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/DictionaryUpdateEvent");
	jlong gr = updateGlobalRef(env, obj, nativeUpdateHandler_fid, b);
	PhidgetDictionaryHandle h = (PhidgetDictionaryHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetDictionary_setOnUpdateHandler(h, b ? update_handler : NULL, (void *)(uintptr_t) gr);
}
