/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of libphidget22java
 *
 * Copyright (c) 2017-2022 Phidgets Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

#include "phidget_jni.h"
#include "com_phidget22_DigitalInputBase.h"

static jclass digitalInputbase_class;
jclass digitalInput_class;
jmethodID digitalInput_cons;

static jclass stateChangeEvent_class;
static jmethodID fireStateChange_mid	;
static jmethodID stateChangeEvent_cons;
static jfieldID nativeStateChangeHandler_fid;

void com_phidget22_DigitalInputBase_OnLoad(JNIEnv *env) {
	if (!(digitalInput_class = (*env)->FindClass(env, "com/phidget22/DigitalInput"))) {
		(*env)->ExceptionClear(env);
		return;
	}
	if (!(digitalInput_class = (jclass)(*env)->NewGlobalRef(env, digitalInput_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef digitalInput_class");
	if (!(digitalInput_cons = (*env)->GetMethodID(env, digitalInput_class, "<init>", "(J)V")))
		JNI_ABORT_STDERR("Couldn't get Method ID <init> from digitalInput_class");

	if (!(digitalInputbase_class = (*env)->FindClass(env, "com/phidget22/DigitalInputBase")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/DigitalInputBase");
	if (!(digitalInputbase_class = (jclass)(*env)->NewGlobalRef(env, digitalInputbase_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef digitalInputbase_class");

	if ((stateChangeEvent_class = (*env)->FindClass(env, "com/phidget22/DigitalInputStateChangeEvent"))) {
		if (!(stateChangeEvent_class = (jclass)(*env)->NewGlobalRef(env, stateChangeEvent_class)))
			JNI_ABORT_STDERR("Couldn't create global ref StateChangeEvent_class");
		if (!(fireStateChange_mid = (*env)->GetMethodID(env, digitalInputbase_class, "fireStateChange", "(Lcom/phidget22/DigitalInputStateChangeEvent;)V")))
			JNI_ABORT_STDERR("Couldn't get method ID fireStateChange");
		if (!(stateChangeEvent_cons = (*env)->GetMethodID(env, stateChangeEvent_class, "<init>", "(Lcom/phidget22/DigitalInput;Z)V")))
			JNI_ABORT_STDERR("Couldn't get method ID <init> from StateChangeEvent_class");
		if (!(nativeStateChangeHandler_fid = (*env)->GetFieldID(env, digitalInputbase_class, "nativeStateChangeHandler", "J")))
			JNI_ABORT_STDERR("Couldn't get Field ID nativeStateChangeHandler from digitalInputbase_class");
	} else {
		(*env)->ExceptionClear(env);
	}
}
JNIEXPORT jlong JNICALL Java_com_phidget22_DigitalInputBase_create(JNIEnv * env, jclass obj) {
	PhidgetDigitalInputHandle phid;
	int error; 
	if ((error = PhidgetDigitalInput_create(&phid)) != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(error);
		return 0;
	}
	return (jlong)(uintptr_t)phid;
}

JNIEXPORT jobject JNICALL Java_com_phidget22_DigitalInputBase_getInputMode(JNIEnv * env, jobject obj) {
	PhidgetDigitalInputHandle h = (PhidgetDigitalInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	Phidget_InputMode inputMode;
	if (InputMode_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/InputMode");
	ret = PhidgetDigitalInput_getInputMode(h, &inputMode);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return NULL;
	}
	return (*env)->CallStaticObjectMethod(env, InputMode_class, InputMode_getEnum_mid, inputMode);
}

JNIEXPORT void JNICALL Java_com_phidget22_DigitalInputBase_setInputMode(JNIEnv * env, jobject obj, jobject inputMode) {
	PhidgetDigitalInputHandle h = (PhidgetDigitalInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	if (InputMode_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/InputMode");
	ret = PhidgetDigitalInput_setInputMode(h, (Phidget_InputMode)(*env)->CallIntMethod(env, inputMode, InputMode_getCode_mid));
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jobject JNICALL Java_com_phidget22_DigitalInputBase_getPowerSupply(JNIEnv * env, jobject obj) {
	PhidgetDigitalInputHandle h = (PhidgetDigitalInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	Phidget_PowerSupply powerSupply;
	if (PowerSupply_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/PowerSupply");
	ret = PhidgetDigitalInput_getPowerSupply(h, &powerSupply);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return NULL;
	}
	return (*env)->CallStaticObjectMethod(env, PowerSupply_class, PowerSupply_getEnum_mid, powerSupply);
}

JNIEXPORT void JNICALL Java_com_phidget22_DigitalInputBase_setPowerSupply(JNIEnv * env, jobject obj, jobject powerSupply) {
	PhidgetDigitalInputHandle h = (PhidgetDigitalInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	if (PowerSupply_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/PowerSupply");
	ret = PhidgetDigitalInput_setPowerSupply(h, (Phidget_PowerSupply)(*env)->CallIntMethod(env, powerSupply, PowerSupply_getCode_mid));
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jboolean JNICALL Java_com_phidget22_DigitalInputBase_getState(JNIEnv * env, jobject obj) {
	PhidgetDigitalInputHandle h = (PhidgetDigitalInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	int state;
	ret = PhidgetDigitalInput_getState(h, &state);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return state;
	}
	return state;
}

static void CCONV stateChange_handler(PhidgetDigitalInputHandle h, void *arg, int state) {
	jobject stateChangeEv;
	JNIEnv *env;
	jobject obj;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;

	if ((stateChangeEv = (*env)->NewObject(env, stateChangeEvent_class, stateChangeEvent_cons, obj, state)) != 0) {
		(*env)->CallVoidMethod(env, obj, fireStateChange_mid, stateChangeEv);
		(*env)->DeleteLocalRef(env, stateChangeEv);
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_DigitalInputBase_enableStateChangeEvents(JNIEnv * env, jobject obj, jboolean b) {
	if (stateChangeEvent_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/DigitalInputStateChangeEvent");
	jlong gr = updateGlobalRef(env, obj, nativeStateChangeHandler_fid, b);
	PhidgetDigitalInputHandle h = (PhidgetDigitalInputHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetDigitalInput_setOnStateChangeHandler(h, b ? stateChange_handler : NULL, (void *)(uintptr_t) gr);
}
