/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of libphidget22java
 *
 * Copyright (c) 2017-2022 Phidgets Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

#include "phidget_jni.h"
#include "com_phidget22_DigitalOutputBase.h"

static jclass digitalOutputbase_class;
jclass digitalOutput_class;
jmethodID digitalOutput_cons;

void com_phidget22_DigitalOutputBase_OnLoad(JNIEnv *env) {
	if (!(digitalOutput_class = (*env)->FindClass(env, "com/phidget22/DigitalOutput"))) {
		(*env)->ExceptionClear(env);
		return;
	}
	if (!(digitalOutput_class = (jclass)(*env)->NewGlobalRef(env, digitalOutput_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef digitalOutput_class");
	if (!(digitalOutput_cons = (*env)->GetMethodID(env, digitalOutput_class, "<init>", "(J)V")))
		JNI_ABORT_STDERR("Couldn't get Method ID <init> from digitalOutput_class");

	if (!(digitalOutputbase_class = (*env)->FindClass(env, "com/phidget22/DigitalOutputBase")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/DigitalOutputBase");
	if (!(digitalOutputbase_class = (jclass)(*env)->NewGlobalRef(env, digitalOutputbase_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef digitalOutputbase_class");
}
JNIEXPORT jlong JNICALL Java_com_phidget22_DigitalOutputBase_create(JNIEnv * env, jclass obj) {
	PhidgetDigitalOutputHandle phid;
	int error; 
	if ((error = PhidgetDigitalOutput_create(&phid)) != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(error);
		return 0;
	}
	return (jlong)(uintptr_t)phid;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_DigitalOutputBase_getDutyCycle(JNIEnv * env, jobject obj) {
	PhidgetDigitalOutputHandle h = (PhidgetDigitalOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double dutyCycle;
	ret = PhidgetDigitalOutput_getDutyCycle(h, &dutyCycle);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return dutyCycle;
	}
	return dutyCycle;
}

JNIEXPORT void JNICALL Java_com_phidget22_DigitalOutputBase_setDutyCycle__DLcom_phidget22_AsyncListener_2(JNIEnv * env, jobject obj, jdouble dutyCycle, jobject asyncHandler) {
	PhidgetDigitalOutputHandle h = (PhidgetDigitalOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	jclass obj_class = (*env)->FindClass(env, "Ljava/lang/Object;");
	jobjectArray arr = (*env)->NewObjectArray(env, 2, obj_class, NULL);
	(*env)->SetObjectArrayElement(env, arr, 0, obj);
	(*env)->SetObjectArrayElement(env, arr, 1, asyncHandler);
	PhidgetDigitalOutput_setDutyCycle_async(h, (double)dutyCycle, asyncCallbackHandler, (*env)->NewGlobalRef(env, arr));
	(*env)->DeleteLocalRef(env, arr);
}

JNIEXPORT void JNICALL Java_com_phidget22_DigitalOutputBase_setDutyCycle__D(JNIEnv * env, jobject obj, jdouble dutyCycle) {
	PhidgetDigitalOutputHandle h = (PhidgetDigitalOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetDigitalOutput_setDutyCycle(h, (double)dutyCycle);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_DigitalOutputBase_getMinDutyCycle(JNIEnv * env, jobject obj) {
	PhidgetDigitalOutputHandle h = (PhidgetDigitalOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minDutyCycle;
	ret = PhidgetDigitalOutput_getMinDutyCycle(h, &minDutyCycle);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minDutyCycle;
	}
	return minDutyCycle;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_DigitalOutputBase_getMaxDutyCycle(JNIEnv * env, jobject obj) {
	PhidgetDigitalOutputHandle h = (PhidgetDigitalOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxDutyCycle;
	ret = PhidgetDigitalOutput_getMaxDutyCycle(h, &maxDutyCycle);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxDutyCycle;
	}
	return maxDutyCycle;
}

JNIEXPORT void JNICALL Java_com_phidget22_DigitalOutputBase_enableFailsafe(JNIEnv * env, jobject obj, jint failsafeTime) {
	PhidgetDigitalOutputHandle h = (PhidgetDigitalOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetDigitalOutput_enableFailsafe(h, (uint32_t)failsafeTime);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jint JNICALL Java_com_phidget22_DigitalOutputBase_getMinFailsafeTime(JNIEnv * env, jobject obj) {
	PhidgetDigitalOutputHandle h = (PhidgetDigitalOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t minFailsafeTime;
	ret = PhidgetDigitalOutput_getMinFailsafeTime(h, &minFailsafeTime);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minFailsafeTime;
	}
	return minFailsafeTime;
}

JNIEXPORT jint JNICALL Java_com_phidget22_DigitalOutputBase_getMaxFailsafeTime(JNIEnv * env, jobject obj) {
	PhidgetDigitalOutputHandle h = (PhidgetDigitalOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t maxFailsafeTime;
	ret = PhidgetDigitalOutput_getMaxFailsafeTime(h, &maxFailsafeTime);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxFailsafeTime;
	}
	return maxFailsafeTime;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_DigitalOutputBase_getFrequency(JNIEnv * env, jobject obj) {
	PhidgetDigitalOutputHandle h = (PhidgetDigitalOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double frequency;
	ret = PhidgetDigitalOutput_getFrequency(h, &frequency);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return frequency;
	}
	return frequency;
}

JNIEXPORT void JNICALL Java_com_phidget22_DigitalOutputBase_setFrequency(JNIEnv * env, jobject obj, jdouble frequency) {
	PhidgetDigitalOutputHandle h = (PhidgetDigitalOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetDigitalOutput_setFrequency(h, (double)frequency);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_DigitalOutputBase_getMinFrequency(JNIEnv * env, jobject obj) {
	PhidgetDigitalOutputHandle h = (PhidgetDigitalOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minFrequency;
	ret = PhidgetDigitalOutput_getMinFrequency(h, &minFrequency);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minFrequency;
	}
	return minFrequency;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_DigitalOutputBase_getMaxFrequency(JNIEnv * env, jobject obj) {
	PhidgetDigitalOutputHandle h = (PhidgetDigitalOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxFrequency;
	ret = PhidgetDigitalOutput_getMaxFrequency(h, &maxFrequency);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxFrequency;
	}
	return maxFrequency;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_DigitalOutputBase_getLEDCurrentLimit(JNIEnv * env, jobject obj) {
	PhidgetDigitalOutputHandle h = (PhidgetDigitalOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double LEDCurrentLimit;
	ret = PhidgetDigitalOutput_getLEDCurrentLimit(h, &LEDCurrentLimit);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return LEDCurrentLimit;
	}
	return LEDCurrentLimit;
}

JNIEXPORT void JNICALL Java_com_phidget22_DigitalOutputBase_setLEDCurrentLimit__D(JNIEnv * env, jobject obj, jdouble LEDCurrentLimit) {
	PhidgetDigitalOutputHandle h = (PhidgetDigitalOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetDigitalOutput_setLEDCurrentLimit(h, (double)LEDCurrentLimit);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_DigitalOutputBase_setLEDCurrentLimit__DLcom_phidget22_AsyncListener_2(JNIEnv * env, jobject obj, jdouble LEDCurrentLimit, jobject asyncHandler) {
	PhidgetDigitalOutputHandle h = (PhidgetDigitalOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	jclass obj_class = (*env)->FindClass(env, "Ljava/lang/Object;");
	jobjectArray arr = (*env)->NewObjectArray(env, 2, obj_class, NULL);
	(*env)->SetObjectArrayElement(env, arr, 0, obj);
	(*env)->SetObjectArrayElement(env, arr, 1, asyncHandler);
	PhidgetDigitalOutput_setLEDCurrentLimit_async(h, (double)LEDCurrentLimit, asyncCallbackHandler, (*env)->NewGlobalRef(env, arr));
	(*env)->DeleteLocalRef(env, arr);
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_DigitalOutputBase_getMinLEDCurrentLimit(JNIEnv * env, jobject obj) {
	PhidgetDigitalOutputHandle h = (PhidgetDigitalOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minLEDCurrentLimit;
	ret = PhidgetDigitalOutput_getMinLEDCurrentLimit(h, &minLEDCurrentLimit);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minLEDCurrentLimit;
	}
	return minLEDCurrentLimit;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_DigitalOutputBase_getMaxLEDCurrentLimit(JNIEnv * env, jobject obj) {
	PhidgetDigitalOutputHandle h = (PhidgetDigitalOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxLEDCurrentLimit;
	ret = PhidgetDigitalOutput_getMaxLEDCurrentLimit(h, &maxLEDCurrentLimit);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxLEDCurrentLimit;
	}
	return maxLEDCurrentLimit;
}

JNIEXPORT jobject JNICALL Java_com_phidget22_DigitalOutputBase_getLEDForwardVoltage(JNIEnv * env, jobject obj) {
	PhidgetDigitalOutputHandle h = (PhidgetDigitalOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	PhidgetDigitalOutput_LEDForwardVoltage LEDForwardVoltage;
	if (LEDForwardVoltage_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/LEDForwardVoltage");
	ret = PhidgetDigitalOutput_getLEDForwardVoltage(h, &LEDForwardVoltage);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return NULL;
	}
	return (*env)->CallStaticObjectMethod(env, LEDForwardVoltage_class, LEDForwardVoltage_getEnum_mid, LEDForwardVoltage);
}

JNIEXPORT void JNICALL Java_com_phidget22_DigitalOutputBase_setLEDForwardVoltage(JNIEnv * env, jobject obj, jobject LEDForwardVoltage) {
	PhidgetDigitalOutputHandle h = (PhidgetDigitalOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	if (LEDForwardVoltage_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/LEDForwardVoltage");
	ret = PhidgetDigitalOutput_setLEDForwardVoltage(h, (PhidgetDigitalOutput_LEDForwardVoltage)(*env)->CallIntMethod(env, LEDForwardVoltage, LEDForwardVoltage_getCode_mid));
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_DigitalOutputBase_resetFailsafe(JNIEnv * env, jobject obj) {
	PhidgetDigitalOutputHandle h = (PhidgetDigitalOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetDigitalOutput_resetFailsafe(h);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jboolean JNICALL Java_com_phidget22_DigitalOutputBase_getState(JNIEnv * env, jobject obj) {
	PhidgetDigitalOutputHandle h = (PhidgetDigitalOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	int state;
	ret = PhidgetDigitalOutput_getState(h, &state);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return state;
	}
	return state;
}

JNIEXPORT void JNICALL Java_com_phidget22_DigitalOutputBase_setState__Z(JNIEnv * env, jobject obj, jboolean state) {
	PhidgetDigitalOutputHandle h = (PhidgetDigitalOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetDigitalOutput_setState(h, (int)state);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_DigitalOutputBase_setState__ZLcom_phidget22_AsyncListener_2(JNIEnv * env, jobject obj, jboolean state, jobject asyncHandler) {
	PhidgetDigitalOutputHandle h = (PhidgetDigitalOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	jclass obj_class = (*env)->FindClass(env, "Ljava/lang/Object;");
	jobjectArray arr = (*env)->NewObjectArray(env, 2, obj_class, NULL);
	(*env)->SetObjectArrayElement(env, arr, 0, obj);
	(*env)->SetObjectArrayElement(env, arr, 1, asyncHandler);
	PhidgetDigitalOutput_setState_async(h, (int)state, asyncCallbackHandler, (*env)->NewGlobalRef(env, arr));
	(*env)->DeleteLocalRef(env, arr);
}
