/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of libphidget22java
 *
 * Copyright (c) 2017-2022 Phidgets Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

#include "phidget_jni.h"
#include "com_phidget22_EncoderBase.h"

static jclass encoderbase_class;
jclass encoder_class;
jmethodID encoder_cons;

static jclass positionChangeEvent_class;
static jmethodID firePositionChange_mid	;
static jmethodID positionChangeEvent_cons;
static jfieldID nativePositionChangeHandler_fid;

void com_phidget22_EncoderBase_OnLoad(JNIEnv *env) {
	if (!(encoder_class = (*env)->FindClass(env, "com/phidget22/Encoder"))) {
		(*env)->ExceptionClear(env);
		return;
	}
	if (!(encoder_class = (jclass)(*env)->NewGlobalRef(env, encoder_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef encoder_class");
	if (!(encoder_cons = (*env)->GetMethodID(env, encoder_class, "<init>", "(J)V")))
		JNI_ABORT_STDERR("Couldn't get Method ID <init> from encoder_class");

	if (!(encoderbase_class = (*env)->FindClass(env, "com/phidget22/EncoderBase")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/EncoderBase");
	if (!(encoderbase_class = (jclass)(*env)->NewGlobalRef(env, encoderbase_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef encoderbase_class");

	if ((positionChangeEvent_class = (*env)->FindClass(env, "com/phidget22/EncoderPositionChangeEvent"))) {
		if (!(positionChangeEvent_class = (jclass)(*env)->NewGlobalRef(env, positionChangeEvent_class)))
			JNI_ABORT_STDERR("Couldn't create global ref PositionChangeEvent_class");
		if (!(firePositionChange_mid = (*env)->GetMethodID(env, encoderbase_class, "firePositionChange", "(Lcom/phidget22/EncoderPositionChangeEvent;)V")))
			JNI_ABORT_STDERR("Couldn't get method ID firePositionChange");
		if (!(positionChangeEvent_cons = (*env)->GetMethodID(env, positionChangeEvent_class, "<init>", "(Lcom/phidget22/Encoder;IDZ)V")))
			JNI_ABORT_STDERR("Couldn't get method ID <init> from PositionChangeEvent_class");
		if (!(nativePositionChangeHandler_fid = (*env)->GetFieldID(env, encoderbase_class, "nativePositionChangeHandler", "J")))
			JNI_ABORT_STDERR("Couldn't get Field ID nativePositionChangeHandler from encoderbase_class");
	} else {
		(*env)->ExceptionClear(env);
	}
}
JNIEXPORT jlong JNICALL Java_com_phidget22_EncoderBase_create(JNIEnv * env, jclass obj) {
	PhidgetEncoderHandle phid;
	int error; 
	if ((error = PhidgetEncoder_create(&phid)) != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(error);
		return 0;
	}
	return (jlong)(uintptr_t)phid;
}

JNIEXPORT void JNICALL Java_com_phidget22_EncoderBase_setEnabled(JNIEnv * env, jobject obj, jboolean enabled) {
	PhidgetEncoderHandle h = (PhidgetEncoderHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetEncoder_setEnabled(h, (int)enabled);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jboolean JNICALL Java_com_phidget22_EncoderBase_getEnabled(JNIEnv * env, jobject obj) {
	PhidgetEncoderHandle h = (PhidgetEncoderHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	int enabled;
	ret = PhidgetEncoder_getEnabled(h, &enabled);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return enabled;
	}
	return enabled;
}

JNIEXPORT jint JNICALL Java_com_phidget22_EncoderBase_getDataInterval(JNIEnv * env, jobject obj) {
	PhidgetEncoderHandle h = (PhidgetEncoderHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t dataInterval;
	ret = PhidgetEncoder_getDataInterval(h, &dataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return dataInterval;
	}
	return dataInterval;
}

JNIEXPORT void JNICALL Java_com_phidget22_EncoderBase_setDataInterval(JNIEnv * env, jobject obj, jint dataInterval) {
	PhidgetEncoderHandle h = (PhidgetEncoderHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetEncoder_setDataInterval(h, (uint32_t)dataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jint JNICALL Java_com_phidget22_EncoderBase_getMinDataInterval(JNIEnv * env, jobject obj) {
	PhidgetEncoderHandle h = (PhidgetEncoderHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t minDataInterval;
	ret = PhidgetEncoder_getMinDataInterval(h, &minDataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minDataInterval;
	}
	return minDataInterval;
}

JNIEXPORT jint JNICALL Java_com_phidget22_EncoderBase_getMaxDataInterval(JNIEnv * env, jobject obj) {
	PhidgetEncoderHandle h = (PhidgetEncoderHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t maxDataInterval;
	ret = PhidgetEncoder_getMaxDataInterval(h, &maxDataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxDataInterval;
	}
	return maxDataInterval;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_EncoderBase_getDataRate(JNIEnv * env, jobject obj) {
	PhidgetEncoderHandle h = (PhidgetEncoderHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double dataRate;
	ret = PhidgetEncoder_getDataRate(h, &dataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return dataRate;
	}
	return dataRate;
}

JNIEXPORT void JNICALL Java_com_phidget22_EncoderBase_setDataRate(JNIEnv * env, jobject obj, jdouble dataRate) {
	PhidgetEncoderHandle h = (PhidgetEncoderHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetEncoder_setDataRate(h, (double)dataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_EncoderBase_getMinDataRate(JNIEnv * env, jobject obj) {
	PhidgetEncoderHandle h = (PhidgetEncoderHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minDataRate;
	ret = PhidgetEncoder_getMinDataRate(h, &minDataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minDataRate;
	}
	return minDataRate;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_EncoderBase_getMaxDataRate(JNIEnv * env, jobject obj) {
	PhidgetEncoderHandle h = (PhidgetEncoderHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxDataRate;
	ret = PhidgetEncoder_getMaxDataRate(h, &maxDataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxDataRate;
	}
	return maxDataRate;
}

JNIEXPORT jlong JNICALL Java_com_phidget22_EncoderBase_getIndexPosition(JNIEnv * env, jobject obj) {
	PhidgetEncoderHandle h = (PhidgetEncoderHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	int64_t indexPosition;
	ret = PhidgetEncoder_getIndexPosition(h, &indexPosition);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return indexPosition;
	}
	return indexPosition;
}

JNIEXPORT jobject JNICALL Java_com_phidget22_EncoderBase_getIOMode(JNIEnv * env, jobject obj) {
	PhidgetEncoderHandle h = (PhidgetEncoderHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	Phidget_EncoderIOMode IOMode;
	if (EncoderIOMode_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/EncoderIOMode");
	ret = PhidgetEncoder_getIOMode(h, &IOMode);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return NULL;
	}
	return (*env)->CallStaticObjectMethod(env, EncoderIOMode_class, EncoderIOMode_getEnum_mid, IOMode);
}

JNIEXPORT void JNICALL Java_com_phidget22_EncoderBase_setIOMode(JNIEnv * env, jobject obj, jobject IOMode) {
	PhidgetEncoderHandle h = (PhidgetEncoderHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	if (EncoderIOMode_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/EncoderIOMode");
	ret = PhidgetEncoder_setIOMode(h, (Phidget_EncoderIOMode)(*env)->CallIntMethod(env, IOMode, EncoderIOMode_getCode_mid));
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jlong JNICALL Java_com_phidget22_EncoderBase_getPosition(JNIEnv * env, jobject obj) {
	PhidgetEncoderHandle h = (PhidgetEncoderHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	int64_t position;
	ret = PhidgetEncoder_getPosition(h, &position);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return position;
	}
	return position;
}

JNIEXPORT void JNICALL Java_com_phidget22_EncoderBase_setPosition(JNIEnv * env, jobject obj, jlong position) {
	PhidgetEncoderHandle h = (PhidgetEncoderHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetEncoder_setPosition(h, (int64_t)position);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jint JNICALL Java_com_phidget22_EncoderBase_getPositionChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetEncoderHandle h = (PhidgetEncoderHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t positionChangeTrigger;
	ret = PhidgetEncoder_getPositionChangeTrigger(h, &positionChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return positionChangeTrigger;
	}
	return positionChangeTrigger;
}

JNIEXPORT void JNICALL Java_com_phidget22_EncoderBase_setPositionChangeTrigger(JNIEnv * env, jobject obj, jint positionChangeTrigger) {
	PhidgetEncoderHandle h = (PhidgetEncoderHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetEncoder_setPositionChangeTrigger(h, (uint32_t)positionChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jint JNICALL Java_com_phidget22_EncoderBase_getMinPositionChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetEncoderHandle h = (PhidgetEncoderHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t minPositionChangeTrigger;
	ret = PhidgetEncoder_getMinPositionChangeTrigger(h, &minPositionChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minPositionChangeTrigger;
	}
	return minPositionChangeTrigger;
}

JNIEXPORT jint JNICALL Java_com_phidget22_EncoderBase_getMaxPositionChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetEncoderHandle h = (PhidgetEncoderHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t maxPositionChangeTrigger;
	ret = PhidgetEncoder_getMaxPositionChangeTrigger(h, &maxPositionChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxPositionChangeTrigger;
	}
	return maxPositionChangeTrigger;
}

static void CCONV positionChange_handler(PhidgetEncoderHandle h, void *arg, int positionChange, double timeChange, int indexTriggered) {
	jobject positionChangeEv;
	JNIEnv *env;
	jobject obj;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;

	if ((positionChangeEv = (*env)->NewObject(env, positionChangeEvent_class, positionChangeEvent_cons, obj, positionChange, timeChange, indexTriggered)) != 0) {
		(*env)->CallVoidMethod(env, obj, firePositionChange_mid, positionChangeEv);
		(*env)->DeleteLocalRef(env, positionChangeEv);
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_EncoderBase_enablePositionChangeEvents(JNIEnv * env, jobject obj, jboolean b) {
	if (positionChangeEvent_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/EncoderPositionChangeEvent");
	jlong gr = updateGlobalRef(env, obj, nativePositionChangeHandler_fid, b);
	PhidgetEncoderHandle h = (PhidgetEncoderHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetEncoder_setOnPositionChangeHandler(h, b ? positionChange_handler : NULL, (void *)(uintptr_t) gr);
}
