/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of libphidget22java
 *
 * Copyright (c) 2017-2022 Phidgets Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

#include "phidget_jni.h"
#include "com_phidget22_GyroscopeBase.h"

static jclass gyroscopebase_class;
jclass gyroscope_class;
jmethodID gyroscope_cons;

static jclass angularRateUpdateEvent_class;
static jmethodID fireAngularRateUpdate_mid	;
static jmethodID angularRateUpdateEvent_cons;
static jfieldID nativeAngularRateUpdateHandler_fid;

void com_phidget22_GyroscopeBase_OnLoad(JNIEnv *env) {
	if (!(gyroscope_class = (*env)->FindClass(env, "com/phidget22/Gyroscope"))) {
		(*env)->ExceptionClear(env);
		return;
	}
	if (!(gyroscope_class = (jclass)(*env)->NewGlobalRef(env, gyroscope_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef gyroscope_class");
	if (!(gyroscope_cons = (*env)->GetMethodID(env, gyroscope_class, "<init>", "(J)V")))
		JNI_ABORT_STDERR("Couldn't get Method ID <init> from gyroscope_class");

	if (!(gyroscopebase_class = (*env)->FindClass(env, "com/phidget22/GyroscopeBase")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/GyroscopeBase");
	if (!(gyroscopebase_class = (jclass)(*env)->NewGlobalRef(env, gyroscopebase_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef gyroscopebase_class");

	if ((angularRateUpdateEvent_class = (*env)->FindClass(env, "com/phidget22/GyroscopeAngularRateUpdateEvent"))) {
		if (!(angularRateUpdateEvent_class = (jclass)(*env)->NewGlobalRef(env, angularRateUpdateEvent_class)))
			JNI_ABORT_STDERR("Couldn't create global ref AngularRateUpdateEvent_class");
		if (!(fireAngularRateUpdate_mid = (*env)->GetMethodID(env, gyroscopebase_class, "fireAngularRateUpdate", "(Lcom/phidget22/GyroscopeAngularRateUpdateEvent;)V")))
			JNI_ABORT_STDERR("Couldn't get method ID fireAngularRateUpdate");
		if (!(angularRateUpdateEvent_cons = (*env)->GetMethodID(env, angularRateUpdateEvent_class, "<init>", "(Lcom/phidget22/Gyroscope;[DD)V")))
			JNI_ABORT_STDERR("Couldn't get method ID <init> from AngularRateUpdateEvent_class");
		if (!(nativeAngularRateUpdateHandler_fid = (*env)->GetFieldID(env, gyroscopebase_class, "nativeAngularRateUpdateHandler", "J")))
			JNI_ABORT_STDERR("Couldn't get Field ID nativeAngularRateUpdateHandler from gyroscopebase_class");
	} else {
		(*env)->ExceptionClear(env);
	}
}
JNIEXPORT jlong JNICALL Java_com_phidget22_GyroscopeBase_create(JNIEnv * env, jclass obj) {
	PhidgetGyroscopeHandle phid;
	int error; 
	if ((error = PhidgetGyroscope_create(&phid)) != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(error);
		return 0;
	}
	return (jlong)(uintptr_t)phid;
}

JNIEXPORT jdoubleArray JNICALL Java_com_phidget22_GyroscopeBase_getAngularRate(JNIEnv * env, jobject obj) {
	PhidgetGyroscopeHandle h = (PhidgetGyroscopeHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double angularRate[3];
	jdoubleArray jangularRate = (*env)->NewDoubleArray(env, 3);
	ret = PhidgetGyroscope_getAngularRate(h, &angularRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return NULL;
	}
	(*env)->SetDoubleArrayRegion(env, jangularRate, 0, (jsize)3, angularRate);
	return jangularRate;
}

JNIEXPORT jdoubleArray JNICALL Java_com_phidget22_GyroscopeBase_getMinAngularRate(JNIEnv * env, jobject obj) {
	PhidgetGyroscopeHandle h = (PhidgetGyroscopeHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minAngularRate[3];
	jdoubleArray jminAngularRate = (*env)->NewDoubleArray(env, 3);
	ret = PhidgetGyroscope_getMinAngularRate(h, &minAngularRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return NULL;
	}
	(*env)->SetDoubleArrayRegion(env, jminAngularRate, 0, (jsize)3, minAngularRate);
	return jminAngularRate;
}

JNIEXPORT jdoubleArray JNICALL Java_com_phidget22_GyroscopeBase_getMaxAngularRate(JNIEnv * env, jobject obj) {
	PhidgetGyroscopeHandle h = (PhidgetGyroscopeHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxAngularRate[3];
	jdoubleArray jmaxAngularRate = (*env)->NewDoubleArray(env, 3);
	ret = PhidgetGyroscope_getMaxAngularRate(h, &maxAngularRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return NULL;
	}
	(*env)->SetDoubleArrayRegion(env, jmaxAngularRate, 0, (jsize)3, maxAngularRate);
	return jmaxAngularRate;
}

JNIEXPORT jint JNICALL Java_com_phidget22_GyroscopeBase_getAxisCount(JNIEnv * env, jobject obj) {
	PhidgetGyroscopeHandle h = (PhidgetGyroscopeHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	int axisCount;
	ret = PhidgetGyroscope_getAxisCount(h, &axisCount);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return axisCount;
	}
	return axisCount;
}

JNIEXPORT jint JNICALL Java_com_phidget22_GyroscopeBase_getDataInterval(JNIEnv * env, jobject obj) {
	PhidgetGyroscopeHandle h = (PhidgetGyroscopeHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t dataInterval;
	ret = PhidgetGyroscope_getDataInterval(h, &dataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return dataInterval;
	}
	return dataInterval;
}

JNIEXPORT void JNICALL Java_com_phidget22_GyroscopeBase_setDataInterval(JNIEnv * env, jobject obj, jint dataInterval) {
	PhidgetGyroscopeHandle h = (PhidgetGyroscopeHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetGyroscope_setDataInterval(h, (uint32_t)dataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jint JNICALL Java_com_phidget22_GyroscopeBase_getMinDataInterval(JNIEnv * env, jobject obj) {
	PhidgetGyroscopeHandle h = (PhidgetGyroscopeHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t minDataInterval;
	ret = PhidgetGyroscope_getMinDataInterval(h, &minDataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minDataInterval;
	}
	return minDataInterval;
}

JNIEXPORT jint JNICALL Java_com_phidget22_GyroscopeBase_getMaxDataInterval(JNIEnv * env, jobject obj) {
	PhidgetGyroscopeHandle h = (PhidgetGyroscopeHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t maxDataInterval;
	ret = PhidgetGyroscope_getMaxDataInterval(h, &maxDataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxDataInterval;
	}
	return maxDataInterval;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_GyroscopeBase_getDataRate(JNIEnv * env, jobject obj) {
	PhidgetGyroscopeHandle h = (PhidgetGyroscopeHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double dataRate;
	ret = PhidgetGyroscope_getDataRate(h, &dataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return dataRate;
	}
	return dataRate;
}

JNIEXPORT void JNICALL Java_com_phidget22_GyroscopeBase_setDataRate(JNIEnv * env, jobject obj, jdouble dataRate) {
	PhidgetGyroscopeHandle h = (PhidgetGyroscopeHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetGyroscope_setDataRate(h, (double)dataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_GyroscopeBase_getMinDataRate(JNIEnv * env, jobject obj) {
	PhidgetGyroscopeHandle h = (PhidgetGyroscopeHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minDataRate;
	ret = PhidgetGyroscope_getMinDataRate(h, &minDataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minDataRate;
	}
	return minDataRate;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_GyroscopeBase_getMaxDataRate(JNIEnv * env, jobject obj) {
	PhidgetGyroscopeHandle h = (PhidgetGyroscopeHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxDataRate;
	ret = PhidgetGyroscope_getMaxDataRate(h, &maxDataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxDataRate;
	}
	return maxDataRate;
}

JNIEXPORT jboolean JNICALL Java_com_phidget22_GyroscopeBase_getHeatingEnabled(JNIEnv * env, jobject obj) {
	PhidgetGyroscopeHandle h = (PhidgetGyroscopeHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	int heatingEnabled;
	ret = PhidgetGyroscope_getHeatingEnabled(h, &heatingEnabled);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return heatingEnabled;
	}
	return heatingEnabled;
}

JNIEXPORT void JNICALL Java_com_phidget22_GyroscopeBase_setHeatingEnabled(JNIEnv * env, jobject obj, jboolean heatingEnabled) {
	PhidgetGyroscopeHandle h = (PhidgetGyroscopeHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetGyroscope_setHeatingEnabled(h, (int)heatingEnabled);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_GyroscopeBase_getTimestamp(JNIEnv * env, jobject obj) {
	PhidgetGyroscopeHandle h = (PhidgetGyroscopeHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double timestamp;
	ret = PhidgetGyroscope_getTimestamp(h, &timestamp);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return timestamp;
	}
	return timestamp;
}

JNIEXPORT void JNICALL Java_com_phidget22_GyroscopeBase_zero(JNIEnv * env, jobject obj) {
	PhidgetGyroscopeHandle h = (PhidgetGyroscopeHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetGyroscope_zero(h);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

static void CCONV angularRateUpdate_handler(PhidgetGyroscopeHandle h, void *arg, const double angularRate[3], double timestamp) {
	jobject angularRateUpdateEv;
	JNIEnv *env;
	jobject obj;
	jdoubleArray angularRateArr;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;
	angularRateArr = (*env)->NewDoubleArray(env, (jsize)3);
	(*env)->SetDoubleArrayRegion(env, angularRateArr, 0, (jsize)3, angularRate);

	if ((angularRateUpdateEv = (*env)->NewObject(env, angularRateUpdateEvent_class, angularRateUpdateEvent_cons, obj, angularRateArr, timestamp)) != 0) {
		(*env)->CallVoidMethod(env, obj, fireAngularRateUpdate_mid, angularRateUpdateEv);
		(*env)->DeleteLocalRef(env, angularRateUpdateEv);
	}
	(*env)->DeleteLocalRef(env, angularRateArr);
}

JNIEXPORT void JNICALL Java_com_phidget22_GyroscopeBase_enableAngularRateUpdateEvents(JNIEnv * env, jobject obj, jboolean b) {
	if (angularRateUpdateEvent_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/GyroscopeAngularRateUpdateEvent");
	jlong gr = updateGlobalRef(env, obj, nativeAngularRateUpdateHandler_fid, b);
	PhidgetGyroscopeHandle h = (PhidgetGyroscopeHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetGyroscope_setOnAngularRateUpdateHandler(h, b ? angularRateUpdate_handler : NULL, (void *)(uintptr_t) gr);
}
