/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of libphidget22java
 *
 * Copyright (c) 2017-2022 Phidgets Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

#include "phidget_jni.h"
#include "com_phidget22_HubBase.h"

static jclass hubbase_class;
jclass hub_class;
jmethodID hub_cons;

void com_phidget22_HubBase_OnLoad(JNIEnv *env) {
	if (!(hub_class = (*env)->FindClass(env, "com/phidget22/Hub"))) {
		(*env)->ExceptionClear(env);
		return;
	}
	if (!(hub_class = (jclass)(*env)->NewGlobalRef(env, hub_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef hub_class");
	if (!(hub_cons = (*env)->GetMethodID(env, hub_class, "<init>", "(J)V")))
		JNI_ABORT_STDERR("Couldn't get Method ID <init> from hub_class");

	if (!(hubbase_class = (*env)->FindClass(env, "com/phidget22/HubBase")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/HubBase");
	if (!(hubbase_class = (jclass)(*env)->NewGlobalRef(env, hubbase_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef hubbase_class");
}
JNIEXPORT jlong JNICALL Java_com_phidget22_HubBase_create(JNIEnv * env, jclass obj) {
	PhidgetHubHandle phid;
	int error; 
	if ((error = PhidgetHub_create(&phid)) != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(error);
		return 0;
	}
	return (jlong)(uintptr_t)phid;
}

JNIEXPORT void JNICALL Java_com_phidget22_HubBase_setPortAutoSetSpeed(JNIEnv * env, jobject obj, jint port, jboolean state) {
	PhidgetHubHandle h = (PhidgetHubHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetHub_setPortAutoSetSpeed(h, (int)port, (int)state);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jint JNICALL Java_com_phidget22_HubBase_getPortMaxSpeed(JNIEnv * env, jobject obj, jint port) {
	PhidgetHubHandle h = (PhidgetHubHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t state;
	ret = PhidgetHub_getPortMaxSpeed(h, (int)port, &state);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return state;
	}
	return state;
}

JNIEXPORT jobject JNICALL Java_com_phidget22_HubBase_getPortMode(JNIEnv * env, jobject obj, jint port) {
	PhidgetHubHandle h = (PhidgetHubHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	PhidgetHub_PortMode mode;
	if (HubPortMode_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/HubPortMode");
	ret = PhidgetHub_getPortMode(h, (int)port, &mode);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return NULL;
	}
	return (*env)->CallStaticObjectMethod(env, HubPortMode_class, HubPortMode_getEnum_mid, mode);
}

JNIEXPORT void JNICALL Java_com_phidget22_HubBase_setPortMode(JNIEnv * env, jobject obj, jint port, jobject mode) {
	PhidgetHubHandle h = (PhidgetHubHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	if (HubPortMode_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/HubPortMode");
	ret = PhidgetHub_setPortMode(h, (int)port, (PhidgetHub_PortMode)(*env)->CallIntMethod(env, mode, HubPortMode_getCode_mid));
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jboolean JNICALL Java_com_phidget22_HubBase_getPortPower(JNIEnv * env, jobject obj, jint port) {
	PhidgetHubHandle h = (PhidgetHubHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	int state;
	ret = PhidgetHub_getPortPower(h, (int)port, &state);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return state;
	}
	return state;
}

JNIEXPORT void JNICALL Java_com_phidget22_HubBase_setPortPower(JNIEnv * env, jobject obj, jint port, jboolean state) {
	PhidgetHubHandle h = (PhidgetHubHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetHub_setPortPower(h, (int)port, (int)state);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jboolean JNICALL Java_com_phidget22_HubBase_getPortSupportsAutoSetSpeed(JNIEnv * env, jobject obj, jint port) {
	PhidgetHubHandle h = (PhidgetHubHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	int state;
	ret = PhidgetHub_getPortSupportsAutoSetSpeed(h, (int)port, &state);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return state;
	}
	return state;
}

JNIEXPORT jboolean JNICALL Java_com_phidget22_HubBase_getPortSupportsSetSpeed(JNIEnv * env, jobject obj, jint port) {
	PhidgetHubHandle h = (PhidgetHubHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	int state;
	ret = PhidgetHub_getPortSupportsSetSpeed(h, (int)port, &state);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return state;
	}
	return state;
}
