/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of libphidget22java
 *
 * Copyright (c) 2017-2022 Phidgets Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

#include "phidget_jni.h"
#include "com_phidget22_HumiditySensorBase.h"

static jclass humiditySensorbase_class;
jclass humiditySensor_class;
jmethodID humiditySensor_cons;

static jclass humidityChangeEvent_class;
static jmethodID fireHumidityChange_mid	;
static jmethodID humidityChangeEvent_cons;
static jfieldID nativeHumidityChangeHandler_fid;

void com_phidget22_HumiditySensorBase_OnLoad(JNIEnv *env) {
	if (!(humiditySensor_class = (*env)->FindClass(env, "com/phidget22/HumiditySensor"))) {
		(*env)->ExceptionClear(env);
		return;
	}
	if (!(humiditySensor_class = (jclass)(*env)->NewGlobalRef(env, humiditySensor_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef humiditySensor_class");
	if (!(humiditySensor_cons = (*env)->GetMethodID(env, humiditySensor_class, "<init>", "(J)V")))
		JNI_ABORT_STDERR("Couldn't get Method ID <init> from humiditySensor_class");

	if (!(humiditySensorbase_class = (*env)->FindClass(env, "com/phidget22/HumiditySensorBase")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/HumiditySensorBase");
	if (!(humiditySensorbase_class = (jclass)(*env)->NewGlobalRef(env, humiditySensorbase_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef humiditySensorbase_class");

	if ((humidityChangeEvent_class = (*env)->FindClass(env, "com/phidget22/HumiditySensorHumidityChangeEvent"))) {
		if (!(humidityChangeEvent_class = (jclass)(*env)->NewGlobalRef(env, humidityChangeEvent_class)))
			JNI_ABORT_STDERR("Couldn't create global ref HumidityChangeEvent_class");
		if (!(fireHumidityChange_mid = (*env)->GetMethodID(env, humiditySensorbase_class, "fireHumidityChange", "(Lcom/phidget22/HumiditySensorHumidityChangeEvent;)V")))
			JNI_ABORT_STDERR("Couldn't get method ID fireHumidityChange");
		if (!(humidityChangeEvent_cons = (*env)->GetMethodID(env, humidityChangeEvent_class, "<init>", "(Lcom/phidget22/HumiditySensor;D)V")))
			JNI_ABORT_STDERR("Couldn't get method ID <init> from HumidityChangeEvent_class");
		if (!(nativeHumidityChangeHandler_fid = (*env)->GetFieldID(env, humiditySensorbase_class, "nativeHumidityChangeHandler", "J")))
			JNI_ABORT_STDERR("Couldn't get Field ID nativeHumidityChangeHandler from humiditySensorbase_class");
	} else {
		(*env)->ExceptionClear(env);
	}
}
JNIEXPORT jlong JNICALL Java_com_phidget22_HumiditySensorBase_create(JNIEnv * env, jclass obj) {
	PhidgetHumiditySensorHandle phid;
	int error; 
	if ((error = PhidgetHumiditySensor_create(&phid)) != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(error);
		return 0;
	}
	return (jlong)(uintptr_t)phid;
}

JNIEXPORT jint JNICALL Java_com_phidget22_HumiditySensorBase_getDataInterval(JNIEnv * env, jobject obj) {
	PhidgetHumiditySensorHandle h = (PhidgetHumiditySensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t dataInterval;
	ret = PhidgetHumiditySensor_getDataInterval(h, &dataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return dataInterval;
	}
	return dataInterval;
}

JNIEXPORT void JNICALL Java_com_phidget22_HumiditySensorBase_setDataInterval(JNIEnv * env, jobject obj, jint dataInterval) {
	PhidgetHumiditySensorHandle h = (PhidgetHumiditySensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetHumiditySensor_setDataInterval(h, (uint32_t)dataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jint JNICALL Java_com_phidget22_HumiditySensorBase_getMinDataInterval(JNIEnv * env, jobject obj) {
	PhidgetHumiditySensorHandle h = (PhidgetHumiditySensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t minDataInterval;
	ret = PhidgetHumiditySensor_getMinDataInterval(h, &minDataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minDataInterval;
	}
	return minDataInterval;
}

JNIEXPORT jint JNICALL Java_com_phidget22_HumiditySensorBase_getMaxDataInterval(JNIEnv * env, jobject obj) {
	PhidgetHumiditySensorHandle h = (PhidgetHumiditySensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t maxDataInterval;
	ret = PhidgetHumiditySensor_getMaxDataInterval(h, &maxDataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxDataInterval;
	}
	return maxDataInterval;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_HumiditySensorBase_getDataRate(JNIEnv * env, jobject obj) {
	PhidgetHumiditySensorHandle h = (PhidgetHumiditySensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double dataRate;
	ret = PhidgetHumiditySensor_getDataRate(h, &dataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return dataRate;
	}
	return dataRate;
}

JNIEXPORT void JNICALL Java_com_phidget22_HumiditySensorBase_setDataRate(JNIEnv * env, jobject obj, jdouble dataRate) {
	PhidgetHumiditySensorHandle h = (PhidgetHumiditySensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetHumiditySensor_setDataRate(h, (double)dataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_HumiditySensorBase_getMinDataRate(JNIEnv * env, jobject obj) {
	PhidgetHumiditySensorHandle h = (PhidgetHumiditySensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minDataRate;
	ret = PhidgetHumiditySensor_getMinDataRate(h, &minDataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minDataRate;
	}
	return minDataRate;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_HumiditySensorBase_getMaxDataRate(JNIEnv * env, jobject obj) {
	PhidgetHumiditySensorHandle h = (PhidgetHumiditySensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxDataRate;
	ret = PhidgetHumiditySensor_getMaxDataRate(h, &maxDataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxDataRate;
	}
	return maxDataRate;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_HumiditySensorBase_getHumidity(JNIEnv * env, jobject obj) {
	PhidgetHumiditySensorHandle h = (PhidgetHumiditySensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double humidity;
	ret = PhidgetHumiditySensor_getHumidity(h, &humidity);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return humidity;
	}
	return humidity;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_HumiditySensorBase_getMinHumidity(JNIEnv * env, jobject obj) {
	PhidgetHumiditySensorHandle h = (PhidgetHumiditySensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minHumidity;
	ret = PhidgetHumiditySensor_getMinHumidity(h, &minHumidity);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minHumidity;
	}
	return minHumidity;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_HumiditySensorBase_getMaxHumidity(JNIEnv * env, jobject obj) {
	PhidgetHumiditySensorHandle h = (PhidgetHumiditySensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxHumidity;
	ret = PhidgetHumiditySensor_getMaxHumidity(h, &maxHumidity);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxHumidity;
	}
	return maxHumidity;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_HumiditySensorBase_getHumidityChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetHumiditySensorHandle h = (PhidgetHumiditySensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double humidityChangeTrigger;
	ret = PhidgetHumiditySensor_getHumidityChangeTrigger(h, &humidityChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return humidityChangeTrigger;
	}
	return humidityChangeTrigger;
}

JNIEXPORT void JNICALL Java_com_phidget22_HumiditySensorBase_setHumidityChangeTrigger(JNIEnv * env, jobject obj, jdouble humidityChangeTrigger) {
	PhidgetHumiditySensorHandle h = (PhidgetHumiditySensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetHumiditySensor_setHumidityChangeTrigger(h, (double)humidityChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_HumiditySensorBase_getMinHumidityChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetHumiditySensorHandle h = (PhidgetHumiditySensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minHumidityChangeTrigger;
	ret = PhidgetHumiditySensor_getMinHumidityChangeTrigger(h, &minHumidityChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minHumidityChangeTrigger;
	}
	return minHumidityChangeTrigger;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_HumiditySensorBase_getMaxHumidityChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetHumiditySensorHandle h = (PhidgetHumiditySensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxHumidityChangeTrigger;
	ret = PhidgetHumiditySensor_getMaxHumidityChangeTrigger(h, &maxHumidityChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxHumidityChangeTrigger;
	}
	return maxHumidityChangeTrigger;
}

static void CCONV humidityChange_handler(PhidgetHumiditySensorHandle h, void *arg, double humidity) {
	jobject humidityChangeEv;
	JNIEnv *env;
	jobject obj;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;

	if ((humidityChangeEv = (*env)->NewObject(env, humidityChangeEvent_class, humidityChangeEvent_cons, obj, humidity)) != 0) {
		(*env)->CallVoidMethod(env, obj, fireHumidityChange_mid, humidityChangeEv);
		(*env)->DeleteLocalRef(env, humidityChangeEv);
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_HumiditySensorBase_enableHumidityChangeEvents(JNIEnv * env, jobject obj, jboolean b) {
	if (humidityChangeEvent_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/HumiditySensorHumidityChangeEvent");
	jlong gr = updateGlobalRef(env, obj, nativeHumidityChangeHandler_fid, b);
	PhidgetHumiditySensorHandle h = (PhidgetHumiditySensorHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetHumiditySensor_setOnHumidityChangeHandler(h, b ? humidityChange_handler : NULL, (void *)(uintptr_t) gr);
}
