/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of libphidget22java
 *
 * Copyright (c) 2017-2022 Phidgets Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

#include "phidget_jni.h"
#include "com_phidget22_IRBase.h"

static jclass IRbase_class;
jclass IR_class;
jmethodID IR_cons;

static jclass codeEvent_class;
static jmethodID fireCode_mid	;
static jmethodID codeEvent_cons;
static jfieldID nativeCodeHandler_fid;

static jclass learnEvent_class;
static jmethodID fireLearn_mid	;
static jmethodID learnEvent_cons;
static jfieldID nativeLearnHandler_fid;

static jclass rawDataEvent_class;
static jmethodID fireRawData_mid	;
static jmethodID rawDataEvent_cons;
static jfieldID nativeRawDataHandler_fid;

void com_phidget22_IRBase_OnLoad(JNIEnv *env) {
	if (!(IR_class = (*env)->FindClass(env, "com/phidget22/IR"))) {
		(*env)->ExceptionClear(env);
		return;
	}
	if (!(IR_class = (jclass)(*env)->NewGlobalRef(env, IR_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef IR_class");
	if (!(IR_cons = (*env)->GetMethodID(env, IR_class, "<init>", "(J)V")))
		JNI_ABORT_STDERR("Couldn't get Method ID <init> from IR_class");

	if (!(IRbase_class = (*env)->FindClass(env, "com/phidget22/IRBase")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/IRBase");
	if (!(IRbase_class = (jclass)(*env)->NewGlobalRef(env, IRbase_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef IRbase_class");

	if ((codeEvent_class = (*env)->FindClass(env, "com/phidget22/IRCodeEvent"))) {
		if (!(codeEvent_class = (jclass)(*env)->NewGlobalRef(env, codeEvent_class)))
			JNI_ABORT_STDERR("Couldn't create global ref CodeEvent_class");
		if (!(fireCode_mid = (*env)->GetMethodID(env, IRbase_class, "fireCode", "(Lcom/phidget22/IRCodeEvent;)V")))
			JNI_ABORT_STDERR("Couldn't get method ID fireCode");
		if (!(codeEvent_cons = (*env)->GetMethodID(env, codeEvent_class, "<init>", "(Lcom/phidget22/IR;Ljava/lang/String;IZ)V")))
			JNI_ABORT_STDERR("Couldn't get method ID <init> from CodeEvent_class");
		if (!(nativeCodeHandler_fid = (*env)->GetFieldID(env, IRbase_class, "nativeCodeHandler", "J")))
			JNI_ABORT_STDERR("Couldn't get Field ID nativeCodeHandler from IRbase_class");
	} else {
		(*env)->ExceptionClear(env);
	}

	if ((learnEvent_class = (*env)->FindClass(env, "com/phidget22/IRLearnEvent"))) {
		if (!(learnEvent_class = (jclass)(*env)->NewGlobalRef(env, learnEvent_class)))
			JNI_ABORT_STDERR("Couldn't create global ref LearnEvent_class");
		if (!(fireLearn_mid = (*env)->GetMethodID(env, IRbase_class, "fireLearn", "(Lcom/phidget22/IRLearnEvent;)V")))
			JNI_ABORT_STDERR("Couldn't get method ID fireLearn");
		if (!(learnEvent_cons = (*env)->GetMethodID(env, learnEvent_class, "<init>", "(Lcom/phidget22/IR;Ljava/lang/String;Lcom/phidget22/IRCodeInfo;)V")))
			JNI_ABORT_STDERR("Couldn't get method ID <init> from LearnEvent_class");
		if (!(nativeLearnHandler_fid = (*env)->GetFieldID(env, IRbase_class, "nativeLearnHandler", "J")))
			JNI_ABORT_STDERR("Couldn't get Field ID nativeLearnHandler from IRbase_class");
	} else {
		(*env)->ExceptionClear(env);
	}

	if ((rawDataEvent_class = (*env)->FindClass(env, "com/phidget22/IRRawDataEvent"))) {
		if (!(rawDataEvent_class = (jclass)(*env)->NewGlobalRef(env, rawDataEvent_class)))
			JNI_ABORT_STDERR("Couldn't create global ref RawDataEvent_class");
		if (!(fireRawData_mid = (*env)->GetMethodID(env, IRbase_class, "fireRawData", "(Lcom/phidget22/IRRawDataEvent;)V")))
			JNI_ABORT_STDERR("Couldn't get method ID fireRawData");
		if (!(rawDataEvent_cons = (*env)->GetMethodID(env, rawDataEvent_class, "<init>", "(Lcom/phidget22/IR;[I)V")))
			JNI_ABORT_STDERR("Couldn't get method ID <init> from RawDataEvent_class");
		if (!(nativeRawDataHandler_fid = (*env)->GetFieldID(env, IRbase_class, "nativeRawDataHandler", "J")))
			JNI_ABORT_STDERR("Couldn't get Field ID nativeRawDataHandler from IRbase_class");
	} else {
		(*env)->ExceptionClear(env);
	}
}
JNIEXPORT jlong JNICALL Java_com_phidget22_IRBase_create(JNIEnv * env, jclass obj) {
	PhidgetIRHandle phid;
	int error; 
	if ((error = PhidgetIR_create(&phid)) != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(error);
		return 0;
	}
	return (jlong)(uintptr_t)phid;
}

JNIEXPORT void JNICALL Java_com_phidget22_IRBase_transmit(JNIEnv * env, jobject obj, jstring code, jobject codeInfo) {
	PhidgetIRHandle h = (PhidgetIRHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	const char *codeUTFChars = (code == NULL ? NULL : (*env)->GetStringUTFChars(env, code, NULL));
	PhidgetIR_CodeInfo codeInfoVal = jobject_to_PhidgetIR_CodeInfo(env, codeInfo);
	ret = PhidgetIR_transmit(h, (const char *)codeUTFChars, &codeInfoVal);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		if (codeUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, code, codeUTFChars);
		return;
	}
	if (codeUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, code, codeUTFChars);
}

JNIEXPORT void JNICALL Java_com_phidget22_IRBase_transmitRaw(JNIEnv * env, jobject obj, jintArray data, jint carrierFrequency, jdouble dutyCycle, jint gap) {
	PhidgetIRHandle h = (PhidgetIRHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t *dataArr = (*env)->GetIntArrayElements(env, data, 0);
	size_t dataLen = (*env)->GetArrayLength(env, data);
	ret = PhidgetIR_transmitRaw(h, dataArr, (size_t)dataLen, (uint32_t)carrierFrequency, (double)dutyCycle, (uint32_t)gap);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		(*env)->ReleaseIntArrayElements(env, data, dataArr, 0);
		return;
	}
	(*env)->ReleaseIntArrayElements(env, data, dataArr, 0);
}

JNIEXPORT void JNICALL Java_com_phidget22_IRBase_transmitRepeat(JNIEnv * env, jobject obj) {
	PhidgetIRHandle h = (PhidgetIRHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetIR_transmitRepeat(h);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

static void CCONV code_handler(PhidgetIRHandle h, void *arg, const char * code, uint32_t bitCount, int isRepeat) {
	jobject codeEv;
	JNIEnv *env;
	jobject obj;
	jstring codeStr;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;
	codeStr = (*env)->NewStringUTF(env, code);

	if ((codeEv = (*env)->NewObject(env, codeEvent_class, codeEvent_cons, obj, codeStr, bitCount, isRepeat)) != 0) {
		(*env)->CallVoidMethod(env, obj, fireCode_mid, codeEv);
		(*env)->DeleteLocalRef(env, codeEv);
	}
	(*env)->DeleteLocalRef(env, codeStr);
}

JNIEXPORT void JNICALL Java_com_phidget22_IRBase_enableCodeEvents(JNIEnv * env, jobject obj, jboolean b) {
	if (codeEvent_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/IRCodeEvent");
	jlong gr = updateGlobalRef(env, obj, nativeCodeHandler_fid, b);
	PhidgetIRHandle h = (PhidgetIRHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetIR_setOnCodeHandler(h, b ? code_handler : NULL, (void *)(uintptr_t) gr);
}

static void CCONV learn_handler(PhidgetIRHandle h, void *arg, const char * code, PhidgetIR_CodeInfo *codeInfo) {
	jobject learnEv;
	JNIEnv *env;
	jobject obj;
	jstring codeStr;
	jobject codeInfoObj;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;
	codeStr = (*env)->NewStringUTF(env, code);
	codeInfoObj = PhidgetIR_CodeInfo_to_jobject(env, codeInfo);

	if ((learnEv = (*env)->NewObject(env, learnEvent_class, learnEvent_cons, obj, codeStr, codeInfoObj)) != 0) {
		(*env)->CallVoidMethod(env, obj, fireLearn_mid, learnEv);
		(*env)->DeleteLocalRef(env, learnEv);
	}
	(*env)->DeleteLocalRef(env, codeStr);
	(*env)->DeleteLocalRef(env, codeInfoObj);
}

JNIEXPORT void JNICALL Java_com_phidget22_IRBase_enableLearnEvents(JNIEnv * env, jobject obj, jboolean b) {
	if (learnEvent_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/IRLearnEvent");
	jlong gr = updateGlobalRef(env, obj, nativeLearnHandler_fid, b);
	PhidgetIRHandle h = (PhidgetIRHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetIR_setOnLearnHandler(h, b ? learn_handler : NULL, (void *)(uintptr_t) gr);
}

static void CCONV rawData_handler(PhidgetIRHandle h, void *arg, const uint32_t *data, size_t dataLen) {
	jobject rawDataEv;
	JNIEnv *env;
	jobject obj;
	jintArray dataArr;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;
	dataArr = (*env)->NewIntArray(env, (jsize)dataLen);
	(*env)->SetIntArrayRegion(env, dataArr, 0, (jsize)dataLen, data);

	if ((rawDataEv = (*env)->NewObject(env, rawDataEvent_class, rawDataEvent_cons, obj, dataArr)) != 0) {
		(*env)->CallVoidMethod(env, obj, fireRawData_mid, rawDataEv);
		(*env)->DeleteLocalRef(env, rawDataEv);
	}
	(*env)->DeleteLocalRef(env, dataArr);
}

JNIEXPORT void JNICALL Java_com_phidget22_IRBase_enableRawDataEvents(JNIEnv * env, jobject obj, jboolean b) {
	if (rawDataEvent_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/IRRawDataEvent");
	jlong gr = updateGlobalRef(env, obj, nativeRawDataHandler_fid, b);
	PhidgetIRHandle h = (PhidgetIRHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetIR_setOnRawDataHandler(h, b ? rawData_handler : NULL, (void *)(uintptr_t) gr);
}
