/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of libphidget22java
 *
 * Copyright (c) 2017-2022 Phidgets Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

#include "phidget_jni.h"
#include "com_phidget22_LightSensorBase.h"

static jclass lightSensorbase_class;
jclass lightSensor_class;
jmethodID lightSensor_cons;

static jclass illuminanceChangeEvent_class;
static jmethodID fireIlluminanceChange_mid	;
static jmethodID illuminanceChangeEvent_cons;
static jfieldID nativeIlluminanceChangeHandler_fid;

void com_phidget22_LightSensorBase_OnLoad(JNIEnv *env) {
	if (!(lightSensor_class = (*env)->FindClass(env, "com/phidget22/LightSensor"))) {
		(*env)->ExceptionClear(env);
		return;
	}
	if (!(lightSensor_class = (jclass)(*env)->NewGlobalRef(env, lightSensor_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef lightSensor_class");
	if (!(lightSensor_cons = (*env)->GetMethodID(env, lightSensor_class, "<init>", "(J)V")))
		JNI_ABORT_STDERR("Couldn't get Method ID <init> from lightSensor_class");

	if (!(lightSensorbase_class = (*env)->FindClass(env, "com/phidget22/LightSensorBase")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/LightSensorBase");
	if (!(lightSensorbase_class = (jclass)(*env)->NewGlobalRef(env, lightSensorbase_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef lightSensorbase_class");

	if ((illuminanceChangeEvent_class = (*env)->FindClass(env, "com/phidget22/LightSensorIlluminanceChangeEvent"))) {
		if (!(illuminanceChangeEvent_class = (jclass)(*env)->NewGlobalRef(env, illuminanceChangeEvent_class)))
			JNI_ABORT_STDERR("Couldn't create global ref IlluminanceChangeEvent_class");
		if (!(fireIlluminanceChange_mid = (*env)->GetMethodID(env, lightSensorbase_class, "fireIlluminanceChange", "(Lcom/phidget22/LightSensorIlluminanceChangeEvent;)V")))
			JNI_ABORT_STDERR("Couldn't get method ID fireIlluminanceChange");
		if (!(illuminanceChangeEvent_cons = (*env)->GetMethodID(env, illuminanceChangeEvent_class, "<init>", "(Lcom/phidget22/LightSensor;D)V")))
			JNI_ABORT_STDERR("Couldn't get method ID <init> from IlluminanceChangeEvent_class");
		if (!(nativeIlluminanceChangeHandler_fid = (*env)->GetFieldID(env, lightSensorbase_class, "nativeIlluminanceChangeHandler", "J")))
			JNI_ABORT_STDERR("Couldn't get Field ID nativeIlluminanceChangeHandler from lightSensorbase_class");
	} else {
		(*env)->ExceptionClear(env);
	}
}
JNIEXPORT jlong JNICALL Java_com_phidget22_LightSensorBase_create(JNIEnv * env, jclass obj) {
	PhidgetLightSensorHandle phid;
	int error; 
	if ((error = PhidgetLightSensor_create(&phid)) != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(error);
		return 0;
	}
	return (jlong)(uintptr_t)phid;
}

JNIEXPORT jint JNICALL Java_com_phidget22_LightSensorBase_getDataInterval(JNIEnv * env, jobject obj) {
	PhidgetLightSensorHandle h = (PhidgetLightSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t dataInterval;
	ret = PhidgetLightSensor_getDataInterval(h, &dataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return dataInterval;
	}
	return dataInterval;
}

JNIEXPORT void JNICALL Java_com_phidget22_LightSensorBase_setDataInterval(JNIEnv * env, jobject obj, jint dataInterval) {
	PhidgetLightSensorHandle h = (PhidgetLightSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetLightSensor_setDataInterval(h, (uint32_t)dataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jint JNICALL Java_com_phidget22_LightSensorBase_getMinDataInterval(JNIEnv * env, jobject obj) {
	PhidgetLightSensorHandle h = (PhidgetLightSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t minDataInterval;
	ret = PhidgetLightSensor_getMinDataInterval(h, &minDataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minDataInterval;
	}
	return minDataInterval;
}

JNIEXPORT jint JNICALL Java_com_phidget22_LightSensorBase_getMaxDataInterval(JNIEnv * env, jobject obj) {
	PhidgetLightSensorHandle h = (PhidgetLightSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t maxDataInterval;
	ret = PhidgetLightSensor_getMaxDataInterval(h, &maxDataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxDataInterval;
	}
	return maxDataInterval;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_LightSensorBase_getDataRate(JNIEnv * env, jobject obj) {
	PhidgetLightSensorHandle h = (PhidgetLightSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double dataRate;
	ret = PhidgetLightSensor_getDataRate(h, &dataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return dataRate;
	}
	return dataRate;
}

JNIEXPORT void JNICALL Java_com_phidget22_LightSensorBase_setDataRate(JNIEnv * env, jobject obj, jdouble dataRate) {
	PhidgetLightSensorHandle h = (PhidgetLightSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetLightSensor_setDataRate(h, (double)dataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_LightSensorBase_getMinDataRate(JNIEnv * env, jobject obj) {
	PhidgetLightSensorHandle h = (PhidgetLightSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minDataRate;
	ret = PhidgetLightSensor_getMinDataRate(h, &minDataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minDataRate;
	}
	return minDataRate;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_LightSensorBase_getMaxDataRate(JNIEnv * env, jobject obj) {
	PhidgetLightSensorHandle h = (PhidgetLightSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxDataRate;
	ret = PhidgetLightSensor_getMaxDataRate(h, &maxDataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxDataRate;
	}
	return maxDataRate;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_LightSensorBase_getIlluminance(JNIEnv * env, jobject obj) {
	PhidgetLightSensorHandle h = (PhidgetLightSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double illuminance;
	ret = PhidgetLightSensor_getIlluminance(h, &illuminance);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return illuminance;
	}
	return illuminance;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_LightSensorBase_getMinIlluminance(JNIEnv * env, jobject obj) {
	PhidgetLightSensorHandle h = (PhidgetLightSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minIlluminance;
	ret = PhidgetLightSensor_getMinIlluminance(h, &minIlluminance);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minIlluminance;
	}
	return minIlluminance;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_LightSensorBase_getMaxIlluminance(JNIEnv * env, jobject obj) {
	PhidgetLightSensorHandle h = (PhidgetLightSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxIlluminance;
	ret = PhidgetLightSensor_getMaxIlluminance(h, &maxIlluminance);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxIlluminance;
	}
	return maxIlluminance;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_LightSensorBase_getIlluminanceChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetLightSensorHandle h = (PhidgetLightSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double illuminanceChangeTrigger;
	ret = PhidgetLightSensor_getIlluminanceChangeTrigger(h, &illuminanceChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return illuminanceChangeTrigger;
	}
	return illuminanceChangeTrigger;
}

JNIEXPORT void JNICALL Java_com_phidget22_LightSensorBase_setIlluminanceChangeTrigger(JNIEnv * env, jobject obj, jdouble illuminanceChangeTrigger) {
	PhidgetLightSensorHandle h = (PhidgetLightSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetLightSensor_setIlluminanceChangeTrigger(h, (double)illuminanceChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_LightSensorBase_getMinIlluminanceChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetLightSensorHandle h = (PhidgetLightSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minIlluminanceChangeTrigger;
	ret = PhidgetLightSensor_getMinIlluminanceChangeTrigger(h, &minIlluminanceChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minIlluminanceChangeTrigger;
	}
	return minIlluminanceChangeTrigger;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_LightSensorBase_getMaxIlluminanceChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetLightSensorHandle h = (PhidgetLightSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxIlluminanceChangeTrigger;
	ret = PhidgetLightSensor_getMaxIlluminanceChangeTrigger(h, &maxIlluminanceChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxIlluminanceChangeTrigger;
	}
	return maxIlluminanceChangeTrigger;
}

static void CCONV illuminanceChange_handler(PhidgetLightSensorHandle h, void *arg, double illuminance) {
	jobject illuminanceChangeEv;
	JNIEnv *env;
	jobject obj;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;

	if ((illuminanceChangeEv = (*env)->NewObject(env, illuminanceChangeEvent_class, illuminanceChangeEvent_cons, obj, illuminance)) != 0) {
		(*env)->CallVoidMethod(env, obj, fireIlluminanceChange_mid, illuminanceChangeEv);
		(*env)->DeleteLocalRef(env, illuminanceChangeEv);
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_LightSensorBase_enableIlluminanceChangeEvents(JNIEnv * env, jobject obj, jboolean b) {
	if (illuminanceChangeEvent_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/LightSensorIlluminanceChangeEvent");
	jlong gr = updateGlobalRef(env, obj, nativeIlluminanceChangeHandler_fid, b);
	PhidgetLightSensorHandle h = (PhidgetLightSensorHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetLightSensor_setOnIlluminanceChangeHandler(h, b ? illuminanceChange_handler : NULL, (void *)(uintptr_t) gr);
}
