/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of libphidget22java
 *
 * Copyright (c) 2017-2022 Phidgets Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

#include "phidget_jni.h"
#include "com_phidget22_LogBase.h"

static jclass logbase_class;
jclass log_class;

void com_phidget22_LogBase_OnLoad(JNIEnv *env) {
	if (!(log_class = (*env)->FindClass(env, "com/phidget22/Log"))) {
		(*env)->ExceptionClear(env);
		return;
	}
	if (!(log_class = (jclass)(*env)->NewGlobalRef(env, log_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef log_class");

	if (!(logbase_class = (*env)->FindClass(env, "com/phidget22/LogBase")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/LogBase");
	if (!(logbase_class = (jclass)(*env)->NewGlobalRef(env, logbase_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef logbase_class");
}

JNIEXPORT void JNICALL Java_com_phidget22_LogBase_disable(JNIEnv * env, jobject obj) {
	PhidgetReturnCode ret;
	ret = PhidgetLog_disable();
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_LogBase_enable(JNIEnv * env, jobject obj, jobject level, jstring destination) {
	PhidgetReturnCode ret;
	if (LogLevel_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/LogLevel");
	const char *destinationUTFChars = (destination == NULL ? NULL : (*env)->GetStringUTFChars(env, destination, NULL));
	ret = PhidgetLog_enable((Phidget_LogLevel)(*env)->CallIntMethod(env, level, LogLevel_getCode_mid), (const char *)destinationUTFChars);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		if (destinationUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, destination, destinationUTFChars);
		return;
	}
	if (destinationUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, destination, destinationUTFChars);
}

JNIEXPORT jobject JNICALL Java_com_phidget22_LogBase_getLevel(JNIEnv * env, jobject obj) {
	PhidgetReturnCode ret;
	Phidget_LogLevel level;
	if (LogLevel_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/LogLevel");
	ret = PhidgetLog_getLevel(&level);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return NULL;
	}
	return (*env)->CallStaticObjectMethod(env, LogLevel_class, LogLevel_getEnum_mid, level);
}

JNIEXPORT void JNICALL Java_com_phidget22_LogBase_setLevel(JNIEnv * env, jobject obj, jobject level) {
	PhidgetReturnCode ret;
	if (LogLevel_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/LogLevel");
	ret = PhidgetLog_setLevel((Phidget_LogLevel)(*env)->CallIntMethod(env, level, LogLevel_getCode_mid));
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_LogBase_log__Lcom_phidget22_LogLevel_2Ljava_lang_String_2Ljava_lang_String_2(JNIEnv * env, jobject obj, jobject level, jstring source, jstring message) {
	PhidgetReturnCode ret;
	if (LogLevel_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/LogLevel");
	const char *sourceUTFChars = (source == NULL ? NULL : (*env)->GetStringUTFChars(env, source, NULL));
	const char *messageUTFChars = (message == NULL ? NULL : (*env)->GetStringUTFChars(env, message, NULL));
	ret = PhidgetLog_loges((Phidget_LogLevel)(*env)->CallIntMethod(env, level, LogLevel_getCode_mid), (const char *)sourceUTFChars, (const char *)messageUTFChars);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		if (sourceUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, source, sourceUTFChars);
		if (messageUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, message, messageUTFChars);
		return;
	}
	if (sourceUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, source, sourceUTFChars);
	if (messageUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, message, messageUTFChars);
}

JNIEXPORT void JNICALL Java_com_phidget22_LogBase_log__Lcom_phidget22_LogLevel_2Ljava_lang_String_2(JNIEnv * env, jobject obj, jobject level, jstring message) {
	PhidgetReturnCode ret;
	if (LogLevel_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/LogLevel");
	const char *messageUTFChars = (message == NULL ? NULL : (*env)->GetStringUTFChars(env, message, NULL));
	ret = PhidgetLog_logs((Phidget_LogLevel)(*env)->CallIntMethod(env, level, LogLevel_getCode_mid), (const char *)messageUTFChars);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		if (messageUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, message, messageUTFChars);
		return;
	}
	if (messageUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, message, messageUTFChars);
}

JNIEXPORT void JNICALL Java_com_phidget22_LogBase_rotate(JNIEnv * env, jobject obj) {
	PhidgetReturnCode ret;
	ret = PhidgetLog_rotate();
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jboolean JNICALL Java_com_phidget22_LogBase_isRotating(JNIEnv * env, jobject obj) {
	PhidgetReturnCode ret;
	int isrotating;
	ret = PhidgetLog_isRotating(&isrotating);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return isrotating;
	}
	return isrotating;
}

JNIEXPORT void JNICALL Java_com_phidget22_LogBase_setRotating(JNIEnv * env, jobject obj, jlong size, jint keepCount) {
	PhidgetReturnCode ret;
	ret = PhidgetLog_setRotating((uint64_t)size, (int)keepCount);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_LogBase_enableRotating(JNIEnv * env, jobject obj) {
	PhidgetReturnCode ret;
	ret = PhidgetLog_enableRotating();
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_LogBase_disableRotating(JNIEnv * env, jobject obj) {
	PhidgetReturnCode ret;
	ret = PhidgetLog_disableRotating();
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_LogBase_addSource(JNIEnv * env, jobject obj, jstring source, jobject level) {
	PhidgetReturnCode ret;
	const char *sourceUTFChars = (source == NULL ? NULL : (*env)->GetStringUTFChars(env, source, NULL));
	if (LogLevel_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/LogLevel");
	ret = PhidgetLog_addSource((const char *)sourceUTFChars, (Phidget_LogLevel)(*env)->CallIntMethod(env, level, LogLevel_getCode_mid));
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		if (sourceUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, source, sourceUTFChars);
		return;
	}
	if (sourceUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, source, sourceUTFChars);
}

JNIEXPORT jobject JNICALL Java_com_phidget22_LogBase_getSourceLevel(JNIEnv * env, jobject obj, jstring source) {
	PhidgetReturnCode ret;
	const char *sourceUTFChars = (source == NULL ? NULL : (*env)->GetStringUTFChars(env, source, NULL));
	Phidget_LogLevel level;
	if (LogLevel_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/LogLevel");
	ret = PhidgetLog_getSourceLevel((const char *)sourceUTFChars, &level);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		if (sourceUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, source, sourceUTFChars);
		return NULL;
	}
	if (sourceUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, source, sourceUTFChars);
	return (*env)->CallStaticObjectMethod(env, LogLevel_class, LogLevel_getEnum_mid, level);
}

JNIEXPORT void JNICALL Java_com_phidget22_LogBase_setSourceLevel(JNIEnv * env, jobject obj, jstring source, jobject level) {
	PhidgetReturnCode ret;
	const char *sourceUTFChars = (source == NULL ? NULL : (*env)->GetStringUTFChars(env, source, NULL));
	if (LogLevel_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/LogLevel");
	ret = PhidgetLog_setSourceLevel((const char *)sourceUTFChars, (Phidget_LogLevel)(*env)->CallIntMethod(env, level, LogLevel_getCode_mid));
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		if (sourceUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, source, sourceUTFChars);
		return;
	}
	if (sourceUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, source, sourceUTFChars);
}
