/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of libphidget22java
 *
 * Copyright (c) 2017-2022 Phidgets Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

#include "phidget_jni.h"
#include "com_phidget22_MagnetometerBase.h"

static jclass magnetometerbase_class;
jclass magnetometer_class;
jmethodID magnetometer_cons;

static jclass magneticFieldChangeEvent_class;
static jmethodID fireMagneticFieldChange_mid	;
static jmethodID magneticFieldChangeEvent_cons;
static jfieldID nativeMagneticFieldChangeHandler_fid;

void com_phidget22_MagnetometerBase_OnLoad(JNIEnv *env) {
	if (!(magnetometer_class = (*env)->FindClass(env, "com/phidget22/Magnetometer"))) {
		(*env)->ExceptionClear(env);
		return;
	}
	if (!(magnetometer_class = (jclass)(*env)->NewGlobalRef(env, magnetometer_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef magnetometer_class");
	if (!(magnetometer_cons = (*env)->GetMethodID(env, magnetometer_class, "<init>", "(J)V")))
		JNI_ABORT_STDERR("Couldn't get Method ID <init> from magnetometer_class");

	if (!(magnetometerbase_class = (*env)->FindClass(env, "com/phidget22/MagnetometerBase")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/MagnetometerBase");
	if (!(magnetometerbase_class = (jclass)(*env)->NewGlobalRef(env, magnetometerbase_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef magnetometerbase_class");

	if ((magneticFieldChangeEvent_class = (*env)->FindClass(env, "com/phidget22/MagnetometerMagneticFieldChangeEvent"))) {
		if (!(magneticFieldChangeEvent_class = (jclass)(*env)->NewGlobalRef(env, magneticFieldChangeEvent_class)))
			JNI_ABORT_STDERR("Couldn't create global ref MagneticFieldChangeEvent_class");
		if (!(fireMagneticFieldChange_mid = (*env)->GetMethodID(env, magnetometerbase_class, "fireMagneticFieldChange", "(Lcom/phidget22/MagnetometerMagneticFieldChangeEvent;)V")))
			JNI_ABORT_STDERR("Couldn't get method ID fireMagneticFieldChange");
		if (!(magneticFieldChangeEvent_cons = (*env)->GetMethodID(env, magneticFieldChangeEvent_class, "<init>", "(Lcom/phidget22/Magnetometer;[DD)V")))
			JNI_ABORT_STDERR("Couldn't get method ID <init> from MagneticFieldChangeEvent_class");
		if (!(nativeMagneticFieldChangeHandler_fid = (*env)->GetFieldID(env, magnetometerbase_class, "nativeMagneticFieldChangeHandler", "J")))
			JNI_ABORT_STDERR("Couldn't get Field ID nativeMagneticFieldChangeHandler from magnetometerbase_class");
	} else {
		(*env)->ExceptionClear(env);
	}
}
JNIEXPORT jlong JNICALL Java_com_phidget22_MagnetometerBase_create(JNIEnv * env, jclass obj) {
	PhidgetMagnetometerHandle phid;
	int error; 
	if ((error = PhidgetMagnetometer_create(&phid)) != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(error);
		return 0;
	}
	return (jlong)(uintptr_t)phid;
}

JNIEXPORT jint JNICALL Java_com_phidget22_MagnetometerBase_getAxisCount(JNIEnv * env, jobject obj) {
	PhidgetMagnetometerHandle h = (PhidgetMagnetometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	int axisCount;
	ret = PhidgetMagnetometer_getAxisCount(h, &axisCount);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return axisCount;
	}
	return axisCount;
}

JNIEXPORT void JNICALL Java_com_phidget22_MagnetometerBase_setCorrectionParameters(JNIEnv * env, jobject obj, jdouble magneticField, jdouble offset0, jdouble offset1, jdouble offset2, jdouble gain0, jdouble gain1, jdouble gain2, jdouble T0, jdouble T1, jdouble T2, jdouble T3, jdouble T4, jdouble T5) {
	PhidgetMagnetometerHandle h = (PhidgetMagnetometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetMagnetometer_setCorrectionParameters(h, (double)magneticField, (double)offset0, (double)offset1, (double)offset2, (double)gain0, (double)gain1, (double)gain2, (double)T0, (double)T1, (double)T2, (double)T3, (double)T4, (double)T5);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jint JNICALL Java_com_phidget22_MagnetometerBase_getDataInterval(JNIEnv * env, jobject obj) {
	PhidgetMagnetometerHandle h = (PhidgetMagnetometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t dataInterval;
	ret = PhidgetMagnetometer_getDataInterval(h, &dataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return dataInterval;
	}
	return dataInterval;
}

JNIEXPORT void JNICALL Java_com_phidget22_MagnetometerBase_setDataInterval(JNIEnv * env, jobject obj, jint dataInterval) {
	PhidgetMagnetometerHandle h = (PhidgetMagnetometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetMagnetometer_setDataInterval(h, (uint32_t)dataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jint JNICALL Java_com_phidget22_MagnetometerBase_getMinDataInterval(JNIEnv * env, jobject obj) {
	PhidgetMagnetometerHandle h = (PhidgetMagnetometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t minDataInterval;
	ret = PhidgetMagnetometer_getMinDataInterval(h, &minDataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minDataInterval;
	}
	return minDataInterval;
}

JNIEXPORT jint JNICALL Java_com_phidget22_MagnetometerBase_getMaxDataInterval(JNIEnv * env, jobject obj) {
	PhidgetMagnetometerHandle h = (PhidgetMagnetometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t maxDataInterval;
	ret = PhidgetMagnetometer_getMaxDataInterval(h, &maxDataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxDataInterval;
	}
	return maxDataInterval;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MagnetometerBase_getDataRate(JNIEnv * env, jobject obj) {
	PhidgetMagnetometerHandle h = (PhidgetMagnetometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double dataRate;
	ret = PhidgetMagnetometer_getDataRate(h, &dataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return dataRate;
	}
	return dataRate;
}

JNIEXPORT void JNICALL Java_com_phidget22_MagnetometerBase_setDataRate(JNIEnv * env, jobject obj, jdouble dataRate) {
	PhidgetMagnetometerHandle h = (PhidgetMagnetometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetMagnetometer_setDataRate(h, (double)dataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MagnetometerBase_getMinDataRate(JNIEnv * env, jobject obj) {
	PhidgetMagnetometerHandle h = (PhidgetMagnetometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minDataRate;
	ret = PhidgetMagnetometer_getMinDataRate(h, &minDataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minDataRate;
	}
	return minDataRate;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MagnetometerBase_getMaxDataRate(JNIEnv * env, jobject obj) {
	PhidgetMagnetometerHandle h = (PhidgetMagnetometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxDataRate;
	ret = PhidgetMagnetometer_getMaxDataRate(h, &maxDataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxDataRate;
	}
	return maxDataRate;
}

JNIEXPORT jboolean JNICALL Java_com_phidget22_MagnetometerBase_getHeatingEnabled(JNIEnv * env, jobject obj) {
	PhidgetMagnetometerHandle h = (PhidgetMagnetometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	int heatingEnabled;
	ret = PhidgetMagnetometer_getHeatingEnabled(h, &heatingEnabled);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return heatingEnabled;
	}
	return heatingEnabled;
}

JNIEXPORT void JNICALL Java_com_phidget22_MagnetometerBase_setHeatingEnabled(JNIEnv * env, jobject obj, jboolean heatingEnabled) {
	PhidgetMagnetometerHandle h = (PhidgetMagnetometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetMagnetometer_setHeatingEnabled(h, (int)heatingEnabled);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdoubleArray JNICALL Java_com_phidget22_MagnetometerBase_getMagneticField(JNIEnv * env, jobject obj) {
	PhidgetMagnetometerHandle h = (PhidgetMagnetometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double magneticField[3];
	jdoubleArray jmagneticField = (*env)->NewDoubleArray(env, 3);
	ret = PhidgetMagnetometer_getMagneticField(h, &magneticField);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return NULL;
	}
	(*env)->SetDoubleArrayRegion(env, jmagneticField, 0, (jsize)3, magneticField);
	return jmagneticField;
}

JNIEXPORT jdoubleArray JNICALL Java_com_phidget22_MagnetometerBase_getMinMagneticField(JNIEnv * env, jobject obj) {
	PhidgetMagnetometerHandle h = (PhidgetMagnetometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minMagneticField[3];
	jdoubleArray jminMagneticField = (*env)->NewDoubleArray(env, 3);
	ret = PhidgetMagnetometer_getMinMagneticField(h, &minMagneticField);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return NULL;
	}
	(*env)->SetDoubleArrayRegion(env, jminMagneticField, 0, (jsize)3, minMagneticField);
	return jminMagneticField;
}

JNIEXPORT jdoubleArray JNICALL Java_com_phidget22_MagnetometerBase_getMaxMagneticField(JNIEnv * env, jobject obj) {
	PhidgetMagnetometerHandle h = (PhidgetMagnetometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxMagneticField[3];
	jdoubleArray jmaxMagneticField = (*env)->NewDoubleArray(env, 3);
	ret = PhidgetMagnetometer_getMaxMagneticField(h, &maxMagneticField);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return NULL;
	}
	(*env)->SetDoubleArrayRegion(env, jmaxMagneticField, 0, (jsize)3, maxMagneticField);
	return jmaxMagneticField;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MagnetometerBase_getMagneticFieldChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetMagnetometerHandle h = (PhidgetMagnetometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double magneticFieldChangeTrigger;
	ret = PhidgetMagnetometer_getMagneticFieldChangeTrigger(h, &magneticFieldChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return magneticFieldChangeTrigger;
	}
	return magneticFieldChangeTrigger;
}

JNIEXPORT void JNICALL Java_com_phidget22_MagnetometerBase_setMagneticFieldChangeTrigger(JNIEnv * env, jobject obj, jdouble magneticFieldChangeTrigger) {
	PhidgetMagnetometerHandle h = (PhidgetMagnetometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetMagnetometer_setMagneticFieldChangeTrigger(h, (double)magneticFieldChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MagnetometerBase_getMinMagneticFieldChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetMagnetometerHandle h = (PhidgetMagnetometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minMagneticFieldChangeTrigger;
	ret = PhidgetMagnetometer_getMinMagneticFieldChangeTrigger(h, &minMagneticFieldChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minMagneticFieldChangeTrigger;
	}
	return minMagneticFieldChangeTrigger;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MagnetometerBase_getMaxMagneticFieldChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetMagnetometerHandle h = (PhidgetMagnetometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxMagneticFieldChangeTrigger;
	ret = PhidgetMagnetometer_getMaxMagneticFieldChangeTrigger(h, &maxMagneticFieldChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxMagneticFieldChangeTrigger;
	}
	return maxMagneticFieldChangeTrigger;
}

JNIEXPORT void JNICALL Java_com_phidget22_MagnetometerBase_resetCorrectionParameters(JNIEnv * env, jobject obj) {
	PhidgetMagnetometerHandle h = (PhidgetMagnetometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetMagnetometer_resetCorrectionParameters(h);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_MagnetometerBase_saveCorrectionParameters(JNIEnv * env, jobject obj) {
	PhidgetMagnetometerHandle h = (PhidgetMagnetometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetMagnetometer_saveCorrectionParameters(h);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MagnetometerBase_getTimestamp(JNIEnv * env, jobject obj) {
	PhidgetMagnetometerHandle h = (PhidgetMagnetometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double timestamp;
	ret = PhidgetMagnetometer_getTimestamp(h, &timestamp);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return timestamp;
	}
	return timestamp;
}

static void CCONV magneticFieldChange_handler(PhidgetMagnetometerHandle h, void *arg, const double magneticField[3], double timestamp) {
	jobject magneticFieldChangeEv;
	JNIEnv *env;
	jobject obj;
	jdoubleArray magneticFieldArr;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;
	magneticFieldArr = (*env)->NewDoubleArray(env, (jsize)3);
	(*env)->SetDoubleArrayRegion(env, magneticFieldArr, 0, (jsize)3, magneticField);

	if ((magneticFieldChangeEv = (*env)->NewObject(env, magneticFieldChangeEvent_class, magneticFieldChangeEvent_cons, obj, magneticFieldArr, timestamp)) != 0) {
		(*env)->CallVoidMethod(env, obj, fireMagneticFieldChange_mid, magneticFieldChangeEv);
		(*env)->DeleteLocalRef(env, magneticFieldChangeEv);
	}
	(*env)->DeleteLocalRef(env, magneticFieldArr);
}

JNIEXPORT void JNICALL Java_com_phidget22_MagnetometerBase_enableMagneticFieldChangeEvents(JNIEnv * env, jobject obj, jboolean b) {
	if (magneticFieldChangeEvent_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/MagnetometerMagneticFieldChangeEvent");
	jlong gr = updateGlobalRef(env, obj, nativeMagneticFieldChangeHandler_fid, b);
	PhidgetMagnetometerHandle h = (PhidgetMagnetometerHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetMagnetometer_setOnMagneticFieldChangeHandler(h, b ? magneticFieldChange_handler : NULL, (void *)(uintptr_t) gr);
}
