/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of libphidget22java
 *
 * Copyright (c) 2017-2022 Phidgets Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

#include "phidget_jni.h"
#include "com_phidget22_MotorPositionControllerBase.h"

static jclass motorPositionControllerbase_class;
jclass motorPositionController_class;
jmethodID motorPositionController_cons;

static jclass positionChangeEvent_class;
static jmethodID firePositionChange_mid	;
static jmethodID positionChangeEvent_cons;
static jfieldID nativePositionChangeHandler_fid;

static jclass dutyCycleUpdateEvent_class;
static jmethodID fireDutyCycleUpdate_mid	;
static jmethodID dutyCycleUpdateEvent_cons;
static jfieldID nativeDutyCycleUpdateHandler_fid;

void com_phidget22_MotorPositionControllerBase_OnLoad(JNIEnv *env) {
	if (!(motorPositionController_class = (*env)->FindClass(env, "com/phidget22/MotorPositionController"))) {
		(*env)->ExceptionClear(env);
		return;
	}
	if (!(motorPositionController_class = (jclass)(*env)->NewGlobalRef(env, motorPositionController_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef motorPositionController_class");
	if (!(motorPositionController_cons = (*env)->GetMethodID(env, motorPositionController_class, "<init>", "(J)V")))
		JNI_ABORT_STDERR("Couldn't get Method ID <init> from motorPositionController_class");

	if (!(motorPositionControllerbase_class = (*env)->FindClass(env, "com/phidget22/MotorPositionControllerBase")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/MotorPositionControllerBase");
	if (!(motorPositionControllerbase_class = (jclass)(*env)->NewGlobalRef(env, motorPositionControllerbase_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef motorPositionControllerbase_class");

	if ((positionChangeEvent_class = (*env)->FindClass(env, "com/phidget22/MotorPositionControllerPositionChangeEvent"))) {
		if (!(positionChangeEvent_class = (jclass)(*env)->NewGlobalRef(env, positionChangeEvent_class)))
			JNI_ABORT_STDERR("Couldn't create global ref PositionChangeEvent_class");
		if (!(firePositionChange_mid = (*env)->GetMethodID(env, motorPositionControllerbase_class, "firePositionChange", "(Lcom/phidget22/MotorPositionControllerPositionChangeEvent;)V")))
			JNI_ABORT_STDERR("Couldn't get method ID firePositionChange");
		if (!(positionChangeEvent_cons = (*env)->GetMethodID(env, positionChangeEvent_class, "<init>", "(Lcom/phidget22/MotorPositionController;D)V")))
			JNI_ABORT_STDERR("Couldn't get method ID <init> from PositionChangeEvent_class");
		if (!(nativePositionChangeHandler_fid = (*env)->GetFieldID(env, motorPositionControllerbase_class, "nativePositionChangeHandler", "J")))
			JNI_ABORT_STDERR("Couldn't get Field ID nativePositionChangeHandler from motorPositionControllerbase_class");
	} else {
		(*env)->ExceptionClear(env);
	}

	if ((dutyCycleUpdateEvent_class = (*env)->FindClass(env, "com/phidget22/MotorPositionControllerDutyCycleUpdateEvent"))) {
		if (!(dutyCycleUpdateEvent_class = (jclass)(*env)->NewGlobalRef(env, dutyCycleUpdateEvent_class)))
			JNI_ABORT_STDERR("Couldn't create global ref DutyCycleUpdateEvent_class");
		if (!(fireDutyCycleUpdate_mid = (*env)->GetMethodID(env, motorPositionControllerbase_class, "fireDutyCycleUpdate", "(Lcom/phidget22/MotorPositionControllerDutyCycleUpdateEvent;)V")))
			JNI_ABORT_STDERR("Couldn't get method ID fireDutyCycleUpdate");
		if (!(dutyCycleUpdateEvent_cons = (*env)->GetMethodID(env, dutyCycleUpdateEvent_class, "<init>", "(Lcom/phidget22/MotorPositionController;D)V")))
			JNI_ABORT_STDERR("Couldn't get method ID <init> from DutyCycleUpdateEvent_class");
		if (!(nativeDutyCycleUpdateHandler_fid = (*env)->GetFieldID(env, motorPositionControllerbase_class, "nativeDutyCycleUpdateHandler", "J")))
			JNI_ABORT_STDERR("Couldn't get Field ID nativeDutyCycleUpdateHandler from motorPositionControllerbase_class");
	} else {
		(*env)->ExceptionClear(env);
	}
}
JNIEXPORT jlong JNICALL Java_com_phidget22_MotorPositionControllerBase_create(JNIEnv * env, jclass obj) {
	PhidgetMotorPositionControllerHandle phid;
	int error; 
	if ((error = PhidgetMotorPositionController_create(&phid)) != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(error);
		return 0;
	}
	return (jlong)(uintptr_t)phid;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MotorPositionControllerBase_getAcceleration(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double acceleration;
	ret = PhidgetMotorPositionController_getAcceleration(h, &acceleration);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return acceleration;
	}
	return acceleration;
}

JNIEXPORT void JNICALL Java_com_phidget22_MotorPositionControllerBase_setAcceleration(JNIEnv * env, jobject obj, jdouble acceleration) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetMotorPositionController_setAcceleration(h, (double)acceleration);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MotorPositionControllerBase_getMinAcceleration(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minAcceleration;
	ret = PhidgetMotorPositionController_getMinAcceleration(h, &minAcceleration);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minAcceleration;
	}
	return minAcceleration;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MotorPositionControllerBase_getMaxAcceleration(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxAcceleration;
	ret = PhidgetMotorPositionController_getMaxAcceleration(h, &maxAcceleration);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxAcceleration;
	}
	return maxAcceleration;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MotorPositionControllerBase_getMinBrakingStrength(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minBrakingStrength;
	ret = PhidgetMotorPositionController_getMinBrakingStrength(h, &minBrakingStrength);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minBrakingStrength;
	}
	return minBrakingStrength;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MotorPositionControllerBase_getMaxBrakingStrength(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxBrakingStrength;
	ret = PhidgetMotorPositionController_getMaxBrakingStrength(h, &maxBrakingStrength);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxBrakingStrength;
	}
	return maxBrakingStrength;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MotorPositionControllerBase_getCurrentLimit(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double currentLimit;
	ret = PhidgetMotorPositionController_getCurrentLimit(h, &currentLimit);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return currentLimit;
	}
	return currentLimit;
}

JNIEXPORT void JNICALL Java_com_phidget22_MotorPositionControllerBase_setCurrentLimit(JNIEnv * env, jobject obj, jdouble currentLimit) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetMotorPositionController_setCurrentLimit(h, (double)currentLimit);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MotorPositionControllerBase_getMinCurrentLimit(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minCurrentLimit;
	ret = PhidgetMotorPositionController_getMinCurrentLimit(h, &minCurrentLimit);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minCurrentLimit;
	}
	return minCurrentLimit;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MotorPositionControllerBase_getMaxCurrentLimit(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxCurrentLimit;
	ret = PhidgetMotorPositionController_getMaxCurrentLimit(h, &maxCurrentLimit);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxCurrentLimit;
	}
	return maxCurrentLimit;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MotorPositionControllerBase_getCurrentRegulatorGain(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double currentRegulatorGain;
	ret = PhidgetMotorPositionController_getCurrentRegulatorGain(h, &currentRegulatorGain);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return currentRegulatorGain;
	}
	return currentRegulatorGain;
}

JNIEXPORT void JNICALL Java_com_phidget22_MotorPositionControllerBase_setCurrentRegulatorGain(JNIEnv * env, jobject obj, jdouble currentRegulatorGain) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetMotorPositionController_setCurrentRegulatorGain(h, (double)currentRegulatorGain);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MotorPositionControllerBase_getMinCurrentRegulatorGain(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minCurrentRegulatorGain;
	ret = PhidgetMotorPositionController_getMinCurrentRegulatorGain(h, &minCurrentRegulatorGain);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minCurrentRegulatorGain;
	}
	return minCurrentRegulatorGain;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MotorPositionControllerBase_getMaxCurrentRegulatorGain(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxCurrentRegulatorGain;
	ret = PhidgetMotorPositionController_getMaxCurrentRegulatorGain(h, &maxCurrentRegulatorGain);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxCurrentRegulatorGain;
	}
	return maxCurrentRegulatorGain;
}

JNIEXPORT jint JNICALL Java_com_phidget22_MotorPositionControllerBase_getDataInterval(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t dataInterval;
	ret = PhidgetMotorPositionController_getDataInterval(h, &dataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return dataInterval;
	}
	return dataInterval;
}

JNIEXPORT void JNICALL Java_com_phidget22_MotorPositionControllerBase_setDataInterval(JNIEnv * env, jobject obj, jint dataInterval) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetMotorPositionController_setDataInterval(h, (uint32_t)dataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jint JNICALL Java_com_phidget22_MotorPositionControllerBase_getMinDataInterval(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t minDataInterval;
	ret = PhidgetMotorPositionController_getMinDataInterval(h, &minDataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minDataInterval;
	}
	return minDataInterval;
}

JNIEXPORT jint JNICALL Java_com_phidget22_MotorPositionControllerBase_getMaxDataInterval(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t maxDataInterval;
	ret = PhidgetMotorPositionController_getMaxDataInterval(h, &maxDataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxDataInterval;
	}
	return maxDataInterval;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MotorPositionControllerBase_getDataRate(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double dataRate;
	ret = PhidgetMotorPositionController_getDataRate(h, &dataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return dataRate;
	}
	return dataRate;
}

JNIEXPORT void JNICALL Java_com_phidget22_MotorPositionControllerBase_setDataRate(JNIEnv * env, jobject obj, jdouble dataRate) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetMotorPositionController_setDataRate(h, (double)dataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MotorPositionControllerBase_getMinDataRate(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minDataRate;
	ret = PhidgetMotorPositionController_getMinDataRate(h, &minDataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minDataRate;
	}
	return minDataRate;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MotorPositionControllerBase_getMaxDataRate(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxDataRate;
	ret = PhidgetMotorPositionController_getMaxDataRate(h, &maxDataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxDataRate;
	}
	return maxDataRate;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MotorPositionControllerBase_getDeadBand(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double deadBand;
	ret = PhidgetMotorPositionController_getDeadBand(h, &deadBand);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return deadBand;
	}
	return deadBand;
}

JNIEXPORT void JNICALL Java_com_phidget22_MotorPositionControllerBase_setDeadBand(JNIEnv * env, jobject obj, jdouble deadBand) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetMotorPositionController_setDeadBand(h, (double)deadBand);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MotorPositionControllerBase_getDutyCycle(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double dutyCycle;
	ret = PhidgetMotorPositionController_getDutyCycle(h, &dutyCycle);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return dutyCycle;
	}
	return dutyCycle;
}

JNIEXPORT jboolean JNICALL Java_com_phidget22_MotorPositionControllerBase_getEngaged(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	int engaged;
	ret = PhidgetMotorPositionController_getEngaged(h, &engaged);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return engaged;
	}
	return engaged;
}

JNIEXPORT void JNICALL Java_com_phidget22_MotorPositionControllerBase_setEngaged(JNIEnv * env, jobject obj, jboolean engaged) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetMotorPositionController_setEngaged(h, (int)engaged);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_MotorPositionControllerBase_enableFailsafe(JNIEnv * env, jobject obj, jint failsafeTime) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetMotorPositionController_enableFailsafe(h, (uint32_t)failsafeTime);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jint JNICALL Java_com_phidget22_MotorPositionControllerBase_getMinFailsafeTime(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t minFailsafeTime;
	ret = PhidgetMotorPositionController_getMinFailsafeTime(h, &minFailsafeTime);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minFailsafeTime;
	}
	return minFailsafeTime;
}

JNIEXPORT jint JNICALL Java_com_phidget22_MotorPositionControllerBase_getMaxFailsafeTime(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t maxFailsafeTime;
	ret = PhidgetMotorPositionController_getMaxFailsafeTime(h, &maxFailsafeTime);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxFailsafeTime;
	}
	return maxFailsafeTime;
}

JNIEXPORT jobject JNICALL Java_com_phidget22_MotorPositionControllerBase_getFanMode(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	Phidget_FanMode fanMode;
	if (FanMode_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/FanMode");
	ret = PhidgetMotorPositionController_getFanMode(h, &fanMode);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return NULL;
	}
	return (*env)->CallStaticObjectMethod(env, FanMode_class, FanMode_getEnum_mid, fanMode);
}

JNIEXPORT void JNICALL Java_com_phidget22_MotorPositionControllerBase_setFanMode(JNIEnv * env, jobject obj, jobject fanMode) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	if (FanMode_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/FanMode");
	ret = PhidgetMotorPositionController_setFanMode(h, (Phidget_FanMode)(*env)->CallIntMethod(env, fanMode, FanMode_getCode_mid));
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jobject JNICALL Java_com_phidget22_MotorPositionControllerBase_getIOMode(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	Phidget_EncoderIOMode IOMode;
	if (EncoderIOMode_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/EncoderIOMode");
	ret = PhidgetMotorPositionController_getIOMode(h, &IOMode);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return NULL;
	}
	return (*env)->CallStaticObjectMethod(env, EncoderIOMode_class, EncoderIOMode_getEnum_mid, IOMode);
}

JNIEXPORT void JNICALL Java_com_phidget22_MotorPositionControllerBase_setIOMode(JNIEnv * env, jobject obj, jobject IOMode) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	if (EncoderIOMode_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/EncoderIOMode");
	ret = PhidgetMotorPositionController_setIOMode(h, (Phidget_EncoderIOMode)(*env)->CallIntMethod(env, IOMode, EncoderIOMode_getCode_mid));
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MotorPositionControllerBase_getKd(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double kd;
	ret = PhidgetMotorPositionController_getKd(h, &kd);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return kd;
	}
	return kd;
}

JNIEXPORT void JNICALL Java_com_phidget22_MotorPositionControllerBase_setKd(JNIEnv * env, jobject obj, jdouble kd) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetMotorPositionController_setKd(h, (double)kd);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MotorPositionControllerBase_getKi(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double ki;
	ret = PhidgetMotorPositionController_getKi(h, &ki);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return ki;
	}
	return ki;
}

JNIEXPORT void JNICALL Java_com_phidget22_MotorPositionControllerBase_setKi(JNIEnv * env, jobject obj, jdouble ki) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetMotorPositionController_setKi(h, (double)ki);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MotorPositionControllerBase_getKp(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double kp;
	ret = PhidgetMotorPositionController_getKp(h, &kp);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return kp;
	}
	return kp;
}

JNIEXPORT void JNICALL Java_com_phidget22_MotorPositionControllerBase_setKp(JNIEnv * env, jobject obj, jdouble kp) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetMotorPositionController_setKp(h, (double)kp);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MotorPositionControllerBase_getPosition(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double position;
	ret = PhidgetMotorPositionController_getPosition(h, &position);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return position;
	}
	return position;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MotorPositionControllerBase_getMinPosition(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minPosition;
	ret = PhidgetMotorPositionController_getMinPosition(h, &minPosition);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minPosition;
	}
	return minPosition;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MotorPositionControllerBase_getMaxPosition(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxPosition;
	ret = PhidgetMotorPositionController_getMaxPosition(h, &maxPosition);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxPosition;
	}
	return maxPosition;
}

JNIEXPORT void JNICALL Java_com_phidget22_MotorPositionControllerBase_addPositionOffset(JNIEnv * env, jobject obj, jdouble positionOffset) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetMotorPositionController_addPositionOffset(h, (double)positionOffset);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MotorPositionControllerBase_getRescaleFactor(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double rescaleFactor;
	ret = PhidgetMotorPositionController_getRescaleFactor(h, &rescaleFactor);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return rescaleFactor;
	}
	return rescaleFactor;
}

JNIEXPORT void JNICALL Java_com_phidget22_MotorPositionControllerBase_setRescaleFactor(JNIEnv * env, jobject obj, jdouble rescaleFactor) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetMotorPositionController_setRescaleFactor(h, (double)rescaleFactor);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_MotorPositionControllerBase_resetFailsafe(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetMotorPositionController_resetFailsafe(h);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MotorPositionControllerBase_getStallVelocity(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double stallVelocity;
	ret = PhidgetMotorPositionController_getStallVelocity(h, &stallVelocity);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return stallVelocity;
	}
	return stallVelocity;
}

JNIEXPORT void JNICALL Java_com_phidget22_MotorPositionControllerBase_setStallVelocity(JNIEnv * env, jobject obj, jdouble stallVelocity) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetMotorPositionController_setStallVelocity(h, (double)stallVelocity);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MotorPositionControllerBase_getMinStallVelocity(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minStallVelocity;
	ret = PhidgetMotorPositionController_getMinStallVelocity(h, &minStallVelocity);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minStallVelocity;
	}
	return minStallVelocity;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MotorPositionControllerBase_getMaxStallVelocity(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxStallVelocity;
	ret = PhidgetMotorPositionController_getMaxStallVelocity(h, &maxStallVelocity);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxStallVelocity;
	}
	return maxStallVelocity;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MotorPositionControllerBase_getTargetBrakingStrength(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double targetBrakingStrength;
	ret = PhidgetMotorPositionController_getTargetBrakingStrength(h, &targetBrakingStrength);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return targetBrakingStrength;
	}
	return targetBrakingStrength;
}

JNIEXPORT void JNICALL Java_com_phidget22_MotorPositionControllerBase_setTargetBrakingStrength(JNIEnv * env, jobject obj, jdouble targetBrakingStrength) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetMotorPositionController_setTargetBrakingStrength(h, (double)targetBrakingStrength);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MotorPositionControllerBase_getTargetPosition(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double targetPosition;
	ret = PhidgetMotorPositionController_getTargetPosition(h, &targetPosition);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return targetPosition;
	}
	return targetPosition;
}

JNIEXPORT void JNICALL Java_com_phidget22_MotorPositionControllerBase_setTargetPosition__DLcom_phidget22_AsyncListener_2(JNIEnv * env, jobject obj, jdouble targetPosition, jobject asyncHandler) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	jclass obj_class = (*env)->FindClass(env, "Ljava/lang/Object;");
	jobjectArray arr = (*env)->NewObjectArray(env, 2, obj_class, NULL);
	(*env)->SetObjectArrayElement(env, arr, 0, obj);
	(*env)->SetObjectArrayElement(env, arr, 1, asyncHandler);
	PhidgetMotorPositionController_setTargetPosition_async(h, (double)targetPosition, asyncCallbackHandler, (*env)->NewGlobalRef(env, arr));
	(*env)->DeleteLocalRef(env, arr);
}

JNIEXPORT void JNICALL Java_com_phidget22_MotorPositionControllerBase_setTargetPosition__D(JNIEnv * env, jobject obj, jdouble targetPosition) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetMotorPositionController_setTargetPosition(h, (double)targetPosition);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MotorPositionControllerBase_getVelocityLimit(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double velocityLimit;
	ret = PhidgetMotorPositionController_getVelocityLimit(h, &velocityLimit);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return velocityLimit;
	}
	return velocityLimit;
}

JNIEXPORT void JNICALL Java_com_phidget22_MotorPositionControllerBase_setVelocityLimit(JNIEnv * env, jobject obj, jdouble velocityLimit) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetMotorPositionController_setVelocityLimit(h, (double)velocityLimit);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MotorPositionControllerBase_getMinVelocityLimit(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minVelocityLimit;
	ret = PhidgetMotorPositionController_getMinVelocityLimit(h, &minVelocityLimit);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minVelocityLimit;
	}
	return minVelocityLimit;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_MotorPositionControllerBase_getMaxVelocityLimit(JNIEnv * env, jobject obj) {
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxVelocityLimit;
	ret = PhidgetMotorPositionController_getMaxVelocityLimit(h, &maxVelocityLimit);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxVelocityLimit;
	}
	return maxVelocityLimit;
}

static void CCONV dutyCycleUpdate_handler(PhidgetMotorPositionControllerHandle h, void *arg, double dutyCycle) {
	jobject dutyCycleUpdateEv;
	JNIEnv *env;
	jobject obj;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;

	if ((dutyCycleUpdateEv = (*env)->NewObject(env, dutyCycleUpdateEvent_class, dutyCycleUpdateEvent_cons, obj, dutyCycle)) != 0) {
		(*env)->CallVoidMethod(env, obj, fireDutyCycleUpdate_mid, dutyCycleUpdateEv);
		(*env)->DeleteLocalRef(env, dutyCycleUpdateEv);
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_MotorPositionControllerBase_enableDutyCycleUpdateEvents(JNIEnv * env, jobject obj, jboolean b) {
	if (dutyCycleUpdateEvent_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/MotorPositionControllerDutyCycleUpdateEvent");
	jlong gr = updateGlobalRef(env, obj, nativeDutyCycleUpdateHandler_fid, b);
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetMotorPositionController_setOnDutyCycleUpdateHandler(h, b ? dutyCycleUpdate_handler : NULL, (void *)(uintptr_t) gr);
}

static void CCONV positionChange_handler(PhidgetMotorPositionControllerHandle h, void *arg, double position) {
	jobject positionChangeEv;
	JNIEnv *env;
	jobject obj;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;

	if ((positionChangeEv = (*env)->NewObject(env, positionChangeEvent_class, positionChangeEvent_cons, obj, position)) != 0) {
		(*env)->CallVoidMethod(env, obj, firePositionChange_mid, positionChangeEv);
		(*env)->DeleteLocalRef(env, positionChangeEv);
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_MotorPositionControllerBase_enablePositionChangeEvents(JNIEnv * env, jobject obj, jboolean b) {
	if (positionChangeEvent_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/MotorPositionControllerPositionChangeEvent");
	jlong gr = updateGlobalRef(env, obj, nativePositionChangeHandler_fid, b);
	PhidgetMotorPositionControllerHandle h = (PhidgetMotorPositionControllerHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetMotorPositionController_setOnPositionChangeHandler(h, b ? positionChange_handler : NULL, (void *)(uintptr_t) gr);
}
