/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of libphidget22java
 *
 * Copyright (c) 2017-2022 Phidgets Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

#include "phidget_jni.h"
#include "com_phidget22_NetBase.h"

static jclass netbase_class;
jclass net_class;

static jclass serverAddedEvent_class;
static jmethodID fireServerAdded_mid	;
static jmethodID serverAddedEvent_cons;
static jfieldID nativeServerAddedHandler_fid;

static jclass serverRemovedEvent_class;
static jmethodID fireServerRemoved_mid	;
static jmethodID serverRemovedEvent_cons;
static jfieldID nativeServerRemovedHandler_fid;

void com_phidget22_NetBase_OnLoad(JNIEnv *env) {
	if (!(net_class = (*env)->FindClass(env, "com/phidget22/Net"))) {
		(*env)->ExceptionClear(env);
		return;
	}
	if (!(net_class = (jclass)(*env)->NewGlobalRef(env, net_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef net_class");

	if (!(netbase_class = (*env)->FindClass(env, "com/phidget22/NetBase")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/NetBase");
	if (!(netbase_class = (jclass)(*env)->NewGlobalRef(env, netbase_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef netbase_class");

	if ((serverAddedEvent_class = (*env)->FindClass(env, "com/phidget22/NetServerAddedEvent"))) {
		if (!(serverAddedEvent_class = (jclass)(*env)->NewGlobalRef(env, serverAddedEvent_class)))
			JNI_ABORT_STDERR("Couldn't create global ref ServerAddedEvent_class");
		if (!(fireServerAdded_mid = (*env)->GetMethodID(env, netbase_class, "fireServerAdded", "(Lcom/phidget22/NetServerAddedEvent;)V")))
			JNI_ABORT_STDERR("Couldn't get method ID fireServerAdded");
		if (!(serverAddedEvent_cons = (*env)->GetMethodID(env, serverAddedEvent_class, "<init>", "(Lcom/phidget22/Net;Lcom/phidget22/PhidgetServer;J)V")))
			JNI_ABORT_STDERR("Couldn't get method ID <init> from ServerAddedEvent_class");
		if (!(nativeServerAddedHandler_fid = (*env)->GetFieldID(env, netbase_class, "nativeServerAddedHandler", "J")))
			JNI_ABORT_STDERR("Couldn't get Field ID nativeServerAddedHandler from netbase_class");
	} else {
		(*env)->ExceptionClear(env);
	}

	if ((serverRemovedEvent_class = (*env)->FindClass(env, "com/phidget22/NetServerRemovedEvent"))) {
		if (!(serverRemovedEvent_class = (jclass)(*env)->NewGlobalRef(env, serverRemovedEvent_class)))
			JNI_ABORT_STDERR("Couldn't create global ref ServerRemovedEvent_class");
		if (!(fireServerRemoved_mid = (*env)->GetMethodID(env, netbase_class, "fireServerRemoved", "(Lcom/phidget22/NetServerRemovedEvent;)V")))
			JNI_ABORT_STDERR("Couldn't get method ID fireServerRemoved");
		if (!(serverRemovedEvent_cons = (*env)->GetMethodID(env, serverRemovedEvent_class, "<init>", "(Lcom/phidget22/Net;Lcom/phidget22/PhidgetServer;)V")))
			JNI_ABORT_STDERR("Couldn't get method ID <init> from ServerRemovedEvent_class");
		if (!(nativeServerRemovedHandler_fid = (*env)->GetFieldID(env, netbase_class, "nativeServerRemovedHandler", "J")))
			JNI_ABORT_STDERR("Couldn't get Field ID nativeServerRemovedHandler from netbase_class");
	} else {
		(*env)->ExceptionClear(env);
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_NetBase_addServer(JNIEnv * env, jobject obj, jstring serverName, jstring address, jint port, jstring password, jint flags) {
	PhidgetReturnCode ret;
	const char *serverNameUTFChars = (serverName == NULL ? NULL : (*env)->GetStringUTFChars(env, serverName, NULL));
	const char *addressUTFChars = (address == NULL ? NULL : (*env)->GetStringUTFChars(env, address, NULL));
	const char *passwordUTFChars = (password == NULL ? NULL : (*env)->GetStringUTFChars(env, password, NULL));
	ret = PhidgetNet_addServer((const char *)serverNameUTFChars, (const char *)addressUTFChars, (int)port, (const char *)passwordUTFChars, (int)flags);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		if (serverNameUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, serverName, serverNameUTFChars);
		if (addressUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, address, addressUTFChars);
		if (passwordUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, password, passwordUTFChars);
		return;
	}
	if (serverNameUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, serverName, serverNameUTFChars);
	if (addressUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, address, addressUTFChars);
	if (passwordUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, password, passwordUTFChars);
}

JNIEXPORT void JNICALL Java_com_phidget22_NetBase_removeServer(JNIEnv * env, jobject obj, jstring serverName) {
	PhidgetReturnCode ret;
	const char *serverNameUTFChars = (serverName == NULL ? NULL : (*env)->GetStringUTFChars(env, serverName, NULL));
	ret = PhidgetNet_removeServer((const char *)serverNameUTFChars);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		if (serverNameUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, serverName, serverNameUTFChars);
		return;
	}
	if (serverNameUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, serverName, serverNameUTFChars);
}

JNIEXPORT void JNICALL Java_com_phidget22_NetBase_enableServer(JNIEnv * env, jobject obj, jstring serverName) {
	PhidgetReturnCode ret;
	const char *serverNameUTFChars = (serverName == NULL ? NULL : (*env)->GetStringUTFChars(env, serverName, NULL));
	ret = PhidgetNet_enableServer((const char *)serverNameUTFChars);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		if (serverNameUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, serverName, serverNameUTFChars);
		return;
	}
	if (serverNameUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, serverName, serverNameUTFChars);
}

JNIEXPORT void JNICALL Java_com_phidget22_NetBase_disableServer(JNIEnv * env, jobject obj, jstring serverName, jint flags) {
	PhidgetReturnCode ret;
	const char *serverNameUTFChars = (serverName == NULL ? NULL : (*env)->GetStringUTFChars(env, serverName, NULL));
	ret = PhidgetNet_disableServer((const char *)serverNameUTFChars, (int)flags);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		if (serverNameUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, serverName, serverNameUTFChars);
		return;
	}
	if (serverNameUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, serverName, serverNameUTFChars);
}

JNIEXPORT void JNICALL Java_com_phidget22_NetBase_enableServerDiscovery(JNIEnv * env, jobject obj, jobject serverType) {
	PhidgetReturnCode ret;
	if (ServerType_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/ServerType");
	ret = PhidgetNet_enableServerDiscovery((PhidgetServerType)(*env)->CallIntMethod(env, serverType, ServerType_getCode_mid));
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_NetBase_disableServerDiscovery(JNIEnv * env, jobject obj, jobject serverType) {
	PhidgetReturnCode ret;
	if (ServerType_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/ServerType");
	ret = PhidgetNet_disableServerDiscovery((PhidgetServerType)(*env)->CallIntMethod(env, serverType, ServerType_getCode_mid));
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_NetBase_setServerPassword(JNIEnv * env, jobject obj, jstring serverName, jstring password) {
	PhidgetReturnCode ret;
	const char *serverNameUTFChars = (serverName == NULL ? NULL : (*env)->GetStringUTFChars(env, serverName, NULL));
	const char *passwordUTFChars = (password == NULL ? NULL : (*env)->GetStringUTFChars(env, password, NULL));
	ret = PhidgetNet_setServerPassword((const char *)serverNameUTFChars, (const char *)passwordUTFChars);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		if (serverNameUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, serverName, serverNameUTFChars);
		if (passwordUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, password, passwordUTFChars);
		return;
	}
	if (serverNameUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, serverName, serverNameUTFChars);
	if (passwordUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, password, passwordUTFChars);
}

static void CCONV serverAdded_handler(void *arg, PhidgetServer *server, void * kv) {
	jobject serverAddedEv;
	JNIEnv *env;
	jobject obj;
	jobject serverObj;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;
	serverObj = PhidgetServer_to_jobject(env, server);

	if ((serverAddedEv = (*env)->NewObject(env, serverAddedEvent_class, serverAddedEvent_cons, obj, serverObj, kv)) != 0) {
		(*env)->CallVoidMethod(env, obj, fireServerAdded_mid, serverAddedEv);
		(*env)->DeleteLocalRef(env, serverAddedEv);
	}
	(*env)->DeleteLocalRef(env, serverObj);
}

JNIEXPORT void JNICALL Java_com_phidget22_NetBase_enableServerAddedEvents(JNIEnv * env, jobject obj, jboolean b) {
	if (serverAddedEvent_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/NetServerAddedEvent");
	jlong gr = updateGlobalRef(env, obj, nativeServerAddedHandler_fid, b);
	PhidgetNet_setOnServerAddedHandler(b ? serverAdded_handler : NULL, (void *)(uintptr_t) gr);
}

static void CCONV serverRemoved_handler(void *arg, PhidgetServer *server) {
	jobject serverRemovedEv;
	JNIEnv *env;
	jobject obj;
	jobject serverObj;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;
	serverObj = PhidgetServer_to_jobject(env, server);

	if ((serverRemovedEv = (*env)->NewObject(env, serverRemovedEvent_class, serverRemovedEvent_cons, obj, serverObj)) != 0) {
		(*env)->CallVoidMethod(env, obj, fireServerRemoved_mid, serverRemovedEv);
		(*env)->DeleteLocalRef(env, serverRemovedEv);
	}
	(*env)->DeleteLocalRef(env, serverObj);
}

JNIEXPORT void JNICALL Java_com_phidget22_NetBase_enableServerRemovedEvents(JNIEnv * env, jobject obj, jboolean b) {
	if (serverRemovedEvent_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/NetServerRemovedEvent");
	jlong gr = updateGlobalRef(env, obj, nativeServerRemovedHandler_fid, b);
	PhidgetNet_setOnServerRemovedHandler(b ? serverRemoved_handler : NULL, (void *)(uintptr_t) gr);
}
