/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of libphidget22java
 *
 * Copyright (c) 2017-2022 Phidgets Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

#include "phidget_jni.h"
#include "com_phidget22_PhidgetBase.h"

static jclass phidgetbase_class;
jclass phidget_class;
jfieldID phidget_handle_fid;

static jclass attachEvent_class;
static jmethodID fireAttach_mid	;
static jmethodID attachEvent_cons;
static jfieldID nativeAttachHandler_fid;

static jclass detachEvent_class;
static jmethodID fireDetach_mid	;
static jmethodID detachEvent_cons;
static jfieldID nativeDetachHandler_fid;

static jclass errorEvent_class;
static jmethodID fireError_mid	;
static jmethodID errorEvent_cons;
static jfieldID nativeErrorHandler_fid;

static jclass propertyChangeEvent_class;
static jmethodID firePropertyChange_mid	;
static jmethodID propertyChangeEvent_cons;
static jfieldID nativePropertyChangeHandler_fid;

void com_phidget22_PhidgetBase_OnLoad(JNIEnv *env) {
	if (!(phidget_class = (*env)->FindClass(env, "com/phidget22/Phidget"))) {
		(*env)->ExceptionClear(env);
		return;
	}
	if (!(phidget_class = (jclass)(*env)->NewGlobalRef(env, phidget_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef phidget_class");

	if (!(phidgetbase_class = (*env)->FindClass(env, "com/phidget22/PhidgetBase")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/PhidgetBase");
	if (!(phidgetbase_class = (jclass)(*env)->NewGlobalRef(env, phidgetbase_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef phidgetbase_class");
	if (!(phidget_handle_fid = (*env)->GetFieldID(env, phidgetbase_class, "handle", "J")))
		JNI_ABORT_STDERR("Couldn't get Field ID handle from phidgetbase_class");

	if ((attachEvent_class = (*env)->FindClass(env, "com/phidget22/AttachEvent"))) {
		if (!(attachEvent_class = (jclass)(*env)->NewGlobalRef(env, attachEvent_class)))
			JNI_ABORT_STDERR("Couldn't create global ref AttachEvent_class");
		if (!(fireAttach_mid = (*env)->GetMethodID(env, phidgetbase_class, "fireAttach", "(Lcom/phidget22/AttachEvent;)V")))
			JNI_ABORT_STDERR("Couldn't get method ID fireAttach");
		if (!(attachEvent_cons = (*env)->GetMethodID(env, attachEvent_class, "<init>", "(Lcom/phidget22/Phidget;)V")))
			JNI_ABORT_STDERR("Couldn't get method ID <init> from AttachEvent_class");
		if (!(nativeAttachHandler_fid = (*env)->GetFieldID(env, phidgetbase_class, "nativeAttachHandler", "J")))
			JNI_ABORT_STDERR("Couldn't get Field ID nativeAttachHandler from phidgetbase_class");
	} else {
		(*env)->ExceptionClear(env);
	}

	if ((detachEvent_class = (*env)->FindClass(env, "com/phidget22/DetachEvent"))) {
		if (!(detachEvent_class = (jclass)(*env)->NewGlobalRef(env, detachEvent_class)))
			JNI_ABORT_STDERR("Couldn't create global ref DetachEvent_class");
		if (!(fireDetach_mid = (*env)->GetMethodID(env, phidgetbase_class, "fireDetach", "(Lcom/phidget22/DetachEvent;)V")))
			JNI_ABORT_STDERR("Couldn't get method ID fireDetach");
		if (!(detachEvent_cons = (*env)->GetMethodID(env, detachEvent_class, "<init>", "(Lcom/phidget22/Phidget;)V")))
			JNI_ABORT_STDERR("Couldn't get method ID <init> from DetachEvent_class");
		if (!(nativeDetachHandler_fid = (*env)->GetFieldID(env, phidgetbase_class, "nativeDetachHandler", "J")))
			JNI_ABORT_STDERR("Couldn't get Field ID nativeDetachHandler from phidgetbase_class");
	} else {
		(*env)->ExceptionClear(env);
	}

	if ((errorEvent_class = (*env)->FindClass(env, "com/phidget22/ErrorEvent"))) {
		if (!(errorEvent_class = (jclass)(*env)->NewGlobalRef(env, errorEvent_class)))
			JNI_ABORT_STDERR("Couldn't create global ref ErrorEvent_class");
		if (!(fireError_mid = (*env)->GetMethodID(env, phidgetbase_class, "fireError", "(Lcom/phidget22/ErrorEvent;)V")))
			JNI_ABORT_STDERR("Couldn't get method ID fireError");
		if (!(errorEvent_cons = (*env)->GetMethodID(env, errorEvent_class, "<init>", "(Lcom/phidget22/Phidget;Lcom/phidget22/ErrorEventCode;Ljava/lang/String;)V")))
			JNI_ABORT_STDERR("Couldn't get method ID <init> from ErrorEvent_class");
		if (!(nativeErrorHandler_fid = (*env)->GetFieldID(env, phidgetbase_class, "nativeErrorHandler", "J")))
			JNI_ABORT_STDERR("Couldn't get Field ID nativeErrorHandler from phidgetbase_class");
	} else {
		(*env)->ExceptionClear(env);
	}

	if ((propertyChangeEvent_class = (*env)->FindClass(env, "com/phidget22/PropertyChangeEvent"))) {
		if (!(propertyChangeEvent_class = (jclass)(*env)->NewGlobalRef(env, propertyChangeEvent_class)))
			JNI_ABORT_STDERR("Couldn't create global ref PropertyChangeEvent_class");
		if (!(firePropertyChange_mid = (*env)->GetMethodID(env, phidgetbase_class, "firePropertyChange", "(Lcom/phidget22/PropertyChangeEvent;)V")))
			JNI_ABORT_STDERR("Couldn't get method ID firePropertyChange");
		if (!(propertyChangeEvent_cons = (*env)->GetMethodID(env, propertyChangeEvent_class, "<init>", "(Lcom/phidget22/Phidget;Ljava/lang/String;)V")))
			JNI_ABORT_STDERR("Couldn't get method ID <init> from PropertyChangeEvent_class");
		if (!(nativePropertyChangeHandler_fid = (*env)->GetFieldID(env, phidgetbase_class, "nativePropertyChangeHandler", "J")))
			JNI_ABORT_STDERR("Couldn't get Field ID nativePropertyChangeHandler from phidgetbase_class");
	} else {
		(*env)->ExceptionClear(env);
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_PhidgetBase_finalize(JNIEnv * env, jobject obj, jint flags) {
	PhidgetReturnCode ret;
	ret = Phidget_finalize((int32_t)flags);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jstring JNICALL Java_com_phidget22_PhidgetBase_getLibraryVersion(JNIEnv * env, jobject obj) {
	PhidgetReturnCode ret;
	const char * libraryVersion;
	ret = Phidget_getLibraryVersion(&libraryVersion);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return NULL;
	}
	return (*env)->NewStringUTF(env, libraryVersion);
}

JNIEXPORT jstring JNICALL Java_com_phidget22_PhidgetBase_getLibraryVersionNumber(JNIEnv * env, jobject obj) {
	PhidgetReturnCode ret;
	const char * libraryVersionNumber;
	ret = Phidget_getLibraryVersionNumber(&libraryVersionNumber);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return NULL;
	}
	return (*env)->NewStringUTF(env, libraryVersionNumber);
}

JNIEXPORT void JNICALL Java_com_phidget22_PhidgetBase_resetLibrary(JNIEnv * env, jobject obj) {
	PhidgetReturnCode ret;
	ret = Phidget_resetLibrary();
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jboolean JNICALL Java_com_phidget22_PhidgetBase_getAttached(JNIEnv * env, jobject obj) {
	PhidgetHandle h = (PhidgetHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	int attached;
	ret = Phidget_getAttached(h, &attached);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return attached;
	}
	return attached;
}

JNIEXPORT jint JNICALL Java_com_phidget22_PhidgetBase_getChannel(JNIEnv * env, jobject obj) {
	PhidgetHandle h = (PhidgetHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	int channel;
	ret = Phidget_getChannel(h, &channel);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return channel;
	}
	return channel;
}

JNIEXPORT void JNICALL Java_com_phidget22_PhidgetBase_setChannel(JNIEnv * env, jobject obj, jint channel) {
	PhidgetHandle h = (PhidgetHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = Phidget_setChannel(h, (int)channel);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jobject JNICALL Java_com_phidget22_PhidgetBase_getChannelClass(JNIEnv * env, jobject obj) {
	PhidgetHandle h = (PhidgetHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	Phidget_ChannelClass channelClass;
	if (ChannelClass_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/ChannelClass");
	ret = Phidget_getChannelClass(h, &channelClass);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return NULL;
	}
	return (*env)->CallStaticObjectMethod(env, ChannelClass_class, ChannelClass_getEnum_mid, channelClass);
}

JNIEXPORT jstring JNICALL Java_com_phidget22_PhidgetBase_getChannelClassName(JNIEnv * env, jobject obj) {
	PhidgetHandle h = (PhidgetHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	const char * channelClassName;
	ret = Phidget_getChannelClassName(h, &channelClassName);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return NULL;
	}
	return (*env)->NewStringUTF(env, channelClassName);
}

JNIEXPORT jstring JNICALL Java_com_phidget22_PhidgetBase_getChannelName(JNIEnv * env, jobject obj) {
	PhidgetHandle h = (PhidgetHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	const char * channelName;
	ret = Phidget_getChannelName(h, &channelName);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return NULL;
	}
	return (*env)->NewStringUTF(env, channelName);
}

JNIEXPORT jobject JNICALL Java_com_phidget22_PhidgetBase_getChannelSubclass(JNIEnv * env, jobject obj) {
	PhidgetHandle h = (PhidgetHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	Phidget_ChannelSubclass channelSubclass;
	if (ChannelSubclass_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/ChannelSubclass");
	ret = Phidget_getChannelSubclass(h, &channelSubclass);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return NULL;
	}
	return (*env)->CallStaticObjectMethod(env, ChannelSubclass_class, ChannelSubclass_getEnum_mid, channelSubclass);
}

JNIEXPORT void JNICALL Java_com_phidget22_PhidgetBase_close(JNIEnv * env, jobject obj) {
	PhidgetHandle h = (PhidgetHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = Phidget_close(h);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jint JNICALL Java_com_phidget22_PhidgetBase_getDeviceChannelCount(JNIEnv * env, jobject obj, jobject cls) {
	PhidgetHandle h = (PhidgetHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	if (ChannelClass_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/ChannelClass");
	uint32_t count;
	ret = Phidget_getDeviceChannelCount(h, (Phidget_ChannelClass)(*env)->CallIntMethod(env, cls, ChannelClass_getCode_mid), &count);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return count;
	}
	return count;
}

JNIEXPORT jobject JNICALL Java_com_phidget22_PhidgetBase_getDeviceClass(JNIEnv * env, jobject obj) {
	PhidgetHandle h = (PhidgetHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	Phidget_DeviceClass deviceClass;
	if (DeviceClass_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/DeviceClass");
	ret = Phidget_getDeviceClass(h, &deviceClass);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return NULL;
	}
	return (*env)->CallStaticObjectMethod(env, DeviceClass_class, DeviceClass_getEnum_mid, deviceClass);
}

JNIEXPORT jstring JNICALL Java_com_phidget22_PhidgetBase_getDeviceClassName(JNIEnv * env, jobject obj) {
	PhidgetHandle h = (PhidgetHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	const char * deviceClassName;
	ret = Phidget_getDeviceClassName(h, &deviceClassName);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return NULL;
	}
	return (*env)->NewStringUTF(env, deviceClassName);
}

JNIEXPORT jobject JNICALL Java_com_phidget22_PhidgetBase_getDeviceID(JNIEnv * env, jobject obj) {
	PhidgetHandle h = (PhidgetHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	Phidget_DeviceID deviceID;
	if (DeviceID_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/DeviceID");
	ret = Phidget_getDeviceID(h, &deviceID);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return NULL;
	}
	return (*env)->CallStaticObjectMethod(env, DeviceID_class, DeviceID_getEnum_mid, deviceID);
}

JNIEXPORT jstring JNICALL Java_com_phidget22_PhidgetBase_getDeviceLabel(JNIEnv * env, jobject obj) {
	PhidgetHandle h = (PhidgetHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	const char * deviceLabel;
	ret = Phidget_getDeviceLabel(h, &deviceLabel);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return NULL;
	}
	return (*env)->NewStringUTF(env, deviceLabel);
}

JNIEXPORT void JNICALL Java_com_phidget22_PhidgetBase_setDeviceLabel(JNIEnv * env, jobject obj, jstring deviceLabel) {
	PhidgetHandle h = (PhidgetHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	const char *deviceLabelUTFChars = (deviceLabel == NULL ? NULL : (*env)->GetStringUTFChars(env, deviceLabel, NULL));
	ret = Phidget_setDeviceLabel(h, (const char *)deviceLabelUTFChars);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		if (deviceLabelUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, deviceLabel, deviceLabelUTFChars);
		return;
	}
	if (deviceLabelUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, deviceLabel, deviceLabelUTFChars);
}

JNIEXPORT jstring JNICALL Java_com_phidget22_PhidgetBase_getDeviceName(JNIEnv * env, jobject obj) {
	PhidgetHandle h = (PhidgetHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	const char * deviceName;
	ret = Phidget_getDeviceName(h, &deviceName);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return NULL;
	}
	return (*env)->NewStringUTF(env, deviceName);
}

JNIEXPORT jint JNICALL Java_com_phidget22_PhidgetBase_getDeviceSerialNumber(JNIEnv * env, jobject obj) {
	PhidgetHandle h = (PhidgetHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	int32_t deviceSerialNumber;
	ret = Phidget_getDeviceSerialNumber(h, &deviceSerialNumber);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return deviceSerialNumber;
	}
	return deviceSerialNumber;
}

JNIEXPORT void JNICALL Java_com_phidget22_PhidgetBase_setDeviceSerialNumber(JNIEnv * env, jobject obj, jint deviceSerialNumber) {
	PhidgetHandle h = (PhidgetHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = Phidget_setDeviceSerialNumber(h, (int32_t)deviceSerialNumber);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jstring JNICALL Java_com_phidget22_PhidgetBase_getDeviceSKU(JNIEnv * env, jobject obj) {
	PhidgetHandle h = (PhidgetHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	const char * deviceSKU;
	ret = Phidget_getDeviceSKU(h, &deviceSKU);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return NULL;
	}
	return (*env)->NewStringUTF(env, deviceSKU);
}

JNIEXPORT jint JNICALL Java_com_phidget22_PhidgetBase_getDeviceVersion(JNIEnv * env, jobject obj) {
	PhidgetHandle h = (PhidgetHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	int deviceVersion;
	ret = Phidget_getDeviceVersion(h, &deviceVersion);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return deviceVersion;
	}
	return deviceVersion;
}

JNIEXPORT jint JNICALL Java_com_phidget22_PhidgetBase_getHubPort(JNIEnv * env, jobject obj) {
	PhidgetHandle h = (PhidgetHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	int hubPort;
	ret = Phidget_getHubPort(h, &hubPort);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return hubPort;
	}
	return hubPort;
}

JNIEXPORT void JNICALL Java_com_phidget22_PhidgetBase_setHubPort(JNIEnv * env, jobject obj, jint hubPort) {
	PhidgetHandle h = (PhidgetHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = Phidget_setHubPort(h, (int)hubPort);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jint JNICALL Java_com_phidget22_PhidgetBase_getHubPortCount(JNIEnv * env, jobject obj) {
	PhidgetHandle h = (PhidgetHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	int hubPortCount;
	ret = Phidget_getHubPortCount(h, &hubPortCount);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return hubPortCount;
	}
	return hubPortCount;
}

JNIEXPORT jint JNICALL Java_com_phidget22_PhidgetBase_getHubPortSpeed(JNIEnv * env, jobject obj) {
	PhidgetHandle h = (PhidgetHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t hubPortSpeed;
	ret = Phidget_getHubPortSpeed(h, &hubPortSpeed);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return hubPortSpeed;
	}
	return hubPortSpeed;
}

JNIEXPORT void JNICALL Java_com_phidget22_PhidgetBase_setHubPortSpeed(JNIEnv * env, jobject obj, jint hubPortSpeed) {
	PhidgetHandle h = (PhidgetHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = Phidget_setHubPortSpeed(h, (uint32_t)hubPortSpeed);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jint JNICALL Java_com_phidget22_PhidgetBase_getMaxHubPortSpeed(JNIEnv * env, jobject obj) {
	PhidgetHandle h = (PhidgetHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t maxHubPortSpeed;
	ret = Phidget_getMaxHubPortSpeed(h, &maxHubPortSpeed);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxHubPortSpeed;
	}
	return maxHubPortSpeed;
}

JNIEXPORT jboolean JNICALL Java_com_phidget22_PhidgetBase_getHubPortSupportsAutoSetSpeed(JNIEnv * env, jobject obj) {
	PhidgetHandle h = (PhidgetHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	int hubPortSupportsAutoSetSpeed;
	ret = Phidget_getHubPortSupportsAutoSetSpeed(h, &hubPortSupportsAutoSetSpeed);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return hubPortSupportsAutoSetSpeed;
	}
	return hubPortSupportsAutoSetSpeed;
}

JNIEXPORT jboolean JNICALL Java_com_phidget22_PhidgetBase_getHubPortSupportsSetSpeed(JNIEnv * env, jobject obj) {
	PhidgetHandle h = (PhidgetHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	int hubPortSupportsSetSpeed;
	ret = Phidget_getHubPortSupportsSetSpeed(h, &hubPortSupportsSetSpeed);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return hubPortSupportsSetSpeed;
	}
	return hubPortSupportsSetSpeed;
}

JNIEXPORT jboolean JNICALL Java_com_phidget22_PhidgetBase_getIsChannel(JNIEnv * env, jobject obj) {
	PhidgetHandle h = (PhidgetHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	int isChannel;
	ret = Phidget_getIsChannel(h, &isChannel);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return isChannel;
	}
	return isChannel;
}

JNIEXPORT jboolean JNICALL Java_com_phidget22_PhidgetBase_getIsHubPortDevice(JNIEnv * env, jobject obj) {
	PhidgetHandle h = (PhidgetHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	int isHubPortDevice;
	ret = Phidget_getIsHubPortDevice(h, &isHubPortDevice);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return isHubPortDevice;
	}
	return isHubPortDevice;
}

JNIEXPORT void JNICALL Java_com_phidget22_PhidgetBase_setIsHubPortDevice(JNIEnv * env, jobject obj, jboolean isHubPortDevice) {
	PhidgetHandle h = (PhidgetHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = Phidget_setIsHubPortDevice(h, (int)isHubPortDevice);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jboolean JNICALL Java_com_phidget22_PhidgetBase_getIsLocal(JNIEnv * env, jobject obj) {
	PhidgetHandle h = (PhidgetHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	int isLocal;
	ret = Phidget_getIsLocal(h, &isLocal);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return isLocal;
	}
	return isLocal;
}

JNIEXPORT void JNICALL Java_com_phidget22_PhidgetBase_setIsLocal(JNIEnv * env, jobject obj, jboolean isLocal) {
	PhidgetHandle h = (PhidgetHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = Phidget_setIsLocal(h, (int)isLocal);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jboolean JNICALL Java_com_phidget22_PhidgetBase_getIsOpen(JNIEnv * env, jobject obj) {
	PhidgetHandle h = (PhidgetHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	int isOpen;
	ret = Phidget_getIsOpen(h, &isOpen);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return isOpen;
	}
	return isOpen;
}

JNIEXPORT jboolean JNICALL Java_com_phidget22_PhidgetBase_getIsRemote(JNIEnv * env, jobject obj) {
	PhidgetHandle h = (PhidgetHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	int isRemote;
	ret = Phidget_getIsRemote(h, &isRemote);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return isRemote;
	}
	return isRemote;
}

JNIEXPORT void JNICALL Java_com_phidget22_PhidgetBase_setIsRemote(JNIEnv * env, jobject obj, jboolean isRemote) {
	PhidgetHandle h = (PhidgetHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = Phidget_setIsRemote(h, (int)isRemote);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_PhidgetBase_open__(JNIEnv * env, jobject obj) {
	PhidgetHandle h = (PhidgetHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = Phidget_open(h);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_PhidgetBase_open__I(JNIEnv * env, jobject obj, jint timeout) {
	PhidgetHandle h = (PhidgetHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = Phidget_openWaitForAttachment(h, (uint32_t)timeout);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jstring JNICALL Java_com_phidget22_PhidgetBase_getServerHostname(JNIEnv * env, jobject obj) {
	PhidgetHandle h = (PhidgetHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	const char * serverHostname;
	ret = Phidget_getServerHostname(h, &serverHostname);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return NULL;
	}
	return (*env)->NewStringUTF(env, serverHostname);
}

JNIEXPORT jstring JNICALL Java_com_phidget22_PhidgetBase_getServerName(JNIEnv * env, jobject obj) {
	PhidgetHandle h = (PhidgetHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	const char * serverName;
	ret = Phidget_getServerName(h, &serverName);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return NULL;
	}
	return (*env)->NewStringUTF(env, serverName);
}

JNIEXPORT void JNICALL Java_com_phidget22_PhidgetBase_setServerName(JNIEnv * env, jobject obj, jstring serverName) {
	PhidgetHandle h = (PhidgetHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	const char *serverNameUTFChars = (serverName == NULL ? NULL : (*env)->GetStringUTFChars(env, serverName, NULL));
	ret = Phidget_setServerName(h, (const char *)serverNameUTFChars);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		if (serverNameUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, serverName, serverNameUTFChars);
		return;
	}
	if (serverNameUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, serverName, serverNameUTFChars);
}

JNIEXPORT jstring JNICALL Java_com_phidget22_PhidgetBase_getServerPeerName(JNIEnv * env, jobject obj) {
	PhidgetHandle h = (PhidgetHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	const char * serverPeerName;
	ret = Phidget_getServerPeerName(h, &serverPeerName);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return NULL;
	}
	return (*env)->NewStringUTF(env, serverPeerName);
}

JNIEXPORT jstring JNICALL Java_com_phidget22_PhidgetBase_getServerUniqueName(JNIEnv * env, jobject obj) {
	PhidgetHandle h = (PhidgetHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	const char * serverUniqueName;
	ret = Phidget_getServerUniqueName(h, &serverUniqueName);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return NULL;
	}
	return (*env)->NewStringUTF(env, serverUniqueName);
}

JNIEXPORT jint JNICALL Java_com_phidget22_PhidgetBase_getMaxVINTDeviceSpeed(JNIEnv * env, jobject obj) {
	PhidgetHandle h = (PhidgetHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t maxVINTDeviceSpeed;
	ret = Phidget_getMaxVINTDeviceSpeed(h, &maxVINTDeviceSpeed);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxVINTDeviceSpeed;
	}
	return maxVINTDeviceSpeed;
}

JNIEXPORT jboolean JNICALL Java_com_phidget22_PhidgetBase_getVINTDeviceSupportsAutoSetSpeed(JNIEnv * env, jobject obj) {
	PhidgetHandle h = (PhidgetHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	int VINTDeviceSupportsAutoSetSpeed;
	ret = Phidget_getVINTDeviceSupportsAutoSetSpeed(h, &VINTDeviceSupportsAutoSetSpeed);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return VINTDeviceSupportsAutoSetSpeed;
	}
	return VINTDeviceSupportsAutoSetSpeed;
}

JNIEXPORT jboolean JNICALL Java_com_phidget22_PhidgetBase_getVINTDeviceSupportsSetSpeed(JNIEnv * env, jobject obj) {
	PhidgetHandle h = (PhidgetHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	int VINTDeviceSupportsSetSpeed;
	ret = Phidget_getVINTDeviceSupportsSetSpeed(h, &VINTDeviceSupportsSetSpeed);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return VINTDeviceSupportsSetSpeed;
	}
	return VINTDeviceSupportsSetSpeed;
}

JNIEXPORT void JNICALL Java_com_phidget22_PhidgetBase_writeDeviceLabel(JNIEnv * env, jobject obj, jstring deviceLabel) {
	PhidgetHandle h = (PhidgetHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	const char *deviceLabelUTFChars = (deviceLabel == NULL ? NULL : (*env)->GetStringUTFChars(env, deviceLabel, NULL));
	ret = Phidget_writeDeviceLabel(h, (const char *)deviceLabelUTFChars);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		if (deviceLabelUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, deviceLabel, deviceLabelUTFChars);
		return;
	}
	if (deviceLabelUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, deviceLabel, deviceLabelUTFChars);
}

static void CCONV attach_handler(PhidgetHandle h, void *arg) {
	jobject attachEv;
	JNIEnv *env;
	jobject obj;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;

	if ((attachEv = (*env)->NewObject(env, attachEvent_class, attachEvent_cons, obj)) != 0) {
		(*env)->CallVoidMethod(env, obj, fireAttach_mid, attachEv);
		(*env)->DeleteLocalRef(env, attachEv);
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_PhidgetBase_enableAttachEvents(JNIEnv * env, jobject obj, jboolean b) {
	if (attachEvent_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/AttachEvent");
	jlong gr = updateGlobalRef(env, obj, nativeAttachHandler_fid, b);
	PhidgetHandle h = (PhidgetHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	Phidget_setOnAttachHandler(h, b ? attach_handler : NULL, (void *)(uintptr_t) gr);
}

static void CCONV detach_handler(PhidgetHandle h, void *arg) {
	jobject detachEv;
	JNIEnv *env;
	jobject obj;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;

	if ((detachEv = (*env)->NewObject(env, detachEvent_class, detachEvent_cons, obj)) != 0) {
		(*env)->CallVoidMethod(env, obj, fireDetach_mid, detachEv);
		(*env)->DeleteLocalRef(env, detachEv);
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_PhidgetBase_enableDetachEvents(JNIEnv * env, jobject obj, jboolean b) {
	if (detachEvent_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/DetachEvent");
	jlong gr = updateGlobalRef(env, obj, nativeDetachHandler_fid, b);
	PhidgetHandle h = (PhidgetHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	Phidget_setOnDetachHandler(h, b ? detach_handler : NULL, (void *)(uintptr_t) gr);
}

static void CCONV error_handler(PhidgetHandle h, void *arg, Phidget_ErrorEventCode code, const char * description) {
	jobject errorEv;
	JNIEnv *env;
	jobject obj;
	jobject codeEnum;
	jstring descriptionStr;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;
	if (ErrorEventCode_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/ErrorEventCode");
	codeEnum = (*env)->CallStaticObjectMethod(env, ErrorEventCode_class, ErrorEventCode_getEnum_mid, code);
	descriptionStr = (*env)->NewStringUTF(env, description);

	if ((errorEv = (*env)->NewObject(env, errorEvent_class, errorEvent_cons, obj, codeEnum, descriptionStr)) != 0) {
		(*env)->CallVoidMethod(env, obj, fireError_mid, errorEv);
		(*env)->DeleteLocalRef(env, errorEv);
	}
	(*env)->DeleteLocalRef(env, codeEnum);
	(*env)->DeleteLocalRef(env, descriptionStr);
}

JNIEXPORT void JNICALL Java_com_phidget22_PhidgetBase_enableErrorEvents(JNIEnv * env, jobject obj, jboolean b) {
	if (errorEvent_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/ErrorEvent");
	jlong gr = updateGlobalRef(env, obj, nativeErrorHandler_fid, b);
	PhidgetHandle h = (PhidgetHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	Phidget_setOnErrorHandler(h, b ? error_handler : NULL, (void *)(uintptr_t) gr);
}

static void CCONV propertyChange_handler(PhidgetHandle h, void *arg, const char * propertyName) {
	jobject propertyChangeEv;
	JNIEnv *env;
	jobject obj;
	jstring propertyNameStr;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;
	propertyNameStr = (*env)->NewStringUTF(env, propertyName);

	if ((propertyChangeEv = (*env)->NewObject(env, propertyChangeEvent_class, propertyChangeEvent_cons, obj, propertyNameStr)) != 0) {
		(*env)->CallVoidMethod(env, obj, firePropertyChange_mid, propertyChangeEv);
		(*env)->DeleteLocalRef(env, propertyChangeEv);
	}
	(*env)->DeleteLocalRef(env, propertyNameStr);
}

JNIEXPORT void JNICALL Java_com_phidget22_PhidgetBase_enablePropertyChangeEvents(JNIEnv * env, jobject obj, jboolean b) {
	if (propertyChangeEvent_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/PropertyChangeEvent");
	jlong gr = updateGlobalRef(env, obj, nativePropertyChangeHandler_fid, b);
	PhidgetHandle h = (PhidgetHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	Phidget_setOnPropertyChangeHandler(h, b ? propertyChange_handler : NULL, (void *)(uintptr_t) gr);
}
