/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of libphidget22java
 *
 * Copyright (c) 2017-2022 Phidgets Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

#include "phidget_jni.h"
#include "com_phidget22_PowerGuardBase.h"

static jclass powerGuardbase_class;
jclass powerGuard_class;
jmethodID powerGuard_cons;

void com_phidget22_PowerGuardBase_OnLoad(JNIEnv *env) {
	if (!(powerGuard_class = (*env)->FindClass(env, "com/phidget22/PowerGuard"))) {
		(*env)->ExceptionClear(env);
		return;
	}
	if (!(powerGuard_class = (jclass)(*env)->NewGlobalRef(env, powerGuard_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef powerGuard_class");
	if (!(powerGuard_cons = (*env)->GetMethodID(env, powerGuard_class, "<init>", "(J)V")))
		JNI_ABORT_STDERR("Couldn't get Method ID <init> from powerGuard_class");

	if (!(powerGuardbase_class = (*env)->FindClass(env, "com/phidget22/PowerGuardBase")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/PowerGuardBase");
	if (!(powerGuardbase_class = (jclass)(*env)->NewGlobalRef(env, powerGuardbase_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef powerGuardbase_class");
}
JNIEXPORT jlong JNICALL Java_com_phidget22_PowerGuardBase_create(JNIEnv * env, jclass obj) {
	PhidgetPowerGuardHandle phid;
	int error; 
	if ((error = PhidgetPowerGuard_create(&phid)) != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(error);
		return 0;
	}
	return (jlong)(uintptr_t)phid;
}

JNIEXPORT void JNICALL Java_com_phidget22_PowerGuardBase_enableFailsafe(JNIEnv * env, jobject obj, jint failsafeTime) {
	PhidgetPowerGuardHandle h = (PhidgetPowerGuardHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetPowerGuard_enableFailsafe(h, (uint32_t)failsafeTime);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jint JNICALL Java_com_phidget22_PowerGuardBase_getMinFailsafeTime(JNIEnv * env, jobject obj) {
	PhidgetPowerGuardHandle h = (PhidgetPowerGuardHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t minFailsafeTime;
	ret = PhidgetPowerGuard_getMinFailsafeTime(h, &minFailsafeTime);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minFailsafeTime;
	}
	return minFailsafeTime;
}

JNIEXPORT jint JNICALL Java_com_phidget22_PowerGuardBase_getMaxFailsafeTime(JNIEnv * env, jobject obj) {
	PhidgetPowerGuardHandle h = (PhidgetPowerGuardHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t maxFailsafeTime;
	ret = PhidgetPowerGuard_getMaxFailsafeTime(h, &maxFailsafeTime);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxFailsafeTime;
	}
	return maxFailsafeTime;
}

JNIEXPORT jobject JNICALL Java_com_phidget22_PowerGuardBase_getFanMode(JNIEnv * env, jobject obj) {
	PhidgetPowerGuardHandle h = (PhidgetPowerGuardHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	Phidget_FanMode fanMode;
	if (FanMode_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/FanMode");
	ret = PhidgetPowerGuard_getFanMode(h, &fanMode);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return NULL;
	}
	return (*env)->CallStaticObjectMethod(env, FanMode_class, FanMode_getEnum_mid, fanMode);
}

JNIEXPORT void JNICALL Java_com_phidget22_PowerGuardBase_setFanMode(JNIEnv * env, jobject obj, jobject fanMode) {
	PhidgetPowerGuardHandle h = (PhidgetPowerGuardHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	if (FanMode_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/FanMode");
	ret = PhidgetPowerGuard_setFanMode(h, (Phidget_FanMode)(*env)->CallIntMethod(env, fanMode, FanMode_getCode_mid));
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_PowerGuardBase_getOverVoltage(JNIEnv * env, jobject obj) {
	PhidgetPowerGuardHandle h = (PhidgetPowerGuardHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double overVoltage;
	ret = PhidgetPowerGuard_getOverVoltage(h, &overVoltage);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return overVoltage;
	}
	return overVoltage;
}

JNIEXPORT void JNICALL Java_com_phidget22_PowerGuardBase_setOverVoltage(JNIEnv * env, jobject obj, jdouble overVoltage) {
	PhidgetPowerGuardHandle h = (PhidgetPowerGuardHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetPowerGuard_setOverVoltage(h, (double)overVoltage);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_PowerGuardBase_getMinOverVoltage(JNIEnv * env, jobject obj) {
	PhidgetPowerGuardHandle h = (PhidgetPowerGuardHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minOverVoltage;
	ret = PhidgetPowerGuard_getMinOverVoltage(h, &minOverVoltage);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minOverVoltage;
	}
	return minOverVoltage;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_PowerGuardBase_getMaxOverVoltage(JNIEnv * env, jobject obj) {
	PhidgetPowerGuardHandle h = (PhidgetPowerGuardHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxOverVoltage;
	ret = PhidgetPowerGuard_getMaxOverVoltage(h, &maxOverVoltage);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxOverVoltage;
	}
	return maxOverVoltage;
}

JNIEXPORT jboolean JNICALL Java_com_phidget22_PowerGuardBase_getPowerEnabled(JNIEnv * env, jobject obj) {
	PhidgetPowerGuardHandle h = (PhidgetPowerGuardHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	int powerEnabled;
	ret = PhidgetPowerGuard_getPowerEnabled(h, &powerEnabled);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return powerEnabled;
	}
	return powerEnabled;
}

JNIEXPORT void JNICALL Java_com_phidget22_PowerGuardBase_setPowerEnabled(JNIEnv * env, jobject obj, jboolean powerEnabled) {
	PhidgetPowerGuardHandle h = (PhidgetPowerGuardHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetPowerGuard_setPowerEnabled(h, (int)powerEnabled);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_PowerGuardBase_resetFailsafe(JNIEnv * env, jobject obj) {
	PhidgetPowerGuardHandle h = (PhidgetPowerGuardHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetPowerGuard_resetFailsafe(h);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}
