/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of libphidget22java
 *
 * Copyright (c) 2017-2022 Phidgets Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

#include "phidget_jni.h"
#include "com_phidget22_PressureSensorBase.h"

static jclass pressureSensorbase_class;
jclass pressureSensor_class;
jmethodID pressureSensor_cons;

static jclass pressureChangeEvent_class;
static jmethodID firePressureChange_mid	;
static jmethodID pressureChangeEvent_cons;
static jfieldID nativePressureChangeHandler_fid;

void com_phidget22_PressureSensorBase_OnLoad(JNIEnv *env) {
	if (!(pressureSensor_class = (*env)->FindClass(env, "com/phidget22/PressureSensor"))) {
		(*env)->ExceptionClear(env);
		return;
	}
	if (!(pressureSensor_class = (jclass)(*env)->NewGlobalRef(env, pressureSensor_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef pressureSensor_class");
	if (!(pressureSensor_cons = (*env)->GetMethodID(env, pressureSensor_class, "<init>", "(J)V")))
		JNI_ABORT_STDERR("Couldn't get Method ID <init> from pressureSensor_class");

	if (!(pressureSensorbase_class = (*env)->FindClass(env, "com/phidget22/PressureSensorBase")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/PressureSensorBase");
	if (!(pressureSensorbase_class = (jclass)(*env)->NewGlobalRef(env, pressureSensorbase_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef pressureSensorbase_class");

	if ((pressureChangeEvent_class = (*env)->FindClass(env, "com/phidget22/PressureSensorPressureChangeEvent"))) {
		if (!(pressureChangeEvent_class = (jclass)(*env)->NewGlobalRef(env, pressureChangeEvent_class)))
			JNI_ABORT_STDERR("Couldn't create global ref PressureChangeEvent_class");
		if (!(firePressureChange_mid = (*env)->GetMethodID(env, pressureSensorbase_class, "firePressureChange", "(Lcom/phidget22/PressureSensorPressureChangeEvent;)V")))
			JNI_ABORT_STDERR("Couldn't get method ID firePressureChange");
		if (!(pressureChangeEvent_cons = (*env)->GetMethodID(env, pressureChangeEvent_class, "<init>", "(Lcom/phidget22/PressureSensor;D)V")))
			JNI_ABORT_STDERR("Couldn't get method ID <init> from PressureChangeEvent_class");
		if (!(nativePressureChangeHandler_fid = (*env)->GetFieldID(env, pressureSensorbase_class, "nativePressureChangeHandler", "J")))
			JNI_ABORT_STDERR("Couldn't get Field ID nativePressureChangeHandler from pressureSensorbase_class");
	} else {
		(*env)->ExceptionClear(env);
	}
}
JNIEXPORT jlong JNICALL Java_com_phidget22_PressureSensorBase_create(JNIEnv * env, jclass obj) {
	PhidgetPressureSensorHandle phid;
	int error; 
	if ((error = PhidgetPressureSensor_create(&phid)) != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(error);
		return 0;
	}
	return (jlong)(uintptr_t)phid;
}

JNIEXPORT jint JNICALL Java_com_phidget22_PressureSensorBase_getDataInterval(JNIEnv * env, jobject obj) {
	PhidgetPressureSensorHandle h = (PhidgetPressureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t dataInterval;
	ret = PhidgetPressureSensor_getDataInterval(h, &dataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return dataInterval;
	}
	return dataInterval;
}

JNIEXPORT void JNICALL Java_com_phidget22_PressureSensorBase_setDataInterval(JNIEnv * env, jobject obj, jint dataInterval) {
	PhidgetPressureSensorHandle h = (PhidgetPressureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetPressureSensor_setDataInterval(h, (uint32_t)dataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jint JNICALL Java_com_phidget22_PressureSensorBase_getMinDataInterval(JNIEnv * env, jobject obj) {
	PhidgetPressureSensorHandle h = (PhidgetPressureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t minDataInterval;
	ret = PhidgetPressureSensor_getMinDataInterval(h, &minDataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minDataInterval;
	}
	return minDataInterval;
}

JNIEXPORT jint JNICALL Java_com_phidget22_PressureSensorBase_getMaxDataInterval(JNIEnv * env, jobject obj) {
	PhidgetPressureSensorHandle h = (PhidgetPressureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t maxDataInterval;
	ret = PhidgetPressureSensor_getMaxDataInterval(h, &maxDataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxDataInterval;
	}
	return maxDataInterval;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_PressureSensorBase_getDataRate(JNIEnv * env, jobject obj) {
	PhidgetPressureSensorHandle h = (PhidgetPressureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double dataRate;
	ret = PhidgetPressureSensor_getDataRate(h, &dataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return dataRate;
	}
	return dataRate;
}

JNIEXPORT void JNICALL Java_com_phidget22_PressureSensorBase_setDataRate(JNIEnv * env, jobject obj, jdouble dataRate) {
	PhidgetPressureSensorHandle h = (PhidgetPressureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetPressureSensor_setDataRate(h, (double)dataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_PressureSensorBase_getMinDataRate(JNIEnv * env, jobject obj) {
	PhidgetPressureSensorHandle h = (PhidgetPressureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minDataRate;
	ret = PhidgetPressureSensor_getMinDataRate(h, &minDataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minDataRate;
	}
	return minDataRate;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_PressureSensorBase_getMaxDataRate(JNIEnv * env, jobject obj) {
	PhidgetPressureSensorHandle h = (PhidgetPressureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxDataRate;
	ret = PhidgetPressureSensor_getMaxDataRate(h, &maxDataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxDataRate;
	}
	return maxDataRate;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_PressureSensorBase_getPressure(JNIEnv * env, jobject obj) {
	PhidgetPressureSensorHandle h = (PhidgetPressureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double pressure;
	ret = PhidgetPressureSensor_getPressure(h, &pressure);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return pressure;
	}
	return pressure;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_PressureSensorBase_getMinPressure(JNIEnv * env, jobject obj) {
	PhidgetPressureSensorHandle h = (PhidgetPressureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minPressure;
	ret = PhidgetPressureSensor_getMinPressure(h, &minPressure);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minPressure;
	}
	return minPressure;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_PressureSensorBase_getMaxPressure(JNIEnv * env, jobject obj) {
	PhidgetPressureSensorHandle h = (PhidgetPressureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxPressure;
	ret = PhidgetPressureSensor_getMaxPressure(h, &maxPressure);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxPressure;
	}
	return maxPressure;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_PressureSensorBase_getPressureChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetPressureSensorHandle h = (PhidgetPressureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double pressureChangeTrigger;
	ret = PhidgetPressureSensor_getPressureChangeTrigger(h, &pressureChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return pressureChangeTrigger;
	}
	return pressureChangeTrigger;
}

JNIEXPORT void JNICALL Java_com_phidget22_PressureSensorBase_setPressureChangeTrigger(JNIEnv * env, jobject obj, jdouble pressureChangeTrigger) {
	PhidgetPressureSensorHandle h = (PhidgetPressureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetPressureSensor_setPressureChangeTrigger(h, (double)pressureChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_PressureSensorBase_getMinPressureChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetPressureSensorHandle h = (PhidgetPressureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minPressureChangeTrigger;
	ret = PhidgetPressureSensor_getMinPressureChangeTrigger(h, &minPressureChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minPressureChangeTrigger;
	}
	return minPressureChangeTrigger;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_PressureSensorBase_getMaxPressureChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetPressureSensorHandle h = (PhidgetPressureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxPressureChangeTrigger;
	ret = PhidgetPressureSensor_getMaxPressureChangeTrigger(h, &maxPressureChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxPressureChangeTrigger;
	}
	return maxPressureChangeTrigger;
}

static void CCONV pressureChange_handler(PhidgetPressureSensorHandle h, void *arg, double pressure) {
	jobject pressureChangeEv;
	JNIEnv *env;
	jobject obj;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;

	if ((pressureChangeEv = (*env)->NewObject(env, pressureChangeEvent_class, pressureChangeEvent_cons, obj, pressure)) != 0) {
		(*env)->CallVoidMethod(env, obj, firePressureChange_mid, pressureChangeEv);
		(*env)->DeleteLocalRef(env, pressureChangeEv);
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_PressureSensorBase_enablePressureChangeEvents(JNIEnv * env, jobject obj, jboolean b) {
	if (pressureChangeEvent_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/PressureSensorPressureChangeEvent");
	jlong gr = updateGlobalRef(env, obj, nativePressureChangeHandler_fid, b);
	PhidgetPressureSensorHandle h = (PhidgetPressureSensorHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetPressureSensor_setOnPressureChangeHandler(h, b ? pressureChange_handler : NULL, (void *)(uintptr_t) gr);
}
