/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of libphidget22java
 *
 * Copyright (c) 2017-2022 Phidgets Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

#include "phidget_jni.h"
#include "com_phidget22_ResistanceInputBase.h"

static jclass resistanceInputbase_class;
jclass resistanceInput_class;
jmethodID resistanceInput_cons;

static jclass resistanceChangeEvent_class;
static jmethodID fireResistanceChange_mid	;
static jmethodID resistanceChangeEvent_cons;
static jfieldID nativeResistanceChangeHandler_fid;

void com_phidget22_ResistanceInputBase_OnLoad(JNIEnv *env) {
	if (!(resistanceInput_class = (*env)->FindClass(env, "com/phidget22/ResistanceInput"))) {
		(*env)->ExceptionClear(env);
		return;
	}
	if (!(resistanceInput_class = (jclass)(*env)->NewGlobalRef(env, resistanceInput_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef resistanceInput_class");
	if (!(resistanceInput_cons = (*env)->GetMethodID(env, resistanceInput_class, "<init>", "(J)V")))
		JNI_ABORT_STDERR("Couldn't get Method ID <init> from resistanceInput_class");

	if (!(resistanceInputbase_class = (*env)->FindClass(env, "com/phidget22/ResistanceInputBase")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/ResistanceInputBase");
	if (!(resistanceInputbase_class = (jclass)(*env)->NewGlobalRef(env, resistanceInputbase_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef resistanceInputbase_class");

	if ((resistanceChangeEvent_class = (*env)->FindClass(env, "com/phidget22/ResistanceInputResistanceChangeEvent"))) {
		if (!(resistanceChangeEvent_class = (jclass)(*env)->NewGlobalRef(env, resistanceChangeEvent_class)))
			JNI_ABORT_STDERR("Couldn't create global ref ResistanceChangeEvent_class");
		if (!(fireResistanceChange_mid = (*env)->GetMethodID(env, resistanceInputbase_class, "fireResistanceChange", "(Lcom/phidget22/ResistanceInputResistanceChangeEvent;)V")))
			JNI_ABORT_STDERR("Couldn't get method ID fireResistanceChange");
		if (!(resistanceChangeEvent_cons = (*env)->GetMethodID(env, resistanceChangeEvent_class, "<init>", "(Lcom/phidget22/ResistanceInput;D)V")))
			JNI_ABORT_STDERR("Couldn't get method ID <init> from ResistanceChangeEvent_class");
		if (!(nativeResistanceChangeHandler_fid = (*env)->GetFieldID(env, resistanceInputbase_class, "nativeResistanceChangeHandler", "J")))
			JNI_ABORT_STDERR("Couldn't get Field ID nativeResistanceChangeHandler from resistanceInputbase_class");
	} else {
		(*env)->ExceptionClear(env);
	}
}
JNIEXPORT jlong JNICALL Java_com_phidget22_ResistanceInputBase_create(JNIEnv * env, jclass obj) {
	PhidgetResistanceInputHandle phid;
	int error; 
	if ((error = PhidgetResistanceInput_create(&phid)) != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(error);
		return 0;
	}
	return (jlong)(uintptr_t)phid;
}

JNIEXPORT jint JNICALL Java_com_phidget22_ResistanceInputBase_getDataInterval(JNIEnv * env, jobject obj) {
	PhidgetResistanceInputHandle h = (PhidgetResistanceInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t dataInterval;
	ret = PhidgetResistanceInput_getDataInterval(h, &dataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return dataInterval;
	}
	return dataInterval;
}

JNIEXPORT void JNICALL Java_com_phidget22_ResistanceInputBase_setDataInterval(JNIEnv * env, jobject obj, jint dataInterval) {
	PhidgetResistanceInputHandle h = (PhidgetResistanceInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetResistanceInput_setDataInterval(h, (uint32_t)dataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jint JNICALL Java_com_phidget22_ResistanceInputBase_getMinDataInterval(JNIEnv * env, jobject obj) {
	PhidgetResistanceInputHandle h = (PhidgetResistanceInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t minDataInterval;
	ret = PhidgetResistanceInput_getMinDataInterval(h, &minDataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minDataInterval;
	}
	return minDataInterval;
}

JNIEXPORT jint JNICALL Java_com_phidget22_ResistanceInputBase_getMaxDataInterval(JNIEnv * env, jobject obj) {
	PhidgetResistanceInputHandle h = (PhidgetResistanceInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t maxDataInterval;
	ret = PhidgetResistanceInput_getMaxDataInterval(h, &maxDataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxDataInterval;
	}
	return maxDataInterval;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_ResistanceInputBase_getDataRate(JNIEnv * env, jobject obj) {
	PhidgetResistanceInputHandle h = (PhidgetResistanceInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double dataRate;
	ret = PhidgetResistanceInput_getDataRate(h, &dataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return dataRate;
	}
	return dataRate;
}

JNIEXPORT void JNICALL Java_com_phidget22_ResistanceInputBase_setDataRate(JNIEnv * env, jobject obj, jdouble dataRate) {
	PhidgetResistanceInputHandle h = (PhidgetResistanceInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetResistanceInput_setDataRate(h, (double)dataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_ResistanceInputBase_getMinDataRate(JNIEnv * env, jobject obj) {
	PhidgetResistanceInputHandle h = (PhidgetResistanceInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minDataRate;
	ret = PhidgetResistanceInput_getMinDataRate(h, &minDataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minDataRate;
	}
	return minDataRate;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_ResistanceInputBase_getMaxDataRate(JNIEnv * env, jobject obj) {
	PhidgetResistanceInputHandle h = (PhidgetResistanceInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxDataRate;
	ret = PhidgetResistanceInput_getMaxDataRate(h, &maxDataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxDataRate;
	}
	return maxDataRate;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_ResistanceInputBase_getResistance(JNIEnv * env, jobject obj) {
	PhidgetResistanceInputHandle h = (PhidgetResistanceInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double resistance;
	ret = PhidgetResistanceInput_getResistance(h, &resistance);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return resistance;
	}
	return resistance;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_ResistanceInputBase_getMinResistance(JNIEnv * env, jobject obj) {
	PhidgetResistanceInputHandle h = (PhidgetResistanceInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minResistance;
	ret = PhidgetResistanceInput_getMinResistance(h, &minResistance);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minResistance;
	}
	return minResistance;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_ResistanceInputBase_getMaxResistance(JNIEnv * env, jobject obj) {
	PhidgetResistanceInputHandle h = (PhidgetResistanceInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxResistance;
	ret = PhidgetResistanceInput_getMaxResistance(h, &maxResistance);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxResistance;
	}
	return maxResistance;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_ResistanceInputBase_getResistanceChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetResistanceInputHandle h = (PhidgetResistanceInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double resistanceChangeTrigger;
	ret = PhidgetResistanceInput_getResistanceChangeTrigger(h, &resistanceChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return resistanceChangeTrigger;
	}
	return resistanceChangeTrigger;
}

JNIEXPORT void JNICALL Java_com_phidget22_ResistanceInputBase_setResistanceChangeTrigger(JNIEnv * env, jobject obj, jdouble resistanceChangeTrigger) {
	PhidgetResistanceInputHandle h = (PhidgetResistanceInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetResistanceInput_setResistanceChangeTrigger(h, (double)resistanceChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_ResistanceInputBase_getMinResistanceChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetResistanceInputHandle h = (PhidgetResistanceInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minResistanceChangeTrigger;
	ret = PhidgetResistanceInput_getMinResistanceChangeTrigger(h, &minResistanceChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minResistanceChangeTrigger;
	}
	return minResistanceChangeTrigger;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_ResistanceInputBase_getMaxResistanceChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetResistanceInputHandle h = (PhidgetResistanceInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxResistanceChangeTrigger;
	ret = PhidgetResistanceInput_getMaxResistanceChangeTrigger(h, &maxResistanceChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxResistanceChangeTrigger;
	}
	return maxResistanceChangeTrigger;
}

JNIEXPORT jobject JNICALL Java_com_phidget22_ResistanceInputBase_getRTDWireSetup(JNIEnv * env, jobject obj) {
	PhidgetResistanceInputHandle h = (PhidgetResistanceInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	Phidget_RTDWireSetup RTDWireSetup;
	if (RTDWireSetup_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/RTDWireSetup");
	ret = PhidgetResistanceInput_getRTDWireSetup(h, &RTDWireSetup);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return NULL;
	}
	return (*env)->CallStaticObjectMethod(env, RTDWireSetup_class, RTDWireSetup_getEnum_mid, RTDWireSetup);
}

JNIEXPORT void JNICALL Java_com_phidget22_ResistanceInputBase_setRTDWireSetup(JNIEnv * env, jobject obj, jobject RTDWireSetup) {
	PhidgetResistanceInputHandle h = (PhidgetResistanceInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	if (RTDWireSetup_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/RTDWireSetup");
	ret = PhidgetResistanceInput_setRTDWireSetup(h, (Phidget_RTDWireSetup)(*env)->CallIntMethod(env, RTDWireSetup, RTDWireSetup_getCode_mid));
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

static void CCONV resistanceChange_handler(PhidgetResistanceInputHandle h, void *arg, double resistance) {
	jobject resistanceChangeEv;
	JNIEnv *env;
	jobject obj;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;

	if ((resistanceChangeEv = (*env)->NewObject(env, resistanceChangeEvent_class, resistanceChangeEvent_cons, obj, resistance)) != 0) {
		(*env)->CallVoidMethod(env, obj, fireResistanceChange_mid, resistanceChangeEv);
		(*env)->DeleteLocalRef(env, resistanceChangeEv);
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_ResistanceInputBase_enableResistanceChangeEvents(JNIEnv * env, jobject obj, jboolean b) {
	if (resistanceChangeEvent_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/ResistanceInputResistanceChangeEvent");
	jlong gr = updateGlobalRef(env, obj, nativeResistanceChangeHandler_fid, b);
	PhidgetResistanceInputHandle h = (PhidgetResistanceInputHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetResistanceInput_setOnResistanceChangeHandler(h, b ? resistanceChange_handler : NULL, (void *)(uintptr_t) gr);
}
