/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of libphidget22java
 *
 * Copyright (c) 2017-2022 Phidgets Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

#include "phidget_jni.h"
#include "com_phidget22_TemperatureSensorBase.h"

static jclass temperatureSensorbase_class;
jclass temperatureSensor_class;
jmethodID temperatureSensor_cons;

static jclass temperatureChangeEvent_class;
static jmethodID fireTemperatureChange_mid	;
static jmethodID temperatureChangeEvent_cons;
static jfieldID nativeTemperatureChangeHandler_fid;

void com_phidget22_TemperatureSensorBase_OnLoad(JNIEnv *env) {
	if (!(temperatureSensor_class = (*env)->FindClass(env, "com/phidget22/TemperatureSensor"))) {
		(*env)->ExceptionClear(env);
		return;
	}
	if (!(temperatureSensor_class = (jclass)(*env)->NewGlobalRef(env, temperatureSensor_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef temperatureSensor_class");
	if (!(temperatureSensor_cons = (*env)->GetMethodID(env, temperatureSensor_class, "<init>", "(J)V")))
		JNI_ABORT_STDERR("Couldn't get Method ID <init> from temperatureSensor_class");

	if (!(temperatureSensorbase_class = (*env)->FindClass(env, "com/phidget22/TemperatureSensorBase")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/TemperatureSensorBase");
	if (!(temperatureSensorbase_class = (jclass)(*env)->NewGlobalRef(env, temperatureSensorbase_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef temperatureSensorbase_class");

	if ((temperatureChangeEvent_class = (*env)->FindClass(env, "com/phidget22/TemperatureSensorTemperatureChangeEvent"))) {
		if (!(temperatureChangeEvent_class = (jclass)(*env)->NewGlobalRef(env, temperatureChangeEvent_class)))
			JNI_ABORT_STDERR("Couldn't create global ref TemperatureChangeEvent_class");
		if (!(fireTemperatureChange_mid = (*env)->GetMethodID(env, temperatureSensorbase_class, "fireTemperatureChange", "(Lcom/phidget22/TemperatureSensorTemperatureChangeEvent;)V")))
			JNI_ABORT_STDERR("Couldn't get method ID fireTemperatureChange");
		if (!(temperatureChangeEvent_cons = (*env)->GetMethodID(env, temperatureChangeEvent_class, "<init>", "(Lcom/phidget22/TemperatureSensor;D)V")))
			JNI_ABORT_STDERR("Couldn't get method ID <init> from TemperatureChangeEvent_class");
		if (!(nativeTemperatureChangeHandler_fid = (*env)->GetFieldID(env, temperatureSensorbase_class, "nativeTemperatureChangeHandler", "J")))
			JNI_ABORT_STDERR("Couldn't get Field ID nativeTemperatureChangeHandler from temperatureSensorbase_class");
	} else {
		(*env)->ExceptionClear(env);
	}
}
JNIEXPORT jlong JNICALL Java_com_phidget22_TemperatureSensorBase_create(JNIEnv * env, jclass obj) {
	PhidgetTemperatureSensorHandle phid;
	int error; 
	if ((error = PhidgetTemperatureSensor_create(&phid)) != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(error);
		return 0;
	}
	return (jlong)(uintptr_t)phid;
}

JNIEXPORT jint JNICALL Java_com_phidget22_TemperatureSensorBase_getDataInterval(JNIEnv * env, jobject obj) {
	PhidgetTemperatureSensorHandle h = (PhidgetTemperatureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t dataInterval;
	ret = PhidgetTemperatureSensor_getDataInterval(h, &dataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return dataInterval;
	}
	return dataInterval;
}

JNIEXPORT void JNICALL Java_com_phidget22_TemperatureSensorBase_setDataInterval(JNIEnv * env, jobject obj, jint dataInterval) {
	PhidgetTemperatureSensorHandle h = (PhidgetTemperatureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetTemperatureSensor_setDataInterval(h, (uint32_t)dataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jint JNICALL Java_com_phidget22_TemperatureSensorBase_getMinDataInterval(JNIEnv * env, jobject obj) {
	PhidgetTemperatureSensorHandle h = (PhidgetTemperatureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t minDataInterval;
	ret = PhidgetTemperatureSensor_getMinDataInterval(h, &minDataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minDataInterval;
	}
	return minDataInterval;
}

JNIEXPORT jint JNICALL Java_com_phidget22_TemperatureSensorBase_getMaxDataInterval(JNIEnv * env, jobject obj) {
	PhidgetTemperatureSensorHandle h = (PhidgetTemperatureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t maxDataInterval;
	ret = PhidgetTemperatureSensor_getMaxDataInterval(h, &maxDataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxDataInterval;
	}
	return maxDataInterval;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_TemperatureSensorBase_getDataRate(JNIEnv * env, jobject obj) {
	PhidgetTemperatureSensorHandle h = (PhidgetTemperatureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double dataRate;
	ret = PhidgetTemperatureSensor_getDataRate(h, &dataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return dataRate;
	}
	return dataRate;
}

JNIEXPORT void JNICALL Java_com_phidget22_TemperatureSensorBase_setDataRate(JNIEnv * env, jobject obj, jdouble dataRate) {
	PhidgetTemperatureSensorHandle h = (PhidgetTemperatureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetTemperatureSensor_setDataRate(h, (double)dataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_TemperatureSensorBase_getMinDataRate(JNIEnv * env, jobject obj) {
	PhidgetTemperatureSensorHandle h = (PhidgetTemperatureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minDataRate;
	ret = PhidgetTemperatureSensor_getMinDataRate(h, &minDataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minDataRate;
	}
	return minDataRate;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_TemperatureSensorBase_getMaxDataRate(JNIEnv * env, jobject obj) {
	PhidgetTemperatureSensorHandle h = (PhidgetTemperatureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxDataRate;
	ret = PhidgetTemperatureSensor_getMaxDataRate(h, &maxDataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxDataRate;
	}
	return maxDataRate;
}

JNIEXPORT jobject JNICALL Java_com_phidget22_TemperatureSensorBase_getRTDType(JNIEnv * env, jobject obj) {
	PhidgetTemperatureSensorHandle h = (PhidgetTemperatureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	PhidgetTemperatureSensor_RTDType RTDType;
	if (RTDType_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/RTDType");
	ret = PhidgetTemperatureSensor_getRTDType(h, &RTDType);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return NULL;
	}
	return (*env)->CallStaticObjectMethod(env, RTDType_class, RTDType_getEnum_mid, RTDType);
}

JNIEXPORT void JNICALL Java_com_phidget22_TemperatureSensorBase_setRTDType(JNIEnv * env, jobject obj, jobject RTDType) {
	PhidgetTemperatureSensorHandle h = (PhidgetTemperatureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	if (RTDType_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/RTDType");
	ret = PhidgetTemperatureSensor_setRTDType(h, (PhidgetTemperatureSensor_RTDType)(*env)->CallIntMethod(env, RTDType, RTDType_getCode_mid));
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jobject JNICALL Java_com_phidget22_TemperatureSensorBase_getRTDWireSetup(JNIEnv * env, jobject obj) {
	PhidgetTemperatureSensorHandle h = (PhidgetTemperatureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	Phidget_RTDWireSetup RTDWireSetup;
	if (RTDWireSetup_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/RTDWireSetup");
	ret = PhidgetTemperatureSensor_getRTDWireSetup(h, &RTDWireSetup);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return NULL;
	}
	return (*env)->CallStaticObjectMethod(env, RTDWireSetup_class, RTDWireSetup_getEnum_mid, RTDWireSetup);
}

JNIEXPORT void JNICALL Java_com_phidget22_TemperatureSensorBase_setRTDWireSetup(JNIEnv * env, jobject obj, jobject RTDWireSetup) {
	PhidgetTemperatureSensorHandle h = (PhidgetTemperatureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	if (RTDWireSetup_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/RTDWireSetup");
	ret = PhidgetTemperatureSensor_setRTDWireSetup(h, (Phidget_RTDWireSetup)(*env)->CallIntMethod(env, RTDWireSetup, RTDWireSetup_getCode_mid));
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_TemperatureSensorBase_getTemperature(JNIEnv * env, jobject obj) {
	PhidgetTemperatureSensorHandle h = (PhidgetTemperatureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double temperature;
	ret = PhidgetTemperatureSensor_getTemperature(h, &temperature);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return temperature;
	}
	return temperature;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_TemperatureSensorBase_getMinTemperature(JNIEnv * env, jobject obj) {
	PhidgetTemperatureSensorHandle h = (PhidgetTemperatureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minTemperature;
	ret = PhidgetTemperatureSensor_getMinTemperature(h, &minTemperature);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minTemperature;
	}
	return minTemperature;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_TemperatureSensorBase_getMaxTemperature(JNIEnv * env, jobject obj) {
	PhidgetTemperatureSensorHandle h = (PhidgetTemperatureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxTemperature;
	ret = PhidgetTemperatureSensor_getMaxTemperature(h, &maxTemperature);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxTemperature;
	}
	return maxTemperature;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_TemperatureSensorBase_getTemperatureChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetTemperatureSensorHandle h = (PhidgetTemperatureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double temperatureChangeTrigger;
	ret = PhidgetTemperatureSensor_getTemperatureChangeTrigger(h, &temperatureChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return temperatureChangeTrigger;
	}
	return temperatureChangeTrigger;
}

JNIEXPORT void JNICALL Java_com_phidget22_TemperatureSensorBase_setTemperatureChangeTrigger(JNIEnv * env, jobject obj, jdouble temperatureChangeTrigger) {
	PhidgetTemperatureSensorHandle h = (PhidgetTemperatureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetTemperatureSensor_setTemperatureChangeTrigger(h, (double)temperatureChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_TemperatureSensorBase_getMinTemperatureChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetTemperatureSensorHandle h = (PhidgetTemperatureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minTemperatureChangeTrigger;
	ret = PhidgetTemperatureSensor_getMinTemperatureChangeTrigger(h, &minTemperatureChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minTemperatureChangeTrigger;
	}
	return minTemperatureChangeTrigger;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_TemperatureSensorBase_getMaxTemperatureChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetTemperatureSensorHandle h = (PhidgetTemperatureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxTemperatureChangeTrigger;
	ret = PhidgetTemperatureSensor_getMaxTemperatureChangeTrigger(h, &maxTemperatureChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxTemperatureChangeTrigger;
	}
	return maxTemperatureChangeTrigger;
}

JNIEXPORT jobject JNICALL Java_com_phidget22_TemperatureSensorBase_getThermocoupleType(JNIEnv * env, jobject obj) {
	PhidgetTemperatureSensorHandle h = (PhidgetTemperatureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	PhidgetTemperatureSensor_ThermocoupleType thermocoupleType;
	if (ThermocoupleType_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/ThermocoupleType");
	ret = PhidgetTemperatureSensor_getThermocoupleType(h, &thermocoupleType);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return NULL;
	}
	return (*env)->CallStaticObjectMethod(env, ThermocoupleType_class, ThermocoupleType_getEnum_mid, thermocoupleType);
}

JNIEXPORT void JNICALL Java_com_phidget22_TemperatureSensorBase_setThermocoupleType(JNIEnv * env, jobject obj, jobject thermocoupleType) {
	PhidgetTemperatureSensorHandle h = (PhidgetTemperatureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	if (ThermocoupleType_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/ThermocoupleType");
	ret = PhidgetTemperatureSensor_setThermocoupleType(h, (PhidgetTemperatureSensor_ThermocoupleType)(*env)->CallIntMethod(env, thermocoupleType, ThermocoupleType_getCode_mid));
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

static void CCONV temperatureChange_handler(PhidgetTemperatureSensorHandle h, void *arg, double temperature) {
	jobject temperatureChangeEv;
	JNIEnv *env;
	jobject obj;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;

	if ((temperatureChangeEv = (*env)->NewObject(env, temperatureChangeEvent_class, temperatureChangeEvent_cons, obj, temperature)) != 0) {
		(*env)->CallVoidMethod(env, obj, fireTemperatureChange_mid, temperatureChangeEv);
		(*env)->DeleteLocalRef(env, temperatureChangeEv);
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_TemperatureSensorBase_enableTemperatureChangeEvents(JNIEnv * env, jobject obj, jboolean b) {
	if (temperatureChangeEvent_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/TemperatureSensorTemperatureChangeEvent");
	jlong gr = updateGlobalRef(env, obj, nativeTemperatureChangeHandler_fid, b);
	PhidgetTemperatureSensorHandle h = (PhidgetTemperatureSensorHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetTemperatureSensor_setOnTemperatureChangeHandler(h, b ? temperatureChange_handler : NULL, (void *)(uintptr_t) gr);
}
