/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of libphidget22java
 *
 * Copyright (c) 2017-2022 Phidgets Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

#include "phidget_jni.h"
#include "com_phidget22_VoltageRatioInputBase.h"

static jclass voltageRatioInputbase_class;
jclass voltageRatioInput_class;
jmethodID voltageRatioInput_cons;

static jclass voltageRatioChangeEvent_class;
static jmethodID fireVoltageRatioChange_mid	;
static jmethodID voltageRatioChangeEvent_cons;
static jfieldID nativeVoltageRatioChangeHandler_fid;

static jclass sensorChangeEvent_class;
static jmethodID fireSensorChange_mid	;
static jmethodID sensorChangeEvent_cons;
static jfieldID nativeSensorChangeHandler_fid;

void com_phidget22_VoltageRatioInputBase_OnLoad(JNIEnv *env) {
	if (!(voltageRatioInput_class = (*env)->FindClass(env, "com/phidget22/VoltageRatioInput"))) {
		(*env)->ExceptionClear(env);
		return;
	}
	if (!(voltageRatioInput_class = (jclass)(*env)->NewGlobalRef(env, voltageRatioInput_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef voltageRatioInput_class");
	if (!(voltageRatioInput_cons = (*env)->GetMethodID(env, voltageRatioInput_class, "<init>", "(J)V")))
		JNI_ABORT_STDERR("Couldn't get Method ID <init> from voltageRatioInput_class");

	if (!(voltageRatioInputbase_class = (*env)->FindClass(env, "com/phidget22/VoltageRatioInputBase")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/VoltageRatioInputBase");
	if (!(voltageRatioInputbase_class = (jclass)(*env)->NewGlobalRef(env, voltageRatioInputbase_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef voltageRatioInputbase_class");

	if ((voltageRatioChangeEvent_class = (*env)->FindClass(env, "com/phidget22/VoltageRatioInputVoltageRatioChangeEvent"))) {
		if (!(voltageRatioChangeEvent_class = (jclass)(*env)->NewGlobalRef(env, voltageRatioChangeEvent_class)))
			JNI_ABORT_STDERR("Couldn't create global ref VoltageRatioChangeEvent_class");
		if (!(fireVoltageRatioChange_mid = (*env)->GetMethodID(env, voltageRatioInputbase_class, "fireVoltageRatioChange", "(Lcom/phidget22/VoltageRatioInputVoltageRatioChangeEvent;)V")))
			JNI_ABORT_STDERR("Couldn't get method ID fireVoltageRatioChange");
		if (!(voltageRatioChangeEvent_cons = (*env)->GetMethodID(env, voltageRatioChangeEvent_class, "<init>", "(Lcom/phidget22/VoltageRatioInput;D)V")))
			JNI_ABORT_STDERR("Couldn't get method ID <init> from VoltageRatioChangeEvent_class");
		if (!(nativeVoltageRatioChangeHandler_fid = (*env)->GetFieldID(env, voltageRatioInputbase_class, "nativeVoltageRatioChangeHandler", "J")))
			JNI_ABORT_STDERR("Couldn't get Field ID nativeVoltageRatioChangeHandler from voltageRatioInputbase_class");
	} else {
		(*env)->ExceptionClear(env);
	}

	if ((sensorChangeEvent_class = (*env)->FindClass(env, "com/phidget22/VoltageRatioInputSensorChangeEvent"))) {
		if (!(sensorChangeEvent_class = (jclass)(*env)->NewGlobalRef(env, sensorChangeEvent_class)))
			JNI_ABORT_STDERR("Couldn't create global ref SensorChangeEvent_class");
		if (!(fireSensorChange_mid = (*env)->GetMethodID(env, voltageRatioInputbase_class, "fireSensorChange", "(Lcom/phidget22/VoltageRatioInputSensorChangeEvent;)V")))
			JNI_ABORT_STDERR("Couldn't get method ID fireSensorChange");
		if (!(sensorChangeEvent_cons = (*env)->GetMethodID(env, sensorChangeEvent_class, "<init>", "(Lcom/phidget22/VoltageRatioInput;DLcom/phidget22/UnitInfo;)V")))
			JNI_ABORT_STDERR("Couldn't get method ID <init> from SensorChangeEvent_class");
		if (!(nativeSensorChangeHandler_fid = (*env)->GetFieldID(env, voltageRatioInputbase_class, "nativeSensorChangeHandler", "J")))
			JNI_ABORT_STDERR("Couldn't get Field ID nativeSensorChangeHandler from voltageRatioInputbase_class");
	} else {
		(*env)->ExceptionClear(env);
	}
}
JNIEXPORT jlong JNICALL Java_com_phidget22_VoltageRatioInputBase_create(JNIEnv * env, jclass obj) {
	PhidgetVoltageRatioInputHandle phid;
	int error; 
	if ((error = PhidgetVoltageRatioInput_create(&phid)) != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(error);
		return 0;
	}
	return (jlong)(uintptr_t)phid;
}

JNIEXPORT jboolean JNICALL Java_com_phidget22_VoltageRatioInputBase_getBridgeEnabled(JNIEnv * env, jobject obj) {
	PhidgetVoltageRatioInputHandle h = (PhidgetVoltageRatioInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	int bridgeEnabled;
	ret = PhidgetVoltageRatioInput_getBridgeEnabled(h, &bridgeEnabled);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return bridgeEnabled;
	}
	return bridgeEnabled;
}

JNIEXPORT void JNICALL Java_com_phidget22_VoltageRatioInputBase_setBridgeEnabled(JNIEnv * env, jobject obj, jboolean bridgeEnabled) {
	PhidgetVoltageRatioInputHandle h = (PhidgetVoltageRatioInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetVoltageRatioInput_setBridgeEnabled(h, (int)bridgeEnabled);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jobject JNICALL Java_com_phidget22_VoltageRatioInputBase_getBridgeGain(JNIEnv * env, jobject obj) {
	PhidgetVoltageRatioInputHandle h = (PhidgetVoltageRatioInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	PhidgetVoltageRatioInput_BridgeGain bridgeGain;
	if (BridgeGain_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/BridgeGain");
	ret = PhidgetVoltageRatioInput_getBridgeGain(h, &bridgeGain);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return NULL;
	}
	return (*env)->CallStaticObjectMethod(env, BridgeGain_class, BridgeGain_getEnum_mid, bridgeGain);
}

JNIEXPORT void JNICALL Java_com_phidget22_VoltageRatioInputBase_setBridgeGain(JNIEnv * env, jobject obj, jobject bridgeGain) {
	PhidgetVoltageRatioInputHandle h = (PhidgetVoltageRatioInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	if (BridgeGain_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/BridgeGain");
	ret = PhidgetVoltageRatioInput_setBridgeGain(h, (PhidgetVoltageRatioInput_BridgeGain)(*env)->CallIntMethod(env, bridgeGain, BridgeGain_getCode_mid));
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jint JNICALL Java_com_phidget22_VoltageRatioInputBase_getDataInterval(JNIEnv * env, jobject obj) {
	PhidgetVoltageRatioInputHandle h = (PhidgetVoltageRatioInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t dataInterval;
	ret = PhidgetVoltageRatioInput_getDataInterval(h, &dataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return dataInterval;
	}
	return dataInterval;
}

JNIEXPORT void JNICALL Java_com_phidget22_VoltageRatioInputBase_setDataInterval(JNIEnv * env, jobject obj, jint dataInterval) {
	PhidgetVoltageRatioInputHandle h = (PhidgetVoltageRatioInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetVoltageRatioInput_setDataInterval(h, (uint32_t)dataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jint JNICALL Java_com_phidget22_VoltageRatioInputBase_getMinDataInterval(JNIEnv * env, jobject obj) {
	PhidgetVoltageRatioInputHandle h = (PhidgetVoltageRatioInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t minDataInterval;
	ret = PhidgetVoltageRatioInput_getMinDataInterval(h, &minDataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minDataInterval;
	}
	return minDataInterval;
}

JNIEXPORT jint JNICALL Java_com_phidget22_VoltageRatioInputBase_getMaxDataInterval(JNIEnv * env, jobject obj) {
	PhidgetVoltageRatioInputHandle h = (PhidgetVoltageRatioInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t maxDataInterval;
	ret = PhidgetVoltageRatioInput_getMaxDataInterval(h, &maxDataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxDataInterval;
	}
	return maxDataInterval;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_VoltageRatioInputBase_getDataRate(JNIEnv * env, jobject obj) {
	PhidgetVoltageRatioInputHandle h = (PhidgetVoltageRatioInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double dataRate;
	ret = PhidgetVoltageRatioInput_getDataRate(h, &dataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return dataRate;
	}
	return dataRate;
}

JNIEXPORT void JNICALL Java_com_phidget22_VoltageRatioInputBase_setDataRate(JNIEnv * env, jobject obj, jdouble dataRate) {
	PhidgetVoltageRatioInputHandle h = (PhidgetVoltageRatioInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetVoltageRatioInput_setDataRate(h, (double)dataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_VoltageRatioInputBase_getMinDataRate(JNIEnv * env, jobject obj) {
	PhidgetVoltageRatioInputHandle h = (PhidgetVoltageRatioInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minDataRate;
	ret = PhidgetVoltageRatioInput_getMinDataRate(h, &minDataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minDataRate;
	}
	return minDataRate;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_VoltageRatioInputBase_getMaxDataRate(JNIEnv * env, jobject obj) {
	PhidgetVoltageRatioInputHandle h = (PhidgetVoltageRatioInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxDataRate;
	ret = PhidgetVoltageRatioInput_getMaxDataRate(h, &maxDataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxDataRate;
	}
	return maxDataRate;
}

JNIEXPORT jobject JNICALL Java_com_phidget22_VoltageRatioInputBase_getSensorType(JNIEnv * env, jobject obj) {
	PhidgetVoltageRatioInputHandle h = (PhidgetVoltageRatioInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	PhidgetVoltageRatioInput_SensorType sensorType;
	if (VoltageRatioSensorType_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/VoltageRatioSensorType");
	ret = PhidgetVoltageRatioInput_getSensorType(h, &sensorType);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return NULL;
	}
	return (*env)->CallStaticObjectMethod(env, VoltageRatioSensorType_class, VoltageRatioSensorType_getEnum_mid, sensorType);
}

JNIEXPORT void JNICALL Java_com_phidget22_VoltageRatioInputBase_setSensorType(JNIEnv * env, jobject obj, jobject sensorType) {
	PhidgetVoltageRatioInputHandle h = (PhidgetVoltageRatioInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	if (VoltageRatioSensorType_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/VoltageRatioSensorType");
	ret = PhidgetVoltageRatioInput_setSensorType(h, (PhidgetVoltageRatioInput_SensorType)(*env)->CallIntMethod(env, sensorType, VoltageRatioSensorType_getCode_mid));
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jobject JNICALL Java_com_phidget22_VoltageRatioInputBase_getSensorUnit(JNIEnv * env, jobject obj) {
	PhidgetVoltageRatioInputHandle h = (PhidgetVoltageRatioInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	Phidget_UnitInfo sensorUnit;
	ret = PhidgetVoltageRatioInput_getSensorUnit(h, &sensorUnit);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return NULL;
	}
	return Phidget_UnitInfo_to_jobject(env, &sensorUnit);
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_VoltageRatioInputBase_getSensorValue(JNIEnv * env, jobject obj) {
	PhidgetVoltageRatioInputHandle h = (PhidgetVoltageRatioInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double sensorValue;
	ret = PhidgetVoltageRatioInput_getSensorValue(h, &sensorValue);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return sensorValue;
	}
	return sensorValue;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_VoltageRatioInputBase_getSensorValueChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetVoltageRatioInputHandle h = (PhidgetVoltageRatioInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double sensorValueChangeTrigger;
	ret = PhidgetVoltageRatioInput_getSensorValueChangeTrigger(h, &sensorValueChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return sensorValueChangeTrigger;
	}
	return sensorValueChangeTrigger;
}

JNIEXPORT void JNICALL Java_com_phidget22_VoltageRatioInputBase_setSensorValueChangeTrigger(JNIEnv * env, jobject obj, jdouble sensorValueChangeTrigger) {
	PhidgetVoltageRatioInputHandle h = (PhidgetVoltageRatioInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetVoltageRatioInput_setSensorValueChangeTrigger(h, (double)sensorValueChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_VoltageRatioInputBase_getVoltageRatio(JNIEnv * env, jobject obj) {
	PhidgetVoltageRatioInputHandle h = (PhidgetVoltageRatioInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double voltageRatio;
	ret = PhidgetVoltageRatioInput_getVoltageRatio(h, &voltageRatio);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return voltageRatio;
	}
	return voltageRatio;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_VoltageRatioInputBase_getMinVoltageRatio(JNIEnv * env, jobject obj) {
	PhidgetVoltageRatioInputHandle h = (PhidgetVoltageRatioInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minVoltageRatio;
	ret = PhidgetVoltageRatioInput_getMinVoltageRatio(h, &minVoltageRatio);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minVoltageRatio;
	}
	return minVoltageRatio;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_VoltageRatioInputBase_getMaxVoltageRatio(JNIEnv * env, jobject obj) {
	PhidgetVoltageRatioInputHandle h = (PhidgetVoltageRatioInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxVoltageRatio;
	ret = PhidgetVoltageRatioInput_getMaxVoltageRatio(h, &maxVoltageRatio);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxVoltageRatio;
	}
	return maxVoltageRatio;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_VoltageRatioInputBase_getVoltageRatioChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetVoltageRatioInputHandle h = (PhidgetVoltageRatioInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double voltageRatioChangeTrigger;
	ret = PhidgetVoltageRatioInput_getVoltageRatioChangeTrigger(h, &voltageRatioChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return voltageRatioChangeTrigger;
	}
	return voltageRatioChangeTrigger;
}

JNIEXPORT void JNICALL Java_com_phidget22_VoltageRatioInputBase_setVoltageRatioChangeTrigger(JNIEnv * env, jobject obj, jdouble voltageRatioChangeTrigger) {
	PhidgetVoltageRatioInputHandle h = (PhidgetVoltageRatioInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetVoltageRatioInput_setVoltageRatioChangeTrigger(h, (double)voltageRatioChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_VoltageRatioInputBase_getMinVoltageRatioChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetVoltageRatioInputHandle h = (PhidgetVoltageRatioInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minVoltageRatioChangeTrigger;
	ret = PhidgetVoltageRatioInput_getMinVoltageRatioChangeTrigger(h, &minVoltageRatioChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minVoltageRatioChangeTrigger;
	}
	return minVoltageRatioChangeTrigger;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_VoltageRatioInputBase_getMaxVoltageRatioChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetVoltageRatioInputHandle h = (PhidgetVoltageRatioInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxVoltageRatioChangeTrigger;
	ret = PhidgetVoltageRatioInput_getMaxVoltageRatioChangeTrigger(h, &maxVoltageRatioChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxVoltageRatioChangeTrigger;
	}
	return maxVoltageRatioChangeTrigger;
}

static void CCONV sensorChange_handler(PhidgetVoltageRatioInputHandle h, void *arg, double sensorValue, Phidget_UnitInfo *sensorUnit) {
	jobject sensorChangeEv;
	JNIEnv *env;
	jobject obj;
	jobject sensorUnitObj;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;
	sensorUnitObj = Phidget_UnitInfo_to_jobject(env, sensorUnit);

	if ((sensorChangeEv = (*env)->NewObject(env, sensorChangeEvent_class, sensorChangeEvent_cons, obj, sensorValue, sensorUnitObj)) != 0) {
		(*env)->CallVoidMethod(env, obj, fireSensorChange_mid, sensorChangeEv);
		(*env)->DeleteLocalRef(env, sensorChangeEv);
	}
	(*env)->DeleteLocalRef(env, sensorUnitObj);
}

JNIEXPORT void JNICALL Java_com_phidget22_VoltageRatioInputBase_enableSensorChangeEvents(JNIEnv * env, jobject obj, jboolean b) {
	if (sensorChangeEvent_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/VoltageRatioInputSensorChangeEvent");
	jlong gr = updateGlobalRef(env, obj, nativeSensorChangeHandler_fid, b);
	PhidgetVoltageRatioInputHandle h = (PhidgetVoltageRatioInputHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetVoltageRatioInput_setOnSensorChangeHandler(h, b ? sensorChange_handler : NULL, (void *)(uintptr_t) gr);
}

static void CCONV voltageRatioChange_handler(PhidgetVoltageRatioInputHandle h, void *arg, double voltageRatio) {
	jobject voltageRatioChangeEv;
	JNIEnv *env;
	jobject obj;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;

	if ((voltageRatioChangeEv = (*env)->NewObject(env, voltageRatioChangeEvent_class, voltageRatioChangeEvent_cons, obj, voltageRatio)) != 0) {
		(*env)->CallVoidMethod(env, obj, fireVoltageRatioChange_mid, voltageRatioChangeEv);
		(*env)->DeleteLocalRef(env, voltageRatioChangeEv);
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_VoltageRatioInputBase_enableVoltageRatioChangeEvents(JNIEnv * env, jobject obj, jboolean b) {
	if (voltageRatioChangeEvent_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/VoltageRatioInputVoltageRatioChangeEvent");
	jlong gr = updateGlobalRef(env, obj, nativeVoltageRatioChangeHandler_fid, b);
	PhidgetVoltageRatioInputHandle h = (PhidgetVoltageRatioInputHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetVoltageRatioInput_setOnVoltageRatioChangeHandler(h, b ? voltageRatioChange_handler : NULL, (void *)(uintptr_t) gr);
}
